#Include "gl/gl.bi"
#Include "gl/glext.bi"

#Include "Inc/Log.bi"

Function glLoadFunction ( ByVal N As String, ByVal S As Integer Ptr ) As Any Ptr
	Dim R As Any Ptr
	R = ScreenGLProc ( n )
	If R Then
		Return R
	EndIf
	ErLog ( "glFunction "+Chr(34)+N+Chr(34)+" not found" )
	If S Then
		*S = -1
	EndIf
	Return 0
End Function

#Include "Inc/Music.bi"

#Undef Mat2
#Undef Mat3
#Undef Mat4
#Undef Vec2
#Undef Vec3
#Undef Vec4
#Undef RECT

#Include "Inc/Mathematics_Types.bi"
#Include "Inc/Mathematics_Functiones.bi"
#Include "Inc/Mathematics_Functiones_dos.bi"
#Include "Inc/Mathematics_Vec.bi"
#Include "Inc/Mathematics_mat.bi"
#Include "Inc/Tabelle.bi"
 
Dim Shared Config As TABELLE
Dim Shared As Integer Screen_Width, Screen_Hight, Screen_Flag

#Include "Inc/Texture.bi"
#Include "Inc/FBO.bi"
#Include "Inc/Shader.bi"
#Include "Inc/TextManager.bi"

Dim Shared Font As GUITMFONT
Dim Shared TextBlur As SHADER
Dim Shared Blur As SHADER
Dim Shared Schweif As SHADER
Dim Shared TextFBO As FBO
Dim Shared TextFBOSize As Single
Dim Shared Gamer As String
Dim Shared ShowInfo As Integer
Dim Shared WiederHole As Integer

Dim Shared MusicVol(0 To 15) As Single
Dim Shared MusicFile As String

#Include "Inc/GUI.bi"

Sub Render()
	Dim As Single _MusicVol
	Flip
	ScreenSync
	MUSIC.UpdateAll()
End Sub

#Include "Inc/Tool.bi"
#Include "Inc/Main.bi"
#Include "Inc/MainMenue.bi"

Sub INIT_GL ()
	
	Dim As String GLVersion, ShaderVersion
	GLVersion = *glGetString ( GL_VERSION )
	InLog ( "Version: "+GLVersion )
	InLog ( "Renderer: "+*glGetString ( GL_RENDERER ) )
	InLog ( "Vendor: "+*glGetString ( GL_VENDOR ) )
	
	If Val ( GLVersion ) < 2.0 Then
		ErLog ( "Version must be higher then 2.0.0" )
		ErLog ( "GL Init failed" )
		Exit Sub
	EndIf
	
	ShaderVersion = *glGetString ( GL_SHADING_LANGUAGE_VERSION_ARB )
	
	If Val ( ShaderVersion ) < 1 Then 
		ErLog ( "No Shader on this hardware" )
		ErLog ( "GL Init failed" )
		Exit Sub
	Else
		InLog ( "ShaderVersion: "+ShaderVersion )
	EndIf
	
	INIT_SHADER ()
	INIT_FBO ()
	If guitmInit (512,512) <> GUI_TM_NO_ERROR Then 
		ErLog ( "Text Manager Init failed" )
		ErLog ( "GL Init failed" )
		Exit Sub
	EndIf
	Font = guitmLoadFont ( Config.ItemS ( "FontFile" )+"Font.pff" )
	If Font = 0 Then
		ErLog ( "Font Load Failed" )
		ErLog ( "GL Init failed" )
		Exit Sub
	EndIf
	
	If ErrorDetected () Then
		ErLog ( "GL Init failed" )
	Else
		InLog ( "GL Init finished" )
	EndIf
	
End Sub
