Type TOOL
	Dll As Any Ptr
	Main As Function( ByVal As Integer, ByVal As Integer, ByVal As Integer, ByVal As Integer ) As Integer
	TTexture As TEXTURE
	Next As TOOL Ptr
End Type
Dim Shared __FirstTool__ As TOOL Ptr

Type FRAMEMOUSE
	Declare Sub Update (ByVal XX As Integer, ByVal YY As Integer, ByVal Bu As Integer)
	Frame As RECT
	X As Single
	Y As Single
	W As Integer
	B As Integer
	XA As Single
	YA As Single
	WA As Integer
	BA As Integer
	Dis As Any Ptr
	Over As Any Ptr
	entf As Single
	relptr As Integer Ptr
	MulX As Single
	MulY As Single
	Ux As Single
	Uy As Single
End Type

Sub FRAMEMOUSE.Update (ByVal XX As Integer, ByVal YY As Integer, ByVal Bu As Integer)
	Dim As Integer L,R,T,B
	This.XA = This.X
	This.YA = This.Y
	This.WA = This.W
	This.BA = This.B
	L = This.Frame.Left
	R = This.Frame.Right+This.Frame.Left
	T = This.Frame.Top
	B = This.Frame.Bottom+This.Frame.Bottom
	This.B = Bu

	This.X = (XX-L)/(R-L)
	This.Y = (YY-T)/(B-T)
	
	If This.X < 0 Or This.X > 1 Or This.Y < 0 Or This.Y > 1 Then
		This.X = This.XA
		This.Y = This.YA
	Else
		This.X *= This.MulX
		This.Y *= This.MulY
		This.X += This.Ux
		This.Y += This.Uy
		This.Ux = This.X-Int(This.X)
		This.Uy = This.Y-Int(This.Y)
		This.X=Int(This.X)
		This.Y=Int(This.Y)
	EndIf
	
End Sub

#Define TOOL_DESTROY &H00
#Define TOOL_INIT &H01
#Define TOOL_UPDATE &H02
#Define TOOL_RESET &H03
#Define TOOL_ADD &H04
#Define TOOL_SET &H05
#Define TOOL_GET &H06
#Define TOOL_PAINT_STATICS &H07
#Define TOOL_PAINT_ENABLED &H08
#Define TOOL_PAINT_SELECTS &H09
#Define TOOL_PAINL_LIGHT &H0A

#Define TOOL_MOUSEOVER_REMOVE &H01
#Define TOOL_MOUSEOVER_RESIZE &H02

Type PARTICLE
	Posi As Vec2
	PosiA As Vec2
	Vector As Vec2
	Alter As Single
	Color As Vec3
	TimeUderSpeedLimit As Single
	NoVerschub As Integer
	Next As PARTICLE Ptr
End Type

Type MAIN_TOOL
	posiX As Integer
	posiY As Integer
	radius As Integer
	grad As Integer
	light As UInteger
	r As Single
	g As Single
	b As Single
	transp As Single
	count As Single Ptr
	whatOver As Integer
	image As UInteger
End Type

Dim Shared __FirstPaticle__ As PARTICLE Ptr
Dim Shared __LastToolPaint__ As Double

Sub DrawCircle ( ByVal x As Integer, ByVal y As Integer, ByVal radius As Integer )
	glBegin(GL_TRIANGLES)
	Dim As Single P,X1,Y1,X2,Y2
	P = 360/radius
	For i As Integer = 0 To radius-1
		X1 = Sin(i*P*3.141/180)
		Y1 = cos(i*P*3.141/180)
		X2 = Sin((i+1)*P*3.141/180)
		Y2 = cos((i+1)*P*3.141/180)
		glvertex2f(X1*radius+x,Y1*radius+y)
		glvertex2f(X2*radius+x,Y2*radius+y)
		glvertex2f(x,y)
	Next
	glEnd()
End Sub

Sub DrawMiddlePlatte ( ByVal x As Integer, ByVal y As Integer, ByVal radius As Integer, ByVal t As Single )
	glBegin(GL_TRIANGLES)
	Dim As Single P,X1,Y1,X2,Y2
	P = 360/radius
	For i As Integer = 0 To radius-1
		X1 = Sin(i*P*3.141/180)
		Y1 = cos(i*P*3.141/180)
		X2 = Sin((i+1)*P*3.141/180)
		Y2 = cos((i+1)*P*3.141/180)
		glColor4f(0.7,0.7,0.7,t)
		glvertex2f(X1*radius*0.8+x,Y1*radius*0.8+y)
		glvertex2f(X2*radius*0.8+x,Y2*radius*0.8+y)
		glColor4f(1,1,1,t)
		glvertex2f(x,y)
		
		glvertex2f(X1*radius*0.8+x,Y1*radius*0.8+y)
		glvertex2f(X2*radius*0.8+x,Y2*radius*0.8+y)
		glvertex2f(X1*radius+x,Y1*radius+y)
		
		glvertex2f(X1*radius+x,Y1*radius+y)
		glvertex2f(X2*radius*0.8+x,Y2*radius*0.8+y)
		glvertex2f(X2*radius+x,Y2*radius+y)
	Next
	glEnd()
End Sub

Sub DrawMiddle ( ByVal x As Integer, ByVal y As Integer, ByVal grad As Integer, ByVal Transp As Single, ByVal count As Single, ByVal image As UInteger )
	DrawMiddlePlatte(x,y,16+16*(-(count*2-1)^2+2),count*Transp)
	glColor4f(1-count,1-count,1-count,Transp)
	
	glEnable(GL_TEXTURE_2D)
	glBindTexture(GL_TEXTURE_2D,image)
	
	glLoadIdentity()
	glTranslatef(x,y,0)
	glRotatef(-grad,0,0,1)	
	glBegin(GL_QUADS)
	glTexCoord2f(0,0):glVertex2f(-16,-16)
	glTexCoord2f(1,0):glVertex2f(16,-16)
	glTexCoord2f(1,1):glVertex2f(16,16)
	glTexCoord2f(0,1):glVertex2f(-16,16)
	glEnd()
	glLoadIdentity()
	glDisable(GL_TEXTURE_2D)
End Sub

Sub drawPfeile ( ByVal x As Integer, ByVal y As Integer, ByVal r As Integer, ByVal flag As Integer, ByVal m As FRAMEMOUSE Ptr )
	Dim As Integer p, grad
	p=Abs(Sin(Timer*5)*3)
	If flag = TOOL_MOUSEOVER_REMOVE Then
		glBegin(GL_TRIANGLES)
		glVertex2f(x+35+p,y+4)
		glVertex2f(x+40+p,y)
		glVertex2f(x+35+p,y-4)
		glVertex2f(x-35-p,y+4)
		glVertex2f(x-40-p,y)
		glVertex2f(x-35-p,y-4)
		glVertex2f(x+4,y+35+p)
		glVertex2f(x,y+40+p)
		glVertex2f(x-4,y+35+p)
		glVertex2f(x+4,y-35-p)
		glVertex2f(x,y-40-p)
		glVertex2f(x-4,y-35-p)
		glEnd()
	ElseIf flag = TOOL_MOUSEOVER_RESIZE Then
		grad = ATan2(m->YA-y,m->XA-X)*180/3.141
		glLoadIdentity()
		glTranslatef(x,y,0)
		glRotatef(grad,0,0,1)
		glBegin(GL_TRIANGLES)
		glVertex2f(r+5+p,4)
		glVertex2f(r+10+p,0)
		glVertex2f(r+5+p,-4)
		glVertex2f(r-5-p,4)
		glVertex2f(r-10-p,0)
		glVertex2f(r-5-p,-4)
		glEnd()
		glLoadIdentity()
	EndIf
End Sub

Sub ToolPaint ( ByVal toolProps As MAIN_TOOL Ptr, ByVal m As FRAMEMOUSE Ptr )
	Dim As Single P,X1,Y1,X2,Y2,Transp,r,g,b
	Dim As Integer x,y,radius
	x=toolProps->posiX
	y=toolProps->posiY
	radius=toolProps->radius
	Transp=toolProps->transp
	P = 360/radius
	
	glEnable(GL_BLEND)
	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	glColor4f(1,1,1,0.1*Transp)
	DrawCircle ( x,y,radius )	
	If toolProps->light Then
		r=toolProps->r
		g=toolProps->g
		b=toolProps->b
		glBegin(GL_QUADS)
		For i As Integer = 0 To radius-1
			X1 = Sin(i*P*3.141/180)
			Y1 = cos(i*P*3.141/180)
			X2 = Sin((i+1)*P*3.141/180)
			Y2 = cos((i+1)*P*3.141/180)
			
			glColor4f(r,g,b,0)
			glvertex2f(X1*(radius-5)+x,Y1*(radius-5)+y)
			glColor4f(r,g,b,Transp)
			glvertex2f(X1*(radius)+x,Y1*(radius)+y)
			glvertex2f(X2*(radius)+x,Y2*(radius)+y)
			glColor4f(r,g,b,0)
			glvertex2f(X2*(radius-5)+x,Y2*(radius-5)+y)
			
			glvertex2f(X1*(radius+5)+x,Y1*(radius+5)+y)
			glColor4f(r,g,b,Transp)
			glvertex2f(X1*(radius)+x,Y1*(radius)+y)
			glvertex2f(X2*(radius)+x,Y2*(radius)+y)
			glColor4f(r,g,b,0)
			glvertex2f(X2*(radius+5)+x,Y2*(radius+5)+y)
			
		Next
		glEnd()
	Else
		glBegin(GL_LINE_LOOP)
		glColor4f(1,1,1,Transp)
		For i As Integer = 0 To radius-1
			X1 = Sin(i*P*3.141/180)
			Y1 = cos(i*P*3.141/180)
			glvertex2f(X1*radius+x,Y1*radius+y)
		Next
		glEnd()
	EndIf
	
	If toolProps->whatOver Then
		*toolProps->count += __LastToolPaint__*4
		If *toolProps->count>1 Then *toolProps->count=1
	Else
		*toolProps->count -= __LastToolPaint__*4
		If *toolProps->count<0 Then *toolProps->count=0
	EndIf
	
	DrawMiddle(x,y,toolProps->grad,Transp,*toolProps->count,toolProps->image)
	
	If toolProps->whatOver And m->Dis=0 Then
		glColor4f(1,1,1,Transp)
		drawPfeile(x,y,radius,toolProps->whatOver,m)
	EndIf
	glDisable(GL_BLEND)
End Sub

Sub LoadTools ()
	Dim Dat As String
	Dim NewTool As TOOL Ptr
	Dim TextureFile As ZString Ptr
	#If Defined(__FB_Linux__)
	   Dat = Dir(Config.ItemS("ToolFile")+"lib*.so")
	#ElseIf Defined(__FB_Win32__)
	   Dat = Dir(Config.ItemS("ToolFile")+"*.dll")
	#EndIf
	Do Until Dat = ""
		NewTool = Allocate(SizeOf(TOOL))
		For i As Integer = 0 To SizeOf(TOOL)-1
			Cast(UByte Ptr,NewTool)[i] = 0
		Next
		NewTool->Dll = DylibLoad(Config.ItemS("ToolFile")+Dat)
		If NewTool->Dll = 0 Then
			ErLog("Load Tool "+Chr(34)+Dat+Chr(34)+" failed")
			DeAllocate(NewTool)
		Else
			NewTool->Main = DylibSymbol(NewTool->Dll,"Main")
			If NewTool->Main = 0 Then
				ErLog("Load Tool "+Chr(34)+Dat+Chr(34)+" failed")
				DylibFree(NewTool->Dll)
				DeAllocate(NewTool)
			Else
				If NewTool->Main(TOOL_INIT,0,0,0) = 0 Then
					ErLog("Load Tool "+Chr(34)+Dat+Chr(34)+" failed")
					DylibFree(NewTool->Dll)
					DeAllocate(NewTool)
				Else
					TextureFile = Cast(ZString Ptr,NewTool->Main(TOOL_GET,Cast(Integer,StrPtr("texture")),0,0))
					If TextureFile <> 0 Then
						NewTool->TTexture.Load(Config.ItemS("TextureFile")+*TextureFile,RGB(255,0,255))
						InLog("Create Texture con ID "&NewTool->TTexture.GetID)
					EndIf
					InLog("Tool "+Chr(34)+Dat+Chr(34)+" instalized")
					NewTool->Next = __FirstTool__
					__FirstTool__ = NewTool
					__FirstTool__->Main(TOOL_SET,0,Cast(Integer,StrPtr("toolpaint")),Cast(Integer,@ToolPaint))
				EndIf
			EndIf
		EndIf
		Dat = Dir()
	Loop
End Sub
Sub DestroyTools ()
	Dim T As TOOL Ptr
	Do Until __FirstTool__ = 0
		T = __FirstTool__
		__FirstTool__ = T->Next
		T->Main ( TOOL_DESTROY,0,0,0)
		DylibFree(T->Dll)
		DeAllocate(T)
	Loop
End Sub
Sub WinTool ()
	Dim T As TOOL Ptr
	T = __FirstTool__
	Do Until T = 0
		T->Main(TOOL_SET,0,Cast(Integer,StrPtr("win")),1)
		T = T->Next
	Loop
End Sub
Sub SetToolMusic(ByVal pMusicVol As Single Ptr)
	Dim T As TOOL Ptr
	T = __FirstTool__
	Do Until T = 0
		T->Main(TOOL_SET,0,Cast(Integer,StrPtr("music")),Cast(Integer,pMusicVol))
		T = T->Next
	Loop
End Sub
Sub DrawToolLights ( )
	Dim T As TOOL Ptr
	T = __FirstTool__
	Do Until T = 0
		T->Main(TOOL_PAINL_LIGHT,0,0,0)
		T = T->Next
	Loop
End Sub
Function UpdateTools ( ByVal M As FRAMEMOUSE Ptr )As Integer
	Dim T As TOOL Ptr
	Dim R As Integer = -1
	Dim ltp As Double
	If M->B = 1 Then
		M->Dis = M->Over
	Else
		M->Dis = 0
	EndIf
	M->relptr = 0
	M->entf = -1
	T = __FirstTool__
	Do Until T = 0
		R And =T->Main(TOOL_UPDATE,Cast(Integer,M),Cast(Integer,@__FirstPaticle__),0)
		T = T->Next
	Loop
	ltp = Timer
	__LastToolPaint__=ltp-__LastToolPaint__
	T = __FirstTool__
	Do Until T = 0
		T->Main(TOOL_PAINT_STATICS,Cast(Integer,M),0,T->TTexture.GetID)
		T = T->Next
	Loop
	T = __FirstTool__
	Do Until T = 0
		T->Main(TOOL_PAINT_ENABLED,Cast(Integer,M),0,T->TTexture.GetID)
		T = T->Next
	Loop
	T = __FirstTool__
	Do Until T = 0
		T->Main(TOOL_PAINT_SELECTS,Cast(Integer,M),0,T->TTexture.GetID)
		T = T->Next
	Loop
	__LastToolPaint__=ltp
	'If R Then WinTool ()
	Return R
End Function
Function AddTool ( ByVal N As String ) As Integer
	Dim T As TOOL Ptr
	T = __FirstTool__
	Do Until T = 0
		If *Cast(ZString Ptr,T->Main(TOOL_GET,Cast(Integer,StrPtr("Name")),0,0)) = N Then
			Return T->Main(TOOL_ADD,0,0,0)
		EndIf
		T = T->Next
	Loop
End Function
Sub SetTool ( ByVal N As String, ByVal ID As Integer, ByVal Was As String, ByVal NewItem As Integer )
	Dim T As TOOL Ptr
	T = __FirstTool__
	Do Until T = 0
		If *Cast(ZString Ptr,T->Main(TOOL_GET,Cast(Integer,StrPtr("Name")),0,0)) = N Then
			T->Main(TOOL_SET,ID,Cast(Integer,StrPtr(Was)),NewItem)
			Exit Sub
		EndIf
		T = T->Next
	Loop
End Sub
Function GetTool ( ByVal N As String, ByVal ID As Integer, ByVal Was As String ) As Integer
	Dim T As TOOL Ptr
	T = __FirstTool__
	Do Until T = 0
		If *Cast(ZString Ptr,T->Main(TOOL_GET,Cast(Integer,StrPtr("Name")),0,0)) = N Then
			Return T->Main(TOOL_GET,Cast(Integer,StrPtr(Was)),ID,0)
		EndIf
		T = T->Next
	Loop
	Return 0
End Function
Sub ResetTools ()
	Dim T As TOOL Ptr
	T = __FirstTool__
	Do Until T = 0
		T->Main(TOOL_RESET,0,0,0)
		T = T->Next
	Loop
End Sub
Sub SetLevelTool ( ByVal T As TABELLE Ptr )
	Dim TA As TOOL Ptr
	Dim N As String
	Dim IT As TABELLENITEM Ptr
	Dim Num As Integer
	Dim Tabe As TABELLE Ptr
	Dim ID As Integer
	Dim i As Integer
	TA = __FirstTool__
	Do Until TA = 0
		N = *Cast(ZString Ptr,TA->Main(TOOL_GET,Cast(Integer,StrPtr("Name")),0,0))
		i = 0
		Do
			i += 1
			If T->ExistItem(N+"["+Str(i)+"]")=0 Then Exit Do
			IT = T->GetItem(N+"["+Str(i)+"]")
			Tabe = IT->GetValTP
			num = 1
			ID = AddTool ( N )
			Do
				IT = Tabe->GetItem(num)
				If IT = 0 Then Exit Do
				SetTool ( N , ID , IT->GetName , IT->GetValI )
				num += 1
			Loop
		Loop
		TA = TA->Next
	Loop
End Sub

Sub UpdateParticle()
	Dim Ap As PARTICLE Ptr
	Dim L As PARTICLE Ptr
	Dim D As PARTICLE Ptr
	Static LTime As Double
	Dim NTime As Double = Timer
	If LTime = 0 Then LTime = Timer
	Ap = __FirstPaticle__
	glBegin(GL_LINES)
	Do Until Ap = 0
		glColor4f(Ap->Color.r,Ap->Color.g,Ap->Color.b,1)
		glvertex2f(Ap->PosiA.x,Ap->PosiA.y)
		glvertex2f(Ap->Posi.x,Ap->Posi.y)
		If AP->NoVerschub=0 then
			Ap->PosiA = Ap->Posi
			Ap->Posi += Ap->Vector*(NTime-LTime)
			Ap->Vector -= Ap->Vector*(NTime-LTime)/5
		EndIf
		AP->NoVerschub=0
		Ap->Alter -= (NTime-LTime)
		If length(Ap->Vector)<50 Then
			Ap->TimeUderSpeedLimit += (NTime-LTime)
		Else
			Ap->TimeUderSpeedLimit = 0
		EndIf
		If Ap->Alter <= 0 Or Ap->TimeUderSpeedLimit>3 Then
			If L = 0 Then
				__FirstPaticle__ = Ap->Next
				D = Ap
				Ap = Ap->Next
				DeAllocate(D)
				Continue Do
			EndIf
			L->Next = Ap->Next
			D = Ap
			Ap = Ap->Next
			DeAllocate(D)
			Continue Do
		EndIf
		L = Ap
		Ap = Ap->Next
	Loop
	LTime = NTime
	glEnd()
End Sub
Sub DestryAllParticle()
	Dim Ap As PARTICLE Ptr
	Dim D As PARTICLE Ptr
	Ap = __FirstPaticle__
	Do Until Ap = 0
		D = Ap
		Ap = Ap->Next
		DeAllocate(D)
	Loop
	__FirstPaticle__ = 0
End Sub
