Dim Shared FBO_glGenFramebuffersEXT As PFNglGenFramebuffersEXTPROC
Dim Shared FBO_glBindFramebufferEXT As PFNglBindFramebufferEXTPROC
Dim Shared FBO_glGenRenderbuffersEXT As PFNglGenRenderbuffersEXTPROC
Dim Shared FBO_glBindRenderbufferEXT As PFNglBindRenderbufferEXTPROC
Dim Shared FBO_glRenderbufferStorageEXT As PFNglRenderbufferStorageEXTPROC
Dim Shared FBO_glFramebufferRenderbufferEXT As PFNglFramebufferRenderbufferEXTPROC
Dim Shared FBO_glFramebufferTexture2DEXT As PFNglFramebufferTexture2DEXTPROC
Dim Shared FBO_glCheckFramebufferStatusEXT As PFNglCheckFramebufferStatusEXTPROC
Dim Shared FBO_glGenerateMipmapEXT As PFNglGenerateMipmapEXTPROC
Dim Shared FBO_glDeleteFramebuffersEXT As PFNglDeleteFramebuffersEXTPROC
Dim Shared FBO_glDeleteRenderbuffersEXT As PFNglDeleteRenderbuffersEXTPROC
Dim Shared glDrawBuffers As PFNGLDRAWBUFFERSPROC

Dim Shared FBO_Init As Integer
Dim Shared FBO_maxcolorbuffers As UInteger
Dim Shared FBO_maxdrawbuffers As UInteger

Sub INIT_FBO ()
	Dim Sucsses As Integer
	FBO_glGenFramebuffersEXT = glLoadFunction ( "glGenFramebuffersEXT", @Sucsses )
	FBO_glBindFramebufferEXT = glLoadFunction ( "glBindFramebufferEXT", @Sucsses )
	FBO_glGenRenderbuffersEXT = glLoadFunction ("glGenRenderbuffersEXT", @Sucsses )
	FBO_glBindRenderbufferEXT = glLoadFunction ( "glBindRenderbufferEXT", @Sucsses )
	FBO_glRenderbufferStorageEXT = glLoadFunction ( "glRenderbufferStorageEXT", @Sucsses )
	FBO_glFramebufferRenderbufferEXT = glLoadFunction ( "glFramebufferRenderbufferEXT", @Sucsses )
	FBO_glFramebufferTexture2DEXT = glLoadFunction ( "glFramebufferTexture2DEXT", @Sucsses )
	FBO_glCheckFramebufferStatusEXT = glLoadFunction ( "glCheckFramebufferStatusEXT", @Sucsses )
	FBO_glGenerateMipmapEXT = glLoadFunction ( "glGenerateMipmapEXT", @Sucsses )
	FBO_glDeleteFramebuffersEXT = glLoadFunction ( "glDeleteFramebuffersEXT", @Sucsses )
	FBO_glDeleteRenderbuffersEXT = glLoadFunction ( "glDeleteRenderbuffersEXT", @Sucsses )
	glDrawBuffers = glLoadFunction ( "glDrawBuffers", @Sucsses )
	If Sucsses = 0 Then
		FBO_Init = -1
 		glGetIntegerv ( GL_MAX_COLOR_ATTACHMENTS_EXT, @FBO_maxcolorbuffers )
 		glGetIntegerv ( GL_MAX_DRAW_BUFFERS, @FBO_maxdrawbuffers )
	EndIf
End Sub

Type FBO
	Declare Sub Create ( ByVal As Integer, ByVal As Integer )
	Declare Sub NewTexture ()
	Declare Sub NewRenderBuffer( ByVal As UInteger )
	Declare Sub Bind ()
	Declare Sub UnBind ()
	Declare Sub Destroy ()
	Declare Function SizeX () As Integer
	Declare Function SizeY () As Integer
	Declare Function Texture ( ByVal As Integer ) As UInteger
	Private:
	FBO As UInteger
	numTextures As Integer
	pTexture As UInteger Ptr
	numRenderBuffer As Integer
	pRenderBuffer As UInteger Ptr
	BufferSizeX As Integer
	BufferSizeY As Integer
End Type

Sub FBO.Create ( ByVal SizeXX As Integer, ByVal SizeYY As Integer )
	If FBO_Init Then
		This.BufferSizeX = SizeXX
		This.BufferSizeY = SizeYY
		This.pTexture = Allocate ( SizeOf ( UInteger )+ FBO_maxcolorbuffers )
		This.numTextures = 0
		This.pRenderBuffer = Allocate ( SizeOf ( UInteger )+ FBO_maxdrawbuffers )
		This.numRenderBuffer = 0
		FBO_glGenFramebuffersEXT(1, @This.FBO)
		If This.FBO = 0 Then
			ErLog ( "Framebufferobject create failed" )
		EndIf
		This.Bind ()
	EndIf
End Sub
Sub FBO.NewTexture ()
	If FBO_Init Then
		If This.numTextures + 1 > FBO_maxcolorbuffers Then 
			ErLog("FBO Texture Create Failed")
			Exit Sub
		EndIf
		glGenTextures ( 1, @This.pTexture[This.numTextures] )
		glBindTexture ( GL_TEXTURE_2D, This.pTexture[This.numTextures] )
		glTexParameterf ( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP )
	   glTexParameterf ( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP )
	   glTexParameterf ( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR )
	   glTexParameterf ( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR )
	   glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE )
	   glTexImage2D ( GL_TEXTURE_2D, 0, GL_RGBA, This.BufferSizeX, This.BufferSizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, 0 )
	   FBO_glBindFramebufferEXT ( GL_FRAMEBUFFER_EXT, This.FBO )
		FBO_glFramebufferTexture2DEXT ( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT + This.numTextures, GL_TEXTURE_2D, This.pTexture[This.numTextures], 0 )
		This.numTextures += 1
	EndIf
End Sub
Sub FBO.NewRenderBuffer ( ByVal Art As UInteger )
	If FBO_Init Then
		If This.numRenderBuffer + 1 > 1 Then Exit Sub
		Dim Art2 As UInteger
		If Art = GL_DEPTH_COMPONENT Then
			Art2 = GL_DEPTH_ATTACHMENT_EXT
		EndIf
		FBO_glGenRenderbuffersEXT ( 1,@This.pRenderBuffer[This.numRenderBuffer] )
		FBO_glBindRenderbufferEXT ( GL_RENDERBUFFER_EXT, This.pRenderBuffer[This.numRenderBuffer] )
		FBO_glRenderbufferStorageEXT ( GL_RENDERBUFFER_EXT, Art, This.BufferSizeX, This.BufferSizeY )
		FBO_glBindFramebufferEXT ( GL_FRAMEBUFFER_EXT, This.FBO )
		FBO_glFramebufferRenderbufferEXT ( GL_FRAMEBUFFER_EXT, Art2, GL_RENDERBUFFER_EXT, This.pRenderBuffer[This.numRenderBuffer] )
		This.numRenderBuffer += 1
	EndIf
End Sub
Sub FBO.Bind()
	If FBO_Init Then FBO_glBindFramebufferEXT ( GL_FRAMEBUFFER_EXT, This.FBO )
End Sub
Sub FBO.UnBind()
	If FBO_Init Then FBO_glBindFramebufferEXT ( GL_FRAMEBUFFER_EXT, 0 )
End Sub
Sub FBO.Destroy()
	If FBO_Init Then
		FBO_glDeleteFramebuffersEXT ( 1, @This.FBO )
		This.FBO = 0
		For i As Integer = 0 To This.numRenderBuffer - 1
	  		FBO_glDeleteRenderbuffersEXT ( 1, @This.pRenderBuffer[i] )
		Next
		For i As Integer = 0 To This.numTextures - 1
	  		glDeleteTextures ( 1, @This.pTexture[i] )
		Next
	EndIf
End Sub
Function FBO.SizeX () As Integer
	Return This.BufferSizeX
End Function
Function FBO.SizeY () As Integer
	Return This.BufferSizeY
End Function
Function FBO.Texture ( ByVal Num As Integer ) As UInteger
	If Num = 0 Then Return 0
	If Num > This.numTextures Then Return 0
	Return This.pTexture[Num-1]
End Function
