Type RECT
	Declare Constructor ()
	Declare Constructor ( ByVal As Single, ByVal As Single, ByVal As Single, ByVal As Single )
	Left As Single
	Right As Single
	Top As Single
	Bottom As Single
End Type
Constructor RECT()
	This.Left = 0
	This.Right = 0
	This.Top = 0
	This.Bottom = 0
End Constructor
Constructor RECT( ByVal L As Single, ByVal R As Single, ByVal T As Single, ByVal B As Single )
	This.Left = L
	This.Right = R
	This.Top = T
	This.Bottom = B
End Constructor

Type MOUSE
	Const Down = &H01
	Const Pressed = &H02
	Const Up = &H03
	Declare Sub Update ()
	Declare Property X () As Integer
	Declare Property Y () As Integer
	Declare Property W () As Integer
	Declare Property XMove () As Integer
	Declare Property YMove () As Integer
	Declare Property WMove () As Integer
	Declare Property RButton () As Integer
	Declare Property LButton () As Integer
	Declare Property WButton () As Integer
	Private:
	PX As Integer
	PY As Integer
	PW As Integer
	PB As Integer
	PXA As Integer
	PYA As Integer
	PWA As Integer
	PBA As Integer
End Type

Sub MOUSE.Update ()
	This.PXA = This.PX
	This.PYA = This.PY
	This.PWA = This.PW
	This.PBA = This.PB
	GetMouse This.PX, This.PY, This.PW, This.PB
	If This.PX < 0 Then
		This.PX = This.PXA
		This.PY = This.PYA
		This.PW = This.PWA
		This.PB = 0
	EndIf
End Sub
Property MOUSE.X () As Integer
	Return This.PX
End Property
Property MOUSE.Y () As Integer
	Return This.PY
End Property
Property MOUSE.W () As Integer
	Return This.PW
End Property
Property MOUSE.XMove () As Integer
	Return This.PX - This.PXA
End Property
Property MOUSE.YMove () As Integer
	Return This.PY - This.PYA
End Property
Property MOUSE.WMove () As Integer
	Return This.PW - This.PWA
End Property
Property MOUSE.RButton () As Integer
	Const Button = 2
	If (This.PB And Button) Then
		If (This.PBA And Button) Then
			Return This.Pressed
		Else
			Return This.Down
		EndIf
	Else
		If (This.PBA And Button) Then
			Return This.Up
		EndIf
	EndIf
	Return 0
End Property
Property MOUSE.LButton () As Integer
	Const Button = 1
	If (This.PB And Button) Then
		If (This.PBA And Button) Then
			Return This.Pressed
		Else
			Return This.Down
		EndIf
	Else
		If (This.PBA And Button) Then
			Return This.Up
		EndIf
	EndIf
	Return 0
End Property
Property MOUSE.WButton () As Integer
	Const Button = 4
	If (This.PB And Button) Then
		If (This.PBA And Button) Then
			Return This.Pressed
		Else
			Return This.Down
		EndIf
	Else
		If (This.PBA And Button) Then
			Return This.Up
		EndIf
	EndIf
	Return 0
End Property

Type BUTTON
	Declare Property Position ( ByVal As RECT )
	Declare Property Position () As RECT
	Declare Property Title ( ByVal As String )
	Declare Property Title () As String
	Declare Property AnchorX ( ByVal As Integer )
	Declare Function Update ( ByVal As MOUSE, ByVal As Integer = 0 ) As Integer
	Declare Sub Destroy ()
	Private:
	Posi As RECT
	Tit As ZString Ptr
	Prozent As Single
	AnchorXX As Integer
	OverPressed As Integer
End Type
Property BUTTON.Position ( ByVal R As RECT )
	This.Posi = R
End Property
Property BUTTON.Position () As RECT
	Return This.Posi
End Property
Property BUTTON.Title ( ByVal S As String )
	If This.Tit Then DeAllocate(This.Tit)
	This.Tit = Allocate(Len(S)+1)
	*This.Tit = S
End Property
Property BUTTON.Title () As String
	Return *This.Tit
End Property
Property BUTTON.AnchorX ( ByVal A As Integer )
	This.AnchorXX = A
End Property
Function BUTTON.Update ( ByVal m As MOUSE, ByVal p As Integer = 0 ) As Integer
	Dim S As Any Ptr
	Dim Over As Integer
	If m.X > This.Posi.left And m.X < This.Posi.right And m.Y > This.Posi.Top And m.Y < This.Posi.Bottom Then
		Over = -1
		Select Case m.LButton
			Case m.Down
				This.OverPressed = -1
				Function = 0
			Case m.Up
				If This.OverPressed Then
					Function = -1
				Else
					Function = 0
				EndIf
		End Select
	Else
		This.OverPressed = 0
		Function = 0
	EndIf
	If Over Or p Then
		This.Prozent += 0.2
		If This.Prozent > 1 Then This.Prozent = 1
	Else
		This.Prozent -= 0.1
		If This.Prozent < 0 Then This.Prozent = 0
	EndIf
	S = guitmSave ()
	guitmSetColor(vec4(1,1,1,1-This.Prozent))
	guitmSetViewPort ( This.Posi.Left, This.Posi.Right, Screen_Hight-This.Posi.Bottom, Screen_Hight-This.Posi.Top )
	guitmSetWriteRect ( 0, This.Posi.Right-This.Posi.Left, 0, This.Posi.Bottom-This.Posi.Top )
	guitmSetAnchor ( This.AnchorXX, GUI_TM_TOP )
	guitmSetPosition ( vec2(0,0) )
	guitmwrite ( This.Tit )
	guitmLoad ( S )
End Function
Sub BUTTON.Destroy ()
	If This.Tit Then DeAllocate(This.Tit)
	This.Tit = 0
End Sub

Type SCROLL
	Declare Property Position ( ByVal As RECT )
	Declare Property Position () As RECT
	Declare Property ScrollPosition () As Integer
	Declare Property ScrollPosition ( ByVal As Integer )
	Declare Property ScrollMax () As Integer
	Declare Property ScrollMax ( ByVal As Integer )
	Declare Sub IsHScroll ( ByVal As Integer )
	Declare Function Update ( ByVal As MOUSE ) As Integer
	Declare Sub Destroy ()
	Private:
	Posi As RECT
	SPosi As Integer
	SMax As Integer
	Typ As Integer
	OV As Integer
	TempPosi As Single
End Type

Property SCROLL.Position ( ByVal R As RECT )
	This.Posi = R
End Property
Property SCROLL.Position () As RECT
	Return This.Posi
End Property
Property SCROLL.ScrollPosition () As Integer
	Return This.SPosi
End Property
Property SCROLL.ScrollPosition ( ByVal N As Integer )
	If N < 0 Or N > This.SMax Then Exit Property
	This.SPosi = N
End Property
Property SCROLL.ScrollMax () As Integer
	Return This.SMax
End Property
Property SCROLL.ScrollMax ( ByVal N As Integer )
	This.SMax = N
	If This.SPosi > This.SMax Then This.SPosi = This.SMax
End Property
Sub SCROLL.IsHScroll ( ByVal T As Integer )
	This.Typ = T
End Sub
Function SCROLL.Update ( ByVal M As MOUSE ) As Integer
	glBegin(GL_QUADS)
	glVertex2f(This.Posi.Left,This.Posi.Top)
	glVertex2f(This.Posi.Left+2,This.Posi.Top)
	glVertex2f(This.Posi.Left+2,This.Posi.Bottom)
	glVertex2f(This.Posi.Left,This.Posi.Bottom)
	
	glVertex2f(This.Posi.Right,This.Posi.Top)
	glVertex2f(This.Posi.Right-2,This.Posi.Top)
	glVertex2f(This.Posi.Right-2,This.Posi.Bottom)
	glVertex2f(This.Posi.Right,This.Posi.Bottom)
	
	glVertex2f(This.Posi.Right,This.Posi.Top)
	glVertex2f(This.Posi.Right,This.Posi.Top+2)
	glVertex2f(This.Posi.Left,This.Posi.Top+2)
	glVertex2f(This.Posi.Left,This.Posi.Top)
	
	glVertex2f(This.Posi.Right,This.Posi.Bottom)
	glVertex2f(This.Posi.Right,This.Posi.Bottom-2)
	glVertex2f(This.Posi.Left,This.Posi.Bottom-2)
	glVertex2f(This.Posi.Left,This.Posi.Bottom)
	
	Dim Leng1 As Integer
	Dim Leng2 As Single
	
	If This.ScrollMax = 0 Then
		glVertex2f(This.Posi.Right-4,This.Posi.Top+4)
		glVertex2f(This.Posi.Right-4,This.Posi.Bottom-4)
		glVertex2f(This.Posi.Left+4,This.Posi.Bottom-4)
		glVertex2f(This.Posi.Left+4,This.Posi.Top+4)
		glEnd()
		Return 0
	EndIf
	
	If This.Typ Then
		Leng1 = (This.Posi.Bottom - This.Posi.Top - 8)
		Leng2 = Leng1 / (This.ScrollMax+1)
		
		If m.X > This.Posi.Left+4 And m.X < This.Posi.right-4 And Screen_Hight-m.Y > This.Posi.Bottom-4-This.TempPosi*Leng2-Leng2 And Screen_Hight-m.Y < This.Posi.Bottom-4-This.TempPosi*Leng2 Then
			glColor4f(1,1,1,0)
			Select Case m.LButton
				Case m.Down
					This.TempPosi = This.SPosi
					This.OV = 1
					Function = -1
				Case m.Up
					This.SPosi = This.TempPosi
					This.TempPosi = This.SPosi
					This.OV = 0
					Function = 0
				Case m.Pressed 
					This.SPosi = This.TempPosi
			End Select
		Else
			If m.LButton = m.Up Then
				This.SPosi = This.TempPosi
				This.OV = 0
				Function = 0
			EndIf
			If This.OV <> 2 Then
				Function = 0
				This.OV = 0
				This.TempPosi = This.SPosi
				glColor4f(1,1,1,1)
			Else
				This.SPosi = This.TempPosi
			EndIf
		EndIf
		If This.OV = 2 Then
			This.TempPosi += m.YMove/Leng2
			If This.TempPosi < 0 Then This.TempPosi = 0
			If This.TempPosi > This.SMax Then This.TempPosi = This.SMax
		EndIf
		If This.Ov = 1 Then This.OV = 2
		glVertex2f(This.Posi.Right-4,This.Posi.Bottom-4-This.TempPosi*Leng2-Leng2)
		glVertex2f(This.Posi.Right-4,This.Posi.Bottom-4-This.TempPosi*Leng2)
		glVertex2f(This.Posi.Left+4,This.Posi.Bottom-4-This.TempPosi*Leng2)
		glVertex2f(This.Posi.Left+4,This.Posi.Bottom-4-This.TempPosi*Leng2-Leng2)
		glColor4f(1,1,1,1)
	EndIf
	
	glEnd()
	
End Function
Sub SCROLL.Destroy ()
	'
End Sub


Type LISTBOXLIST
	Item As BUTTON
	Next As LISTBOXLIST Ptr
End Type

Type LISTBOX
	Declare Property Position ( ByVal As RECT )
	Declare Property Position () As RECT
	Declare Function AddItem () As BUTTON Ptr
	Declare Function InsertItem ( ByVal As Integer ) As BUTTON Ptr
	Declare Sub RemoveItem ( ByVal As Integer )
	Declare Property ItemP ( ByVal As Integer ) As BUTTON Ptr
	Declare Function Update ( ByVal As MOUSE ) As Integer
	Declare Sub Destroy ()
	Private:
	Declare Function GetItem ( ByVal As Integer ) As LISTBOXLIST Ptr
	Declare Function GetItemCount () As Integer
	Posi As RECT
	ItemList As LISTBOXLIST Ptr
	HScroll As SCROLL
End Type

Property LISTBOX.Position ( ByVal R As RECT )
	This.Posi = R
End Property
Property LISTBOX.Position () As RECT
	Return This.Posi
End Property
Function LISTBOX.AddItem () As BUTTON Ptr
	Dim Item As LISTBOXLIST Ptr
	Dim IT As LISTBOXLIST Ptr
	Item = Allocate(SizeOf(LISTBOXLIST))
	For i As Integer = 0 To SizeOf(LISTBOXLIST)-1
		Cast(UByte Ptr,Item)[i] = 0
	Next
	Function = @Item->Item
	It = This.ItemList
	If It = 0 Then 
		ItemList = Item
		Exit Function
	EndIf
	Do Until It->Next = 0
		It = It->Next
	Loop
	It->Next = Item
End Function
Function LISTBOX.InsertItem ( ByVal P As Integer ) As BUTTON Ptr
	Dim Item As LISTBOXLIST Ptr
	Dim IT As LISTBOXLIST Ptr
	Item = Allocate(SizeOf(LISTBOXLIST))
	For i As Integer = 0 To SizeOf(LISTBOXLIST)-1
		Cast(UByte Ptr,Item)[i] = 0
	Next
	Function = @Item->Item
	If P <= 1 Then
		If This.ItemList = 0 Then 
			This.ItemList = Item
			Exit Function
		EndIf
		Item->Next = This.ItemList->Next
		Exit Function
	EndIf
	It = GetItem ( P-1 )
	Item->Next = It
	If It = 0 Then 
		This.ItemList = Item
		Exit Function
	EndIf
	It->Next = Item
End Function
Sub LISTBOX.RemoveItem ( ByVal P As Integer )
	Dim IT As LISTBOXLIST Ptr
	Dim Be As LISTBOXLIST Ptr
	It = This.ItemList
	If It = 0 Then Exit Sub
	For i As Integer = 2 To P-1
		Be = It
		If It = 0 Then Exit Sub
		It = It->Next
	Next
	If Be = 0 Then 
		This.ItemList = It->Next
	Else
		Be->Next = It->Next
	EndIf
	It->Item.Destroy ()
	DeAllocate(It)
End Sub
Property LISTBOX.ItemP ( ByVal P As Integer ) As BUTTON Ptr
	Dim IT As LISTBOXLIST Ptr
	It = This.GetItem ( P )
	If It = 0 Then Return 0
	Return @It->Item
End Property
Function LISTBOX.Update ( ByVal M As MOUSE ) As Integer
	Const Hight = 40
	Dim Count As Integer
	Dim R As Integer
	Dim H As Integer
	Dim IT As LISTBOXLIST Ptr
	Dim ITA As LISTBOXLIST Ptr
	Dim Re As RECT
	This.HScroll.IsHScroll(-1)
	This.HScroll.Position = RECT(This.Posi.Right-20,This.Posi.Right,This.Posi.Top,This.Posi.Bottom)
	Count = Int((This.Posi.Bottom - This.Posi.Top-8)/Hight)
	
	TextBlur.Uniformfloat("texture",0)
	
	If This.GetItemCount() - Count < 1 Then 
		This.HScroll.ScrollMax = 0
		R = This.Posi.Right
	Else
		This.HScroll.ScrollMax = This.GetItemCount() - Count
		This.HScroll.Update(M)
		R = This.Posi.Right-20
	EndIf
	
	
	glBegin(GL_QUADS)
	glVertex2f(This.Posi.Left,This.Posi.Top)
	glVertex2f(This.Posi.Left+2,This.Posi.Top)
	glVertex2f(This.Posi.Left+2,This.Posi.Bottom)
	glVertex2f(This.Posi.Left,This.Posi.Bottom)
	
	glVertex2f(This.Posi.Right,This.Posi.Top)
	glVertex2f(This.Posi.Right-2,This.Posi.Top)
	glVertex2f(This.Posi.Right-2,This.Posi.Bottom)
	glVertex2f(This.Posi.Right,This.Posi.Bottom)
	
	glVertex2f(This.Posi.Right,This.Posi.Top)
	glVertex2f(This.Posi.Right,This.Posi.Top+2)
	glVertex2f(This.Posi.Left,This.Posi.Top+2)
	glVertex2f(This.Posi.Left,This.Posi.Top)
	
	glVertex2f(This.Posi.Right,This.Posi.Bottom)
	glVertex2f(This.Posi.Right,This.Posi.Bottom-2)
	glVertex2f(This.Posi.Left,This.Posi.Bottom-2)
	glVertex2f(This.Posi.Left,This.Posi.Bottom)
	glEnd()
	
	TextBlur.Uniformfloat("texture",1)
	
	H = This.Posi.Top+4
	
	Function = 0
	
	For i As Integer = 1 To Count
		ITA = IT
		It = This.GetItem( i+This.HScroll.ScrollPosition )
		If It = ITA Then Exit For
		It->Item.Position = RECT(This.Posi.Left+4,R-4,H,H+Hight)
		If It->Item.Update(M) Then
			Function = i+This.HScroll.ScrollPosition
		EndIf
		H += Hight
	Next
End Function
Sub LISTBOX.Destroy ()
	Dim De As LISTBOXLIST Ptr
	Do Until This.ItemList = 0
		De = This.ItemList
		This.ItemList = This.ItemList->Next
		De->Item.Destroy()
		DeAllocate(De)
	Loop
End Sub
Function LISTBOX.GetItem ( ByVal P As Integer ) As LISTBOXLIST Ptr
	Dim IT As LISTBOXLIST Ptr
	It = This.ItemList
	If It = 0 Then Return 0
	For i As Integer = 2 To P
		If It->Next = 0 Then Return It
		It = It->Next
	Next
	Return It
End Function
Function LISTBOX.GetItemCount () As Integer
	Dim Count As Integer
	Dim IT As LISTBOXLIST Ptr
	It = This.ItemList
	Do Until It = 0
		It = It->Next
		count += 1
	Loop
	Return count
End Function

Type FRAMEMOUSE
	Declare Sub Update ()
	Frame As RECT
	X As Single
	Y As Single
	W As Integer
	B As Integer
	XA As Single
	YA As Single
	WA As Integer
	BA As Integer
	Dis As Any Ptr
	Over As Any Ptr
	entf As Single
	relptr As Integer Ptr
	MulX As Single
	MulY As Single
End Type

Sub FRAMEMOUSE.Update ()
	Dim As Integer XX,YY,L,R,T,B
	This.XA = This.X
	This.YA = This.Y
	This.WA = This.W
	This.BA = This.B
	L = This.Frame.Left
	R = This.Frame.Right
	T = This.Frame.Top
	B = This.Frame.Bottom
	GetMouse XX,YY,This.W,This.B
	
	This.X = (XX-L)/(R-L)
	This.Y = (YY-T)/(B-T)
	
	If This.X < 0 Or This.X > 1 Or This.Y < 0 Or This.Y > 1 Then
		This.X = This.XA
		This.Y = This.YA
	Else
		This.X *= This.MulX
		This.Y *= This.MulY
	EndIf
	
	If This.B = 1 Then
		This.Dis = This.Over
	Else
		This.Dis = 0
	EndIf
	This.relptr = 0
	This.entf = -1
End Sub
