
#Undef RGB
#Undef RGBA
#Undef mat2
#Undef min
#Undef max

Type float As Single

Type vec2
	Union
		x As float
		r As float
		s As float
	End Union
	Union
		y As float
		g As float
		t As float
	End Union
	
	Declare Constructor ()
	Declare Constructor ( ByVal As float, ByVal As float )
	
	Declare Property xy () As vec2
	Declare Property xy ( ByVal As vec2 )
	
	Declare Property rg () As vec2
	Declare Property rg ( ByVal As vec2 )
	
	Declare Property st () As vec2
	Declare Property st ( ByVal As vec2 )
	
	Declare Operator += ( ByVal As float )
	Declare Operator += ( ByVal As vec2 )
	
	Declare Operator -= ( ByVal As float )
	Declare Operator -= ( ByVal As vec2 )
	
	Declare Operator *= ( ByVal As float )
	Declare Operator *= ( ByVal As vec2 )
	
	Declare Operator /= ( ByVal As float )
	Declare Operator /= ( ByVal As vec2 )
	
	Declare Operator ^= ( ByVal As float )
	Declare Operator ^= ( ByVal As vec2 )
	
	Declare Operator Cast () As String
	
End Type

Type vec3
	Union
		x As float
		r As float
		s As float
	End Union
	Union
		y As float
		g As float
		t As float
	End Union
	Union
		z As float
		b As float
		p As float
	End Union
	
	Declare Constructor ()
	Declare Constructor ( ByVal As float, ByVal As float, ByVal As float )
	Declare Constructor ( ByVal As vec2, ByVal As float )
	Declare Constructor ( ByVal As float, ByVal As vec2 )
	
	Declare Property xy () As vec2
	Declare Property xy ( ByVal As vec2 )
	Declare Property xz () As vec2
	Declare Property xz ( ByVal As vec2 )
	Declare Property yz () As vec2
	Declare Property yz ( ByVal As vec2 )
	Declare Property xyz () As vec3
	Declare Property xyz ( ByVal As vec3 )
	
	Declare Property rg () As vec2
	Declare Property rg ( ByVal As vec2 )
	Declare Property rb () As vec2
	Declare Property rb ( ByVal As vec2 )
	Declare Property gb () As vec2
	Declare Property gb ( ByVal As vec2 )
	Declare Property RGB () As vec3
	Declare Property RGB ( ByVal As vec3 )
	
	Declare Property st () As vec2
	Declare Property st ( ByVal As vec2 )
	Declare Property sp () As vec2
	Declare Property sp ( ByVal As vec2 )
	Declare Property tp () As vec2
	Declare Property tp ( ByVal As vec2 )
	Declare Property stp () As vec3
	Declare Property stp ( ByVal As vec3 )
	
	Declare Operator += ( ByVal As float )
	Declare Operator += ( ByVal As vec3 )
	
	Declare Operator -= ( ByVal As float )
	Declare Operator -= ( ByVal As vec3 )
	
	Declare Operator *= ( ByVal As float )
	Declare Operator *= ( ByVal As vec3 )
	
	Declare Operator /= ( ByVal As float )
	Declare Operator /= ( ByVal As vec3 )
	
	Declare Operator ^= ( ByVal As float )
	Declare Operator ^= ( ByVal As vec3 )
	
	Declare Operator Cast () As String
	
End Type

Type vec4
	Union
		x As float
		r As float
		s As float
	End Union
	Union
		y As float
		g As float
		t As float
	End Union
	Union
		z As float
		b As float
		p As float
	End Union
	Union
		w As float
		a As float
		q As float
	End Union
	
	Declare Constructor ()
	Declare Constructor ( ByVal As float, ByVal As float, ByVal As float, ByVal As float )
	Declare Constructor ( ByVal As vec2, ByVal As float, ByVal As float )
	Declare Constructor ( ByVal As float, ByVal As vec2, ByVal As float )
	Declare Constructor ( ByVal As float, ByVal As float, ByVal As vec2 )
	Declare Constructor ( ByVal As vec2, ByVal As vec2 )
	Declare Constructor ( ByVal As vec3, ByVal As float )
	Declare Constructor ( ByVal As float, ByVal As vec3 )
	
	Declare Property xy () As vec2
	Declare Property xy ( ByVal As vec2 )
	Declare Property xz () As vec2
	Declare Property xz ( ByVal As vec2 )
	Declare Property xw () As vec2
	Declare Property xw ( ByVal As vec2 )
	Declare Property yz () As vec2
	Declare Property yz ( ByVal As vec2 )
	Declare Property yw () As vec2
	Declare Property yw ( ByVal As vec2 )
	Declare Property zw () As vec2
	Declare Property zw ( ByVal As vec2 )
	Declare Property xyz () As vec3
	Declare Property xyz ( ByVal As vec3 )
	Declare Property xyw () As vec3
	Declare Property xyw ( ByVal As vec3 )
	Declare Property xzw () As vec3
	Declare Property xzw ( ByVal As vec3 )
	Declare Property yzw () As vec3
	Declare Property yzw ( ByVal As vec3 )
	Declare Property xyzw () As vec4
	Declare Property xyzw ( ByVal As vec4 )
	
	Declare Property rg () As vec2
	Declare Property rg ( ByVal As vec2 )
	Declare Property rb () As vec2
	Declare Property rb ( ByVal As vec2 )
	Declare Property ra () As vec2
	Declare Property ra ( ByVal As vec2 )
	Declare Property gb () As vec2
	Declare Property gb ( ByVal As vec2 )
	Declare Property ga () As vec2
	Declare Property ga ( ByVal As vec2 )
	Declare Property ba () As vec2
	Declare Property ba ( ByVal As vec2 )
	Declare Property RGB () As vec3
	Declare Property RGB ( ByVal As vec3 )
	Declare Property rga () As vec3
	Declare Property rga ( ByVal As vec3 )
	Declare Property rba () As vec3
	Declare Property rba ( ByVal As vec3 )
	Declare Property gba () As vec3
	Declare Property gba ( ByVal As vec3 )
	Declare Property RGBA () As vec4
	Declare Property RGBA ( ByVal As vec4 )
	
	Declare Property st () As vec2
	Declare Property st ( ByVal As vec2 )
	Declare Property sp () As vec2
	Declare Property sp ( ByVal As vec2 )
	Declare Property sq () As vec2
	Declare Property sq ( ByVal As vec2 )
	Declare Property tp () As vec2
	Declare Property tp ( ByVal As vec2 )
	Declare Property tq () As vec2
	Declare Property tq ( ByVal As vec2 )
	Declare Property pq () As vec2
	Declare Property pq ( ByVal As vec2 )
	Declare Property stp () As vec3
	Declare Property stp ( ByVal As vec3 )
	Declare Property stq () As vec3
	Declare Property stq ( ByVal As vec3 )
	Declare Property spq () As vec3
	Declare Property spq ( ByVal As vec3 )
	Declare Property tpq () As vec3
	Declare Property tpq ( ByVal As vec3 )
	Declare Property stpq () As vec4
	Declare Property stpq ( ByVal As vec4 )
	
	Declare Operator += ( ByVal As float )
	Declare Operator += ( ByVal As vec4 )
	
	Declare Operator -= ( ByVal As float )
	Declare Operator -= ( ByVal As vec4 )
	
	Declare Operator *= ( ByVal As float )
	Declare Operator *= ( ByVal As vec4 )
	
	Declare Operator /= ( ByVal As float )
	Declare Operator /= ( ByVal As vec4 )
	
	Declare Operator ^= ( ByVal As float )
	Declare Operator ^= ( ByVal As vec4 )
	
	Declare Operator Cast () As String
	
End Type

Type mat2
	Union
		mat(0 To 1,0 To 1) As float
		Type 
			As Single mat00,mat01
			As Single mat10,mat11
		End Type
	End Union
	Declare Constructor ()
	Declare Constructor ( ByVal As float, ByVal As float, ByVal As float, ByVal As float )
	Declare Constructor ( ByVal As vec2, ByVal As vec2 )
	Declare Destructor ()
	Declare Operator += ( ByVal As float )
	Declare Operator += ( ByVal As mat2 )
	Declare Operator -= ( ByVal As float )
	Declare Operator -= ( ByVal As mat2 )
	Declare Operator *= ( ByVal As float )
	Declare Operator *= ( ByVal As mat2 )
	Declare Operator /= ( ByVal As float )
	Declare Operator /= ( ByVal As mat2 )
	
	Declare Operator cast () As String
End Type

Type mat3
	Union
		mat(0 To 2,0 To 2) As float
		Type 
			As Single mat00,mat01,mat02
			As Single mat10,mat11,mat12
			As Single mat20,mat21,mat22
		End Type
	End Union
	Declare Constructor ()
	Declare Constructor ( ByVal As float, ByVal As float, ByVal As float, _
	ByVal As float, ByVal As float, ByVal As float,_
	ByVal As float, ByVal As float, ByVal As float )
	Declare Constructor ( ByVal As vec3, ByVal As vec3, ByVal As vec3 )
	Declare Destructor ()
	Declare Operator += ( ByVal As float )
	Declare Operator += ( ByVal As mat3 )
	Declare Operator -= ( ByVal As float )
	Declare Operator -= ( ByVal As mat3 )
	Declare Operator *= ( ByVal As float )
	Declare Operator *= ( ByVal As mat3 )
	Declare Operator /= ( ByVal As float )
	Declare Operator /= ( ByVal As mat3 )
	
	Declare Operator cast () As String
End Type

Type mat4
	Union
		mat(0 To 3,0 To 3) As float
		Type 
			As Single mat00,mat01,mat02,mat03
			As Single mat10,mat11,mat12,mat13
			As Single mat20,mat21,mat22,mat23
			As Single mat30,mat31,mat32,mat33
		End Type
	End Union
	Declare Constructor ()
	Declare Constructor ( ByVal As float, ByVal As float, ByVal As float, ByVal As float,_
	ByVal As float, ByVal As float, ByVal As float, ByVal As float,_
	ByVal As float, ByVal As float, ByVal As float, ByVal As float,_
	ByVal As float, ByVal As float, ByVal As float, ByVal As float)
	Declare Constructor ( ByVal As vec4, ByVal As vec4, ByVal As vec4, ByVal As vec4 )
	Declare Destructor ()
	Declare Operator += ( ByVal As float )
	Declare Operator += ( ByVal As mat4 )
	Declare Operator -= ( ByVal As float )
	Declare Operator -= ( ByVal As mat4 )
	Declare Operator *= ( ByVal As float )
	Declare Operator *= ( ByVal As mat4 )
	Declare Operator /= ( ByVal As float )
	Declare Operator /= ( ByVal As mat4 )
	
	Declare Operator cast () As String
End Type
