#Macro InitOperator(Op,nu,na)
Operator op ( ByVal v1 As mat##nu , ByVal v2 As mat##nu ) As mat##nu
	Dim ret As mat##nu
	vec##na ( @ret.mat00 , nu^2 , @v1.mat00 , nu^2 , @v2.mat00 , nu^2 )
	Return ret
End Operator
Operator op ( ByVal v1 As float , ByVal v2 As mat##nu ) As mat##nu
	Dim ret As mat##nu
	vec##na ( @ret.mat00 , nu^2 , @v1 , 1 , @v2.mat00 , nu^2 )
	Return ret
End Operator
Operator op ( ByVal v1 As mat##nu , ByVal v2 As float ) As mat##nu
	Dim ret As mat##nu
	vec##na ( @ret.mat00 , nu^2 , @v1.mat00 , nu^2 , @v2 , 1 )
	Return ret
End Operator
#EndMacro


/'***********************************************************
########################____mat2____#########################
***********************************************************'/

Constructor mat2 ()
	IdentitymatrixSet(@mat00,2)
End Constructor
Constructor mat2 ( ByVal v1 As float, ByVal v2 As float, ByVal v3 As float, ByVal v4 As float )
	mat00 = v1
	mat01 = v2
	mat10 = v3
	mat11 = v4
End Constructor
Constructor mat2 ( ByVal v1 As vec2, ByVal v2 As vec2 )
	mat00 = v1.x
	mat01 = v1.y
	mat10 = v2.x
	mat11 = v2.y
End Constructor
Destructor mat2 ()

End Destructor

Operator mat2.+= ( ByVal v1 As float )
	vecsum(@mat00,4,@mat00,4,@v1,1)
End Operator
Operator mat2.+= ( ByVal v1 As mat2 )
	vecsum(@mat00,4,@mat00,4,@v1.mat00,4)
End Operator
Operator mat2.-= ( ByVal v1 As float )
	vecsub(@mat00,4,@mat00,4,@v1,1)
End Operator
Operator mat2.-= ( ByVal v1 As mat2 )
	vecsub(@mat00,4,@mat00,4,@v1.mat00,4)
End Operator
Operator mat2.*= ( ByVal v1 As float )
	vecmul(@mat00,4,@mat00,4,@v1,1)
End Operator
Operator mat2.*= ( ByVal v1 As mat2 )
	matmult( @mat00,2,2,@mat00,2,2,@v1.mat00,2,2)
End Operator
Operator mat2./= ( ByVal v1 As float )
	vecdiv(@mat00,4,@mat00,4,@v1,1)
End Operator
Operator mat2./= ( ByVal v1 As mat2 )
	vecdiv(@mat00,4,@mat00,4,@v1.mat00,4)
End Operator

Operator mat2.Cast () As String
	Return "{{ "+Str(mat00)+", "+Str(mat10)+" },"+Chr(13,10)+" { "+Str(mat01)+", "+Str(mat11)+" }}"
End Operator

InitOperator(+,2,sum)
Operator - ( ByVal v1 As mat2 ) As mat2
	Dim ret As mat2
	Dim zero As Single = 0
	vecsub ( @ret.mat00,4,@zero,1,@v1.mat00,4)
	Return ret
End Operator
InitOperator(-,2,sum)
InitOperator(/,2,sum)

Operator * ( ByVal v1 As mat2, ByVal v2 As mat2 ) As mat2
	Dim ret As mat2
	matmult(@ret.mat00,2,2,@v1.mat00,2,2,@v2.mat00,2,2)
	Return ret
End Operator
Operator * ( ByVal v1 As mat2, ByVal v2 As float ) As mat2
	Dim ret As mat2
	vecmul(@ret.mat00,4,@v1.mat00,4,@v2,1)
	Return ret
End Operator
Operator * ( ByVal v1 As float, ByVal v2 As mat2 ) As mat2
	Dim ret As mat2
	vecmul(@ret.mat00,4,@v1,1,@v2.mat00,4)
	Return ret
End Operator
Operator * ( ByVal v1 As mat2, ByVal v2 As vec2 ) As vec2
	Dim ret As vec2
	matmult(@ret.x,1,2,@v1.mat00,2,2,@v2.x,1,2)
	Return ret
End Operator

Function matrixCompMult OverLoad ( ByVal v1 As mat2, ByVal v2 As mat2 ) As mat2
	Dim ret As mat2
	vecmul(@ret.mat00,4,@v1.mat00,4,@v2.mat00,4)
	Return ret
End Function



/'***********************************************************
########################____mat3____#########################
***********************************************************'/

Constructor mat3 ()
	IdentitymatrixSet(@mat00,3)
End Constructor
Constructor mat3 ( ByVal v1 As float, ByVal v2 As float, ByVal v3 As float, _
	ByVal v4 As float, ByVal v5 As float, ByVal v6 As float,_
	ByVal v7 As float, ByVal v8 As float, ByVal v9 As float )
	mat00 = v1
	mat01 = v2
	mat02 = v3
	mat10 = v4
	mat11 = v5
	mat12 = v6
	mat20 = v7
	mat21 = v8
	mat22 = v9
End Constructor
Constructor mat3 ( ByVal v1 As vec3, ByVal v2 As vec3, ByVal v3 As vec3 )
	mat00 = v1.x
	mat01 = v1.y
	mat02 = v1.z
	mat10 = v2.x
	mat11 = v2.y
	mat12 = v2.z
	mat20 = v3.x
	mat21 = v3.y
	mat22 = v3.z
End Constructor
Destructor mat3 ()

End Destructor

Operator mat3.+= ( ByVal v1 As float )
	vecsum(@mat00,9,@mat00,9,@v1,1)
End Operator
Operator mat3.+= ( ByVal v1 As mat3 )
	vecsum(@mat00,9,@mat00,9,@v1.mat00,9)
End Operator
Operator mat3.-= ( ByVal v1 As float )
	vecsub(@mat00,9,@mat00,9,@v1,1)
End Operator
Operator mat3.-= ( ByVal v1 As mat3 )
	vecsub(@mat00,9,@mat00,9,@v1.mat00,9)
End Operator
Operator mat3.*= ( ByVal v1 As float )
	vecmul(@mat00,9,@mat00,9,@v1,1)
End Operator
Operator mat3.*= ( ByVal v1 As mat3 )
	matmult( @mat00,3,3,@mat00,3,3,@v1.mat00,3,3)
End Operator
Operator mat3./= ( ByVal v1 As float )
	vecdiv(@mat00,9,@mat00,9,@v1,1)
End Operator
Operator mat3./= ( ByVal v1 As mat3 )
	vecdiv(@mat00,9,@mat00,9,@v1.mat00,9)
End Operator

Operator mat3.Cast () As String
	Return "{{ "+Str(mat00)+", "+Str(mat10)+", "+Str(mat20)+" },"+Chr(13,10)+_
	" { "+Str(mat01)+", "+Str(mat11)+", "+Str(mat21)+" },"+Chr(13,10)+_
	" { "+Str(mat02)+", "+Str(mat12)+", "+Str(mat22)+" }}"
End Operator

InitOperator(+,3,sum)
Operator - ( ByVal v1 As mat3 ) As mat3
	Dim ret As mat3
	Dim zero As Single = 0
	vecsub ( @ret.mat00,9,@zero,1,@v1.mat00,9)
	Return ret
End Operator
InitOperator(-,3,sum)
InitOperator(/,3,sum)

Operator * ( ByVal v1 As mat3, ByVal v2 As mat3 ) As mat3
	Dim ret As mat3
	matmult(@ret.mat00,3,3,@v1.mat00,3,3,@v2.mat00,3,3)
	Return ret
End Operator
Operator * ( ByVal v1 As mat3, ByVal v2 As float ) As mat3
	Dim ret As mat3
	vecmul(@ret.mat00,9,@v1.mat00,9,@v2,1)
	Return ret
End Operator
Operator * ( ByVal v1 As float, ByVal v2 As mat3 ) As mat3
	Dim ret As mat3
	vecmul(@ret.mat00,9,@v1,1,@v2.mat00,9)
	Return ret
End Operator
Operator * ( ByVal v1 As mat3, ByVal v2 As vec3 ) As vec3
	Dim ret As vec3
	matmult(@ret.x,1,3,@v1.mat00,3,3,@v2.x,1,3)
	Return ret
End Operator

Function matrixCompMult OverLoad ( ByVal v1 As mat3, ByVal v2 As mat3 ) As mat3
	Dim ret As mat3
	vecmul(@ret.mat00,9,@v1.mat00,9,@v2.mat00,9)
	Return ret
End Function



/'***********************************************************
########################____mat4____#########################
***********************************************************'/

Constructor mat4 ()
	IdentitymatrixSet(@mat00,4)
End Constructor
Constructor mat4 ( ByVal v1 As float, ByVal v2 As float, ByVal v3 As float, ByVal v4 As float,_
	ByVal v5 As float, ByVal v6 As float, ByVal v7 As float, ByVal v8 As float,_
	ByVal v9 As float, ByVal v10 As float, ByVal v11 As float, ByVal v12 As float,_
	ByVal v13 As float, ByVal v14 As float, ByVal v15 As float, ByVal v16 As float)
	mat00 = v1
	mat01 = v2
	mat02 = v3
	mat03 = v4
	mat10 = v5
	mat11 = v6
	mat12 = v7
	mat13 = v8
	mat20 = v9
	mat21 = v10
	mat22 = v11
	mat23 = v12
	mat30 = v13
	mat31 = v14
	mat32 = v15
	mat33 = v16
End Constructor
Constructor mat4 ( ByVal v1 As vec4, ByVal v2 As vec4, ByVal v3 As vec4, ByVal v4 As vec4 )
	mat00 = v1.x
	mat01 = v1.y
	mat02 = v1.z
	mat03 = v1.w
	mat10 = v2.x
	mat11 = v2.y
	mat12 = v2.z
	mat13 = v2.w
	mat20 = v3.x
	mat21 = v3.y
	mat22 = v3.z
	mat23 = v3.w
	mat30 = v4.x
	mat31 = v4.y
	mat32 = v4.z
	mat33 = v4.w
End Constructor
Destructor mat4 ()
End Destructor
	
Operator mat4.+= ( ByVal v1 As float )
	vecsum(@mat00,16,@mat00,16,@v1,1)
End Operator
Operator mat4.+= ( ByVal v1 As mat4 )
	vecsum(@mat00,16,@mat00,16,@v1.mat00,16)
End Operator
Operator mat4.-= ( ByVal v1 As float )
	vecsub(@mat00,16,@mat00,16,@v1,1)
End Operator
Operator mat4.-= ( ByVal v1 As mat4 )
	vecsub(@mat00,16,@mat00,16,@v1.mat00,16)
End Operator
Operator mat4.*= ( ByVal v1 As float )
	vecmul(@mat00,16,@mat00,16,@v1,1)
End Operator
Operator mat4.*= ( ByVal v1 As mat4 )
	matmult( @mat00,4,4,@mat00,4,4,@v1.mat00,4,4)
End Operator
Operator mat4./= ( ByVal v1 As float )
	vecdiv(@mat00,16,@mat00,16,@v1,1)
End Operator
Operator mat4./= ( ByVal v1 As mat4 )
	vecdiv(@mat00,16,@mat00,16,@v1.mat00,16)
End Operator

Operator mat4.Cast () As String
	Return "{{ "+Str(mat00)+", "+Str(mat10)+", "+Str(mat20)+", "+Str(mat30)+" },"+Chr(13,10)+_
	" { "+Str(mat01)+", "+Str(mat11)+", "+Str(mat21)+", "+Str(mat31)+" },"+Chr(13,10)+_
	" { "+Str(mat02)+", "+Str(mat12)+", "+Str(mat22)+", "+Str(mat32)+" },"+Chr(13,10)+_
	" { "+Str(mat03)+", "+Str(mat13)+", "+Str(mat23)+", "+Str(mat33)+" }}"
End Operator

InitOperator(+,4,sum)
Operator - ( ByVal v1 As mat4 ) As mat4
	Dim ret As mat4
	Dim zero As Single = 0
	vecsub ( @ret.mat00,16,@zero,1,@v1.mat00,16)
	Return ret
End Operator
InitOperator(-,4,sum)
InitOperator(/,4,sum)

Operator * ( ByVal v1 As mat4, ByVal v2 As mat4 ) As mat4
	Dim ret As mat4
	matmult(@ret.mat00,4,4,@v1.mat00,4,4,@v2.mat00,4,4)
	Return ret
End Operator
Operator * ( ByVal v1 As mat4, ByVal v2 As float ) As mat4
	Dim ret As mat4
	vecmul(@ret.mat00,16,@v1.mat00,16,@v2,1)
	Return ret
End Operator
Operator * ( ByVal v1 As float, ByVal v2 As mat4 ) As mat4
	Dim ret As mat4
	vecmul(@ret.mat00,16,@v1,1,@v2.mat00,16)
	Return ret
End Operator
Operator * ( ByVal v1 As mat4, ByVal v2 As vec4 ) As vec4
	Dim ret As vec4
	matmult(@ret.x,1,4,@v1.mat00,4,4,@v2.x,1,4)
	Return ret
End Operator

Function matrixCompMult OverLoad ( ByVal v1 As mat4, ByVal v2 As mat4 ) As mat4
	Dim ret As mat4
	vecmul(@ret.mat00,16,@v1.mat00,16,@v2.mat00,16)
	Return ret
End Function


#Undef InitOperator
