Dim Shared SHADER_glCreateShaderObject as PFNglCreateShaderObjectARBPROC
Dim Shared SHADER_glShaderSource as PFNglShaderSourcePROC
Dim Shared SHADER_glGetShaderSource As PFNglGetShaderSourcePROC
Dim Shared SHADER_glCompileShader As PFNglCompileShaderPROC
Dim Shared SHADER_glDeleteObject As PFNglDeleteObjectARBPROC
Dim Shared SHADER_glCreateProgramObject As PFNglCreateProgramObjectARBPROC
Dim Shared SHADER_glAttachObject As PFNglAttachObjectARBPROC
Dim Shared SHADER_glUseProgramObject As PFNglUseProgramObjectARBPROC
Dim Shared SHADER_glLinkProgram As PFNglLinkProgramPROC
Dim Shared SHADER_glValidateProgram As PFNglValidateProgramPROC
Dim Shared SHADER_glGetObjectParameteriv As PFNglGetObjectParameterivARBPROC
Dim Shared SHADER_glGetInfoLog As PFNglGetInfoLogARBPROC
Dim Shared SHADER_glGetUniformLocation As PFNglGetUniformLocationPROC
Dim Shared SHADER_glUniform1i As PFNglUniform1iPROC
Dim Shared SHADER_glUniform1f As PFNglUniform1fPROC
Dim Shared SHADER_glUniform2fv As PFNglUniform2fvPROC
Dim Shared SHADER_glUniform3fv As PFNglUniform3fvPROC

Dim Shared SHADER_Init As Integer

Sub INIT_SHADER ()
	Dim Sucsses As Integer
	SHADER_glCreateShaderObject = glLoadFunction ( "glCreateShaderObjectARB", @Sucsses )
	SHADER_glShaderSource = glLoadFunction ( "glShaderSource", @Sucsses )
 	SHADER_glGetShaderSource = glLoadFunction ( "glGetShaderSource", @Sucsses )
 	SHADER_glCompileShader = glLoadFunction ( "glCompileShader", @Sucsses )
 	SHADER_glDeleteObject = glLoadFunction ( "glDeleteObjectARB", @Sucsses )
 	SHADER_glCreateProgramObject = glLoadFunction ( "glCreateProgramObjectARB", @Sucsses )
 	SHADER_glAttachObject = glLoadFunction ( "glAttachObjectARB", @Sucsses )
 	SHADER_glUseProgramObject = glLoadFunction ( "glUseProgramObjectARB", @Sucsses )
 	SHADER_glLinkProgram = glLoadFunction ( "glLinkProgram", @Sucsses )
 	SHADER_glValidateProgram = glLoadFunction ( "glValidateProgram", @Sucsses )
 	SHADER_glGetObjectParameteriv = glLoadFunction ( "glGetObjectParameterivARB", @Sucsses )
 	SHADER_glGetInfoLog = glLoadFunction ( "glGetInfoLogARB", @Sucsses )
 	SHADER_glGetUniformLocation = glLoadFunction ( "glGetUniformLocation", @Sucsses )
 	SHADER_glUniform1i = glLoadFunction ( "glUniform1i", @Sucsses )
 	SHADER_glUniform1f = glLoadFunction ( "glUniform1f", @Sucsses )
 	SHADER_glUniform2fv = glLoadFunction ( "glUniform2fv", @Sucsses )
 	SHADER_glUniform3fv = glLoadFunction ( "glUniform3fv", @Sucsses )
 	If Sucsses = 0 Then SHADER_Init = -1
End Sub

Type SHADER
	Declare Sub Compile ( ByVal As String )
	Declare Sub Bind ()
	Declare Sub UnBind ()
	Declare Sub Destroy ()
	Declare Sub UniformVec2 ( ByVal As String, ByVal As Vec2 )
	Declare Sub Uniformfloat ( ByVal As String, ByVal As Float )
	Private:
	Declare Function CompileShaderString ( ByVal As String, ByVal As UInteger, ByVal As String ) As GLHandleARB
	LinkedShader As GLHandleARB
	VertexShader As GLHandleARB
	FragmentShader As GLHandleARB
End Type

Sub SHADER.Compile ( ByVal File As String )
	If SHADER_Init Then
		Dim FF As Integer
		Dim As String D,L
		Dim infologsize As UInteger
		Dim Info As String
		FF = FreeFile
		If Open ( File +".GLVS" For Input As #FF ) = 0 Then
			D = ""
			Do Until Eof(FF)
				Line Input #FF , L
				D += L + Chr(13,10)
			Loop
			Close #FF
			This.VertexShader = This.CompileShaderString ( D, GL_VERTEX_SHADER_ARB, File + " Vertex Shader" )
		Else
			ErLog ( "File "+Chr(34)+File+".GLVS"+Chr(34)+" not found" )
		EndIf
		If Open ( File +".GLFS" For Input As #FF ) = 0 Then
			D = ""
			Do Until Eof(FF)
				Line Input #FF , L
				D += L + Chr(13,10)
			Loop
			Close #FF
			This.FragmentShader = This.CompileShaderString ( D, GL_FRAGMENT_SHADER_ARB, File + " Fragment Shader" )
		Else
			ErLog ( "File "+Chr(34)+File+".GLFS"+Chr(34)+" not found" )
		EndIf
		This.LinkedShader = SHADER_glCreateProgramObject ()
		If This.LinkedShader = 0 Then ErLog ( "Shader "+Chr(34)+File+Chr(34)+" create failed")
		SHADER_glAttachObject ( This.LinkedShader, This.VertexShader )
		SHADER_glAttachObject ( This.LinkedShader, This.FragmentShader )
		SHADER_glLinkProgram ( This.LinkedShader )
		SHADER_glGetObjectParameteriv( This.LinkedShader, GL_OBJECT_INFO_LOG_LENGTH_ARB, @infoLogSize )
		Info = String ( infoLogSize, " " )
		If infoLogSize > 1 Then
			SHADER_glGetInfoLog( This.LinkedShader, InfoLogSize, 0, Cast(UByte Ptr,StrPtr(Info)) )
	   	INLog(File+":"+Chr(13,10)+Info)
	   EndIf 
	EndIf
End Sub
Sub SHADER.Bind ()
	If SHADER_Init Then SHADER_glUseProgramObject( This.LinkedShader )
End Sub
Sub SHADER.UnBind ()
	If SHADER_Init Then SHADER_glUseProgramObject( 0 )
End Sub
Sub SHADER.Destroy ()
	If SHADER_Init Then
		SHADER_glDeleteObject( This.VertexShader )
		SHADER_glDeleteObject( This.FragmentShader )
		SHADER_glDeleteObject( This.LinkedShader )
	EndIf
End Sub
Function SHADER.CompileShaderString ( ByVal S As String, ByVal ShaderType As UInteger, ByVal ID As String ) As GLHandleARB
	Dim CreateShader As GLHandleARB
	Dim Shader_Compile_Success As UInteger
	Dim infologsize As UInteger
	Dim Info As String
	
	CreateShader = SHADER_glCreateShaderObject ( ShaderType )
	SHADER_glShaderSource ( CreateShader, 1, @@S, 0)
	SHADER_glCompileShader( CreateShader )
	SHADER_glGetObjectParameteriv( CreateShader, GL_OBJECT_COMPILE_STATUS_ARB, @Shader_Compile_Success )
	
	If Shader_Compile_Success = 0 Then
		SHADER_glGetObjectParameteriv( CreateShader, GL_OBJECT_INFO_LOG_LENGTH_ARB, @infoLogSize )
		Info = String ( infoLogSize, " " )
		SHADER_glGetInfoLog( CreateShader, InfoLogSize, 0, Cast(UByte Ptr,StrPtr(Info)) )
	   ErLog(ID+":"+Chr(13,10)+Info)
	   Return 0
	EndIf
	Return CreateShader
End Function
Sub SHADER.UniformVec2 ( ByVal N As String, ByVal V As Vec2 )
	If SHADER_Init Then SHADER_glUniform2fv(SHADER_glGetUniformLocation(This.LinkedShader,StrPtr(N)),1,@v.x)
End Sub
Sub SHADER.Uniformfloat ( ByVal N As String, ByVal V As Float )
	If SHADER_Init Then SHADER_glUniform1f(SHADER_glGetUniformLocation(This.LinkedShader,StrPtr(N)),v)
End Sub
