Type GUITMFONT As UInteger
Type GUITMFLAG As UInteger

#Define GUI_TM_NO_ERROR &H00
#Define GUI_TM_NOT_STARTED &H01
#Define GUI_TM_STARTED_ALREADY &H02
#Define GUI_TM_ALLOCATE_FAILED &H03
#Define GUI_TM_WRONG_VALUE &H04
#Define GUI_TM_WRONG_FORMAT &H05
#Define GUI_TM_NOT_ENATH_SPACE &H06
#Define GUI_TM_VERSION &H07
#Define GUI_TM_LINE_BRAKE &H08
#Define GUI_TM_BIND_FONT &H09
#Define GUI_TM_COLOR &H0A
#Define GUI_TM_NUM_FONTS &H0B
#Define GUI_TM_TOP &H0C
#Define GUI_TM_BOTTOM &H0D
#Define GUI_TM_RIGHT GUI_TM_TOP
#Define GUI_TM_LEFT GUI_TM_BOTTOM
#Define GUI_TM_MIDDLE &H0E


#Define GUI_TM_DEPTH_TEST &H01
#Define GUI_TM_ALPHA_TEST &H02
#Define GUI_TM_MULTI_LINE &H04
#Define GUI_TM_AUTO_BRAKE &H08

Type GUITMFONTCHAR
	GUI_TM_POSI As vec2
	GUI_TM_SIZE_X As Integer
End Type

Type GUITMFONTS
	GUI_TM_IN_USE As Integer
	GUI_TM_FONT( 1 To 255 ) As GUITMFONTCHAR
End Type

Type GUITMFONTTEXTURE
	GUI_TM_SIZE As vec2
	GUI_TM_TEXTURE As gluint
End Type

Type GUITM
	_GUI_TM_FONT_TEXTURE As GUITMFONTTEXTURE
	_GUI_TM_COLOR As vec4
	_GUI_TM_FLAGS As GUITMFLAG
	_GUI_TM_LINE_BRAKE As ZString Ptr
	_GUI_TM_POSITION As vec2
	_GUI_TM_RECT1 As vec4
	_GUI_TM_RECT2 As vec4
	_GUI_TM_BIND_FONT As GUITMFONT
	_GUI_TM_LINE_LENGTH As Integer
	_GUI_TM_ANCHOR As vec2
	_GUI_TM_FRAME As vec2
	_GUI_TM_NUM_FONTS As UInteger
	_GUI_TM_PTR_FONTS As GUITMFONTS Ptr
	_GUI_TM_SCALE As Single
End Type

Dim Shared As GUITM Ptr __TM__

Declare Function guitmInit ( ByVal As Integer = 1024 , ByVal As Integer = 1024 ) As Integer
Declare Function guitmExit () As Integer
Declare Function guitmLoadFont ( ByVal As ZString Ptr ) As GUITMFONT
Declare Function guitmDeleteFont ( ByVal As GUITMFONT ) As Integer
Declare Function guitmEnable ( ByVal As GUITMFLAG ) As Integer
Declare Function guitmDisable ( ByVal As GUITMFLAG ) As Integer
Declare Function guitmSetViewPort ( ByVal As Integer, ByVal As Integer, ByVal As Integer, ByVal As Integer ) As Integer
Declare Function guitmSetWriteRect ( ByVal As Integer, ByVal As Integer, ByVal As Integer, ByVal As Integer ) As Integer
Declare Function guitmSetLineBrake ( ByVal As ZString Ptr ) As Integer
Declare Function guitmSetLineLength ( ByVal As Integer ) As Integer
Declare Function guitmSetColor ( ByVal As vec4 ) As Integer
Declare Function guitmSetPosition ( ByVal As vec2 ) As Integer
Declare Function guitmSetAnchor ( ByVal As GUITMFLAG, ByVal As GUITMFLAG ) As Integer
Declare Function guitmBindFont ( ByVal As GUITMFONT ) As Integer
Declare Function guitmwrite ( ByVal As ZString Ptr ) As Integer
Declare Function guitmIsEnabled ( ByVal As GUITMFLAG ) As Integer
Declare Function guitmGetString ( ByVal As GUITMFLAG ) As ZString Ptr
Declare Function guitmGetInt ( ByVal As GUITMFLAG ) As Integer
Declare Function guitmSave () As Any Ptr
Declare Function guitmLoad ( ByVal As Any Ptr ) As Integer
Declare Function guitmSetScale ( ByVal As Single ) As Integer

Function guitmInit ( ByVal X As Integer = 1024 , ByVal Y As Integer = 1024 ) As Integer
	Dim As gluint TTEXTURE, TEXTURE_BEVORE
	Dim As UInteger Ptr Tex
	
	If __TM__ <> 0 Then Return GUI_TM_STARTED_ALREADY
	__TM__ = Allocate(Len(GUITM))
	If  __TM__ = 0 Then Return GUI_TM_ALLOCATE_FAILED
	For i As Integer = 0 To Len(GUITM)-1
		Cast(UByte Ptr,__TM__)[i] = 0
	Next
	__TM__->_GUI_TM_FONT_TEXTURE.GUI_TM_SIZE = vec2(x,y)
	
	Tex = Allocate( X * Y * 4 )
	If Tex = 0 Then
		DeAllocate ( __TM__ )
		__TM__ = 0
		Return GUI_TM_ALLOCATE_FAILED
	EndIf
	
	For i As Integer = 0 To X * Y-1
		Tex[i] = &H00FFFFFF
	Next
	
	glGetIntegerv(GL_TEXTURE_BINDING_2D, @TEXTURE_BEVORE)
	glGenTextures(1,@TTEXTURE)
	glBindTexture(GL_TEXTURE_2D,TTEXTURE)
   glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT )
   glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT )
   glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST )
   glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR )
   glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)
   glTexImage2D( GL_TEXTURE_2D, 0, GL_RGBA, X, Y, 0, GL_RGBA, GL_UNSIGNED_BYTE, Tex)
	glBindTexture(GL_TEXTURE_2D, TEXTURE_BEVORE)
	
	DeAllocate( Tex )
	
	If TTEXTURE = 0 Then 
		DeAllocate ( __TM__ )
		__TM__ = 0
		Return GUI_TM_ALLOCATE_FAILED
	EndIf
	
	__TM__->_GUI_TM_FONT_TEXTURE.GUI_TM_TEXTURE = TTEXTURE
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmExit () As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	glDeleteTextures(1, @__TM__->_GUI_TM_FONT_TEXTURE.GUI_TM_TEXTURE)
	If __TM__->_GUI_TM_PTR_FONTS <> 0 Then DeAllocate( __TM__->_GUI_TM_PTR_FONTS )
	If __TM__->_GUI_TM_LINE_BRAKE <> 0 Then DeAllocate( __TM__->_GUI_TM_LINE_BRAKE )
	
	DeAllocate( __TM__ )
	__TM__ = 0
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmLoadFont ( ByVal file As ZString Ptr ) As GUITMFONT
	
	Type FONT_CHAR
		lengh As UByte
		Reie(1 To 16) As UShort
	End Type
	
	Dim ff As Integer
	Dim Font(1 To 255) As FONT_CHAR
	Dim dat As Integer
	Dim Font_Ptr As UInteger Ptr
	Dim As gluint TEXTURE_BEVORE
	Dim Posi As vec2 = vec2(0,0)
	Dim pFont As GUITMFONTS Ptr
	Dim FTS As vec2
	Dim As Integer free
	
	If __TM__ = 0 Then Return 0
	
	ff = FreeFile
	If Open(*file For Binary As ff) <> 0 Then Return 0
	Get #FF,,dat
	If dat <> (1 Shl 24 Or Asc("f") Shl 16 Or Asc("f") Shl 8 Or Asc("p")) Then
		Close #FF
		Return 0
	EndIf
	For i As Integer = 1 To 255
		Get #FF,,Font(i).lengh
		For j As Integer = 1 To Font(i).lengh
			Get #FF,,Font(i).Reie(j)
		Next
		For j As Integer = Font(i).lengh + 1 to 16
			Font(i).Reie(j) = 0
		Next
	Next
	Close #FF
	
	FTS = __TM__->_GUI_TM_FONT_TEXTURE.GUI_TM_SIZE
	
	Font_Ptr = Allocate( FTS.X * FTS.Y * 4 )
	
	If Font_Ptr = 0 Then Return 0
	
	glGetIntegerv( GL_TEXTURE_BINDING_2D, @TEXTURE_BEVORE )
	glBindTexture( GL_TEXTURE_2D , __TM__->_GUI_TM_FONT_TEXTURE.GUI_TM_TEXTURE )
	glGetTexImage( GL_TEXTURE_2D , 0 , GL_RGBA , GL_UNSIGNED_BYTE , Font_Ptr )
	
	For i As Integer = 0 To __TM__->_GUI_TM_NUM_FONTS-1
		If __TM__->_GUI_TM_PTR_FONTS[i].GUI_TM_IN_USE = 0 Then
			Function = i+1
			pFont = @__TM__->_GUI_TM_PTR_FONTS[i]
			Exit For
		EndIf
	Next
	If pFont = 0 Then
		__TM__->_GUI_TM_NUM_FONTS+=1
		Function = __TM__->_GUI_TM_NUM_FONTS
		__TM__->_GUI_TM_PTR_FONTS = ReAllocate(__TM__->_GUI_TM_PTR_FONTS,Len(GUITMFONTS)*__TM__->_GUI_TM_NUM_FONTS)
		pFont = @__TM__->_GUI_TM_PTR_FONTS[__TM__->_GUI_TM_NUM_FONTS-1]
		For i As Integer = 0 To Len(GUITMFONTS)-1
			Cast(UByte Ptr, pFont)[i] = 0
		Next
	EndIf
	
	pFont->GUI_TM_IN_USE = -1
	
	For i As Integer = 1 To 255
		pFont->GUI_TM_FONT(i).GUI_TM_SIZE_X = Font(i).lengh
	Next
	
	For i As Integer = 1 To 255
		If pFont->GUI_TM_FONT(i).GUI_TM_SIZE_X > 0 Then
			Do
				If Font_Ptr[Posi.Y*FTS.X+Posi.X] = &H00FFFFFF Then
					free += 1
				Else
					free = 0
				EndIf
				If free >= Font(i).lengh Then
					Dim iii As Integer
					Dim jjj As Integer
					For ii As Integer = Posi.X - Font(i).lengh +1 To Posi.X
						iii += 1
						jjj = 0
						For jj As Integer = Posi.Y To Posi.Y+15
							Font_Ptr[jj*FTS.X+ii] = IIf((Font(i).Reie(iii)And 1 Shl jjj),&HFFFFFFFF,&H00)
							jjj += 1
						Next
					Next
					pFont->GUI_TM_FONT(i).GUI_TM_POSI = Posi
					pFont->GUI_TM_FONT(i).GUI_TM_POSI.x -= Font(i).lengh -1
					free = 0
					Exit Do
				EndIf
				Posi.X += 1
				If Posi.X >= FTS.X Then
					Posi.X = 0
					Posi.Y += 16
					free = 0
					If Posi.Y+16 >= FTS.Y Then
						DeAllocate( Font_Ptr )
						Return GUI_TM_NOT_ENATH_SPACE
						glBindTexture( GL_TEXTURE_2D , TEXTURE_BEVORE )
					EndIf
				EndIf
			Loop
		EndIf
	Next
	
	glTexImage2D( GL_TEXTURE_2D, 0 , GL_RGBA, __TM__->_GUI_TM_FONT_TEXTURE.GUI_TM_SIZE.X , __TM__->_GUI_TM_FONT_TEXTURE.GUI_TM_SIZE.Y , 0 , GL_RGBA , GL_UNSIGNED_BYTE , Font_Ptr )
	glBindTexture( GL_TEXTURE_2D , TEXTURE_BEVORE )
	
	DeAllocate ( Font_Ptr )
	
End Function

Function guitmDeleteFont ( ByVal font As GUITMFONT ) As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	
	If font = 0 Or font >	__TM__->_GUI_TM_NUM_FONTS Then return GUI_TM_WRONG_VALUE 
	
	__TM__->_GUI_TM_PTR_FONTS[font-1].GUI_TM_IN_USE = 0
	
	Dim Font_Ptr As UInteger Ptr
	Dim FTS As vec2
	Dim As gluint TEXTURE_BEVORE
	
	FTS = __TM__->_GUI_TM_FONT_TEXTURE.GUI_TM_SIZE
	
	Font_Ptr = Allocate( FTS.X * FTS.Y * 4 )
	
	If Font_Ptr = 0 Then Return GUI_TM_ALLOCATE_FAILED
	
	glGetIntegerv( GL_TEXTURE_BINDING_2D, @TEXTURE_BEVORE )
	glBindTexture( GL_TEXTURE_2D , __TM__->_GUI_TM_FONT_TEXTURE.GUI_TM_TEXTURE )
	glGetTexImage( GL_TEXTURE_2D , 0 , GL_RGBA , GL_UNSIGNED_BYTE , Font_Ptr )
	
	For i As Integer = 1 To 255
		If __TM__->_GUI_TM_PTR_FONTS[font-1].GUI_TM_FONT(i).GUI_TM_SIZE_X > 0 Then
			For ii As Integer = __TM__->_GUI_TM_PTR_FONTS[font-1].GUI_TM_FONT(i).GUI_TM_POSI.X To __TM__->_GUI_TM_PTR_FONTS[font-1].GUI_TM_FONT(i).GUI_TM_POSI.X+__TM__->_GUI_TM_PTR_FONTS[font-1].GUI_TM_FONT(i).GUI_TM_SIZE_X-1
				For jj As Integer = __TM__->_GUI_TM_PTR_FONTS[font-1].GUI_TM_FONT(i).GUI_TM_POSI.Y To __TM__->_GUI_TM_PTR_FONTS[font-1].GUI_TM_FONT(i).GUI_TM_POSI.Y + 15
					Font_Ptr[jj*FTS.X+ii] = &H00FFFFFF
				Next
			Next
		EndIf
	Next
	
	glTexImage2D( GL_TEXTURE_2D, 0 , GL_RGBA, __TM__->_GUI_TM_FONT_TEXTURE.GUI_TM_SIZE.X , __TM__->_GUI_TM_FONT_TEXTURE.GUI_TM_SIZE.Y , 0 , GL_RGBA , GL_UNSIGNED_BYTE , Font_Ptr )
	glBindTexture( GL_TEXTURE_2D , TEXTURE_BEVORE )
	
	DeAllocate ( Font_Ptr )
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmEnable ( ByVal Flags As GUITMFLAG ) As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	
	__TM__->_GUI_TM_FLAGS Or = Flags
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmDisable ( ByVal Flags As GUITMFLAG ) As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	
	__TM__->_GUI_TM_FLAGS And = Not(Flags)
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmSetViewPort ( ByVal r As Integer, ByVal l As Integer, ByVal t As Integer, ByVal b As Integer ) As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	
	__TM__->_GUI_TM_RECT1 = vec4(r,l,t,b)
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmSetWriteRect ( ByVal r As Integer, ByVal l As Integer, ByVal t As Integer, ByVal b As Integer ) As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	
	__TM__->_GUI_TM_RECT2 = vec4(r,l,t,b)
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmSetLineBrake ( ByVal br As ZString Ptr ) As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	
	If __TM__->_GUI_TM_LINE_BRAKE <> 0 Then DeAllocate( __TM__->_GUI_TM_LINE_BRAKE )
	__TM__->_GUI_TM_LINE_BRAKE = Allocate(Len(br)+1)
	If __TM__->_GUI_TM_LINE_BRAKE = 0 Then Return GUI_TM_ALLOCATE_FAILED
	*__TM__->_GUI_TM_LINE_BRAKE = *br
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmSetLineLength ( ByVal l As Integer ) As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	
	__TM__->_GUI_TM_LINE_LENGTH = l
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmSetColor ( ByVal Col As vec4 ) As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	
	__TM__->_GUI_TM_COLOR = Col
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmSetPosition ( ByVal Posi As vec2 ) As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	
	__TM__->_GUI_TM_POSITION = Posi
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmSetAnchor ( ByVal F1 As GUITMFLAG, ByVal F2 As GUITMFLAG ) As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	
	__TM__->_GUI_TM_ANCHOR.X = F1
	__TM__->_GUI_TM_ANCHOR.Y = F2
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmSetFrameSize ( ByVal In As vec2 ) As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	
	__TM__->_GUI_TM_FRAME = In
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmBindFont ( ByVal Font As GUITMFONT ) As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	
	If Font > __TM__->_GUI_TM_NUM_FONTS Then Font = 0
	
	__TM__->_GUI_TM_BIND_FONT = Font
	
	Return GUI_TM_NO_ERROR
	
End Function

Function __TM__write( ByVal text As String, ByVal rec As vec2, ByVal frame As vec2, ByVal posi As vec2, ByVal font As GUITMFONTS Ptr, ByVal br As String, ByVal flag As Integer, ByVal scale As Single) As String
	Dim leng As Integer
	Dim ret As String
	Dim last As Integer
	Dim st As Integer = 1
	Dim lasts As Integer
	If (flag And GUI_TM_MULTI_LINE) = 0 Then
		For i As Integer = 1 To Len(text)
			If Mid(text,i,Len(br)) = br And br <> "" Then
				i+= Len(br)-1
				ret += " "
			Else
				ret += Mid(text,i,1)
			EndIf
		Next
		Return ret
	EndIf
	If (flag And GUI_TM_AUTO_BRAKE) = 0 Then
		Return text
	EndIf
	leng = posi.x
	st = 1
	last = 1
	For i As Integer = 1 To Len(text)
		leng += font->GUI_TM_FONT(Asc(text,i)).GUI_TM_SIZE_X*scale
		
		If Mid(text,i,Len(br)) = br And br <> "" Then
			ret += Mid(text,last,i-last)
			i+= Len(br)-1
			last = i+1
			ret += br
			leng = 0
			lasts = 0
		Else
			Select Case Mid(text,i,1)
				Case "a" To "z","A" To "Z","_","0"To"9"
					If lasts <> 2 And lasts <> 0 Then
						If lasts <> 0 Then ret += Mid(text,last,i-last)
						last = i
					EndIf
					lasts = 2
				Case Else
					If lasts <> 1 And lasts <> 0 Then
						If lasts <> 0 Then ret += Mid(text,last,i-last)
						last = i
					EndIf
					lasts = 1
			End Select
		EndIf'
			
		If leng > rec.x Then
			If st = last Then
				ret += Mid(text,last,i-last+1)+br
				lasts = 0
			Else
				ret += br
				i = last
				lasts = 0
			EndIf
			st = i
			last = i
			leng = 0
		Else
			leng += frame.x*scale
		EndIf
	Next
	ret += Mid(text,last)
	Return ret
End Function

Function guitmwrite ( ByVal text As ZString Ptr ) As Integer
	
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	
	If __TM__->_GUI_TM_BIND_FONT = 0 Then Return GUI_TM_NO_ERROR
	
	Dim font As GUITMFONTS ptr = @__TM__->_GUI_TM_PTR_FONTS[__TM__->_GUI_TM_BIND_FONT-1]
	Dim posi As vec2 = __TM__->_GUI_TM_POSITION
	Dim anchor As vec2 = __TM__->_GUI_TM_ANCHOR
	Dim Col As vec4 = __TM__->_GUI_TM_COLOR
	Dim flag As UInteger = __TM__->_GUI_TM_FLAGS
	Dim br As String = *__TM__->_GUI_TM_LINE_BRAKE
	Dim rec1 As vec4 = __TM__->_GUI_TM_RECT1
	Dim rec2 As vec4 = __TM__->_GUI_TM_RECT2
	Dim size As vec2 = __TM__->_GUI_TM_FONT_TEXTURE.GUI_TM_SIZE
	Dim frame As vec2 = __TM__->_GUI_TM_FRAME
	Dim cchar As UByte
	Dim Posii As vec2
	Dim sizex As Integer
	Dim wr As String
	Dim Scale As Single = __TM__->_GUI_TM_SCALE
	
	rec2.x = -rec2.x
	
	glPushAttrib(GL_COLOR_BUFFER_BIT Or GL_CURRENT_BIT Or GL_DEPTH_BUFFER_BIT Or GL_ENABLE_BIT Or GL_LIGHTING_BIT Or GL_TEXTURE_BIT Or GL_VIEWPORT_BIT)
	glViewport(rec1.x,rec1.z,rec1.y-rec1.x,rec1.w-rec1.z)
	glMatrixMode(GL_PROJECTION)
	 glPushMatrix()
	 glLoadIdentity()
	 glOrtho(rec2.x, rec2.x+rec1.y-rec1.x, rec2.z, rec2.z+rec1.w-rec1.z, -1, 1)
	glMatrixMode(GL_MODELVIEW)
	glPushMatrix()
	glLoadIdentity()
	
	posi.y = (rec1.w-rec1.z) - posi.y
	
	If posi.Y < 0 Then Return GUI_TM_NO_ERROR
	If posi.X < 0 Then posi.X = 0
	If posi.X > rec2.y Then posi.X = 0
	
	glDisable( GL_LIGHTING )
	If (flag And GUI_TM_DEPTH_TEST) Then
		glEnable(GL_DEPTH_TEST)
	Else
		glDisable(GL_DEPTH_TEST)
	EndIf
	If (flag And GUI_TM_ALPHA_TEST) Then
		glEnable(GL_ALPHA_TEST)
	Else
		glDisable(GL_ALPHA_TEST)
	EndIf
	glEnable(GL_BLEND)
	glEnable(GL_TEXTURE_2D)
	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	
	glBindTexture(GL_TEXTURE_2D,__TM__->_GUI_TM_FONT_TEXTURE.GUI_TM_TEXTURE)
	
	glColor4f( Col.r, col.g, col.b, col.a )
	
	glBegin(GL_QUADS)
	wr = __TM__write(*text,vec2(rec2.y,0),frame,posi,font,br,flag,Scale)
	Select Case anchor.X
		Case GUI_TM_RIGHT
			Dim leng As Single
			Dim ToPosi As Integer
			ToPosi = InStr(Wr,br)
			If ToPosi = 0 Then 
				ToPosi = Len(Wr)
			Else
				ToPosi -= 1
			EndIf
			For j As Integer = 1 To ToPosi
				leng += (font->GUI_TM_FONT(Asc(Wr,j)).GUI_TM_SIZE_X+frame.x)*scale
			Next
			posi.x += rec2.y-leng
		Case GUI_TM_MIDDLE
			Dim leng As Single
			Dim ToPosi As Integer
			ToPosi = InStr(Wr,br)
			If ToPosi = 0 Then 
				ToPosi = Len(Wr)
			Else
				ToPosi -= 1
			EndIf
			For j As Integer = 1 To ToPosi
				leng += (font->GUI_TM_FONT(Asc(Wr,j)).GUI_TM_SIZE_X+frame.x)*scale
			Next
			posi.x += Int(rec2.y/2-leng/2)
	End Select
	For i As Integer = 1 To Len(wr)
		If Mid(wr,i,Len(br)) = br And br <> "" Then
			i+= Len(br)-1
			posi.x = 0
			Select Case anchor.X
				Case GUI_TM_RIGHT
					Dim leng As Single
					Dim ToPosi As Integer
					ToPosi = InStr(i+1,Wr,br)
					If ToPosi = 0 Then 
						ToPosi = Len(Wr)
					Else
						ToPosi -= 1
					EndIf
					For j As Integer = i+1 To ToPosi
						leng += (font->GUI_TM_FONT(Asc(Wr,j)).GUI_TM_SIZE_X+frame.x)*scale
					Next
					posi.x = rec2.y-leng
				Case GUI_TM_MIDDLE
					Dim leng As Single
					Dim ToPosi As Integer
					ToPosi = InStr(i+1,Wr,br)
					If ToPosi = 0 Then 
						ToPosi = Len(Wr)
					Else
						ToPosi -= 1
					EndIf
					For j As Integer = i+1 To ToPosi
						leng += (font->GUI_TM_FONT(Asc(Wr,j)).GUI_TM_SIZE_X+frame.x)*scale
					Next
					posi.x = rec2.y/2-leng/2
			End Select
			posi.y -= (16+frame.y)*Scale
		Else
			cchar = Asc(wr,i)
			If cchar <> 0 Then
				If font->GUI_TM_FONT(cchar).GUI_TM_SIZE_X <> 0 Then
					Posii = font->GUI_TM_FONT(cchar).GUI_TM_POSI
					sizex = font->GUI_TM_FONT(cchar).GUI_TM_SIZE_X
					glTexCoord2f(Posii.x/size.x,(Posii.y+16)/size.y):glVertex2f(posi.X,posi.Y-16*Scale)
					glTexCoord2f((Posii.x+sizex)/size.x,(Posii.y+16)/size.y):glVertex2f(posi.X+sizex*Scale,posi.Y-16*Scale)
					glTexCoord2f((Posii.x+sizex)/size.x,Posii.y/size.y):glVertex2f(posi.X+sizex*Scale,posi.Y)
					glTexCoord2f(Posii.x/size.x,Posii.y/size.y):glVertex2f(posi.X,posi.Y)
					posi.x += (sizex+frame.x)*Scale
				EndIf
			EndIf
		EndIf
	Next
	glEnd()
	posi.x = 0
	posi.y -= (16+frame.y)*Scale

	glPopMatrix()
	glMatrixMode(GL_PROJECTION)
	glPopMatrix()
	glMatrixMode(GL_MODELVIEW)
	glPopAttrib()
	
	__TM__->_GUI_TM_POSITION.y = (rec1.w-rec1.z) - posi.y
	__TM__->_GUI_TM_POSITION.x = posi.x
	
	Return GUI_TM_NO_ERROR
	
End Function

Function guitmIsEnabled ( ByVal Flags As GUITMFLAG ) As Integer
	
	If __TM__ = 0 Then Return 0
	
	If (Flags And __TM__->_GUI_TM_FLAGS) = Flags Then
		Return -1
	EndIf
	
	Return 0
	
End Function

Function guitmGetString ( ByVal Flag As GUITMFLAG ) As ZString Ptr
	
	If __TM__ = 0 Then Return 0
	
	Select Case Flag
		Case GUI_TM_VERSION
			Return StrPtr("1.0.0")
		Case GUI_TM_LINE_BRAKE
			Return __TM__->_GUI_TM_LINE_BRAKE
	End Select
	
	Return 0
	
End Function

Function guitmGetInt ( ByVal Flag As GUITMFLAG ) As Integer
	
	If __TM__ = 0 Then Return 0
	
	Select Case Flag
		Case GUI_TM_BIND_FONT
			Return __TM__->_GUI_TM_BIND_FONT
		Case GUI_TM_COLOR
			Return RGBA(__TM__->_GUI_TM_COLOR.R,__TM__->_GUI_TM_COLOR.G,__TM__->_GUI_TM_COLOR.B,__TM__->_GUI_TM_COLOR.A)
		Case GUI_TM_NUM_FONTS
			Return __TM__->_GUI_TM_NUM_FONTS
	End Select
	
	Return 0
	
End Function

Function guitmSave () As Any Ptr
	If __TM__ = 0 Then Return 0
	Dim ret As GUITM Ptr
	ret = Allocate(SizeOf(GUITM))
	*ret = *__TM__
	Return ret
End Function

Function guitmLoad ( ByVal P As Any Ptr ) As Integer
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	*__TM__ = *Cast(GUITM Ptr, P)
	DeAllocate(P)
	Return GUI_TM_NO_ERROR
End Function

Function guitmSetScale ( ByVal Scale As Single ) As Integer
	If __TM__ = 0 Then Return GUI_TM_NOT_STARTED
	__TM__->_GUI_TM_SCALE = Scale
	Return GUI_TM_NO_ERROR
End Function
