' BASSMIDI 2.4 FreeBASIC header
' Copyright (c) 2006-2010 Un4seen Developments Ltd.
' Copyright (c) Samuel Gomes, 2010
'
' See the BASSMIDI.CHM file for more detailed documentation
' This header for FreeBASIC was created using the bassmidi.h and bassmidi.bas files in the original package

#Ifndef BASSMIDI_H
#Define BASSMIDI_H

#Inclib "bassmidi"

' Additional BASS_SetConfig options
#Define BASS_CONFIG_MIDI_COMPACT	&H10400
#Define BASS_CONFIG_MIDI_VOICES		&H10401
#Define BASS_CONFIG_MIDI_AUTOFONT	&H10402

' Additional BASS_SetConfigPtr options
#Define BASS_CONFIG_MIDI_DEFFONT	&H10403

' Additional sync types
#Define BASS_SYNC_MIDI_MARKER	&H10000
#Define BASS_SYNC_MIDI_CUE		&H10001
#Define BASS_SYNC_MIDI_LYRIC	&H10002
#Define BASS_SYNC_MIDI_TEXT		&H10003
#Define BASS_SYNC_MIDI_EVENT	&H10004
#Define BASS_SYNC_MIDI_TICK		&H10005
#Define BASS_SYNC_MIDI_TIMESIG	&H10006
#Define BASS_SYNC_MIDI_KEYSIG	&H10007

' Additional BASS_MIDI_StreamCreateFile/etc flags
#Define BASS_MIDI_DECAYEND		&H1000
#Define BASS_MIDI_NOFX			&H2000
#Define BASS_MIDI_DECAYSEEK		&H4000

Type BASS_MIDI_FONT
	font As Long            ' soundfont
	presetno As Long		' preset number (-1=all)
	bank As Long
End Type

Type BASS_MIDI_FONTINFO
	title As ZString Ptr	' name
	copyright As ZString Ptr
	comment As ZString Ptr
	presets As Long         ' number of presets/instruments
	samsize As Long         ' total size (in bytes) of the sample data
	samload As Long         ' amount of sample data currently loaded
	samtype As Long         ' sample format (CTYPE) if packed
End Type

Type BASS_MIDI_MARK
	track As Long           ' track containing marker
	position As Long		' marker position
	text As ZString Ptr     ' marker text
End Type

' Marker types
#Define BASS_MIDI_MARK_MARKER	0	' marker events
#Define BASS_MIDI_MARK_CUE		1	' cue events
#Define BASS_MIDI_MARK_LYRIC	2	' lyric events
#Define BASS_MIDI_MARK_TEXT		3	' text events
#Define BASS_MIDI_MARK_TIMESIG	4	' time signature
#Define BASS_MIDI_MARK_KEYSIG	5	' key signature

' MIDI events
#Define MIDI_EVENT_NOTE				1
#Define MIDI_EVENT_PROGRAM			2
#Define MIDI_EVENT_CHANPRES			3
#Define MIDI_EVENT_PITCH			4
#Define MIDI_EVENT_PITCHRANGE		5
#Define MIDI_EVENT_DRUMS			6
#Define MIDI_EVENT_FINETUNE			7
#Define MIDI_EVENT_COARSETUNE		8
#Define MIDI_EVENT_MASTERVOL		9
#Define MIDI_EVENT_BANK				10
#Define MIDI_EVENT_MODULATION		11
#Define MIDI_EVENT_VOLUME			12
#Define MIDI_EVENT_PAN				13
#Define MIDI_EVENT_EXPRESSION		14
#Define MIDI_EVENT_SUSTAIN			15
#Define MIDI_EVENT_SOUNDOFF			16
#Define MIDI_EVENT_RESET			17
#Define MIDI_EVENT_NOTESOFF			18
#Define MIDI_EVENT_PORTAMENTO		19
#Define MIDI_EVENT_PORTATIME		20
#Define MIDI_EVENT_PORTANOTE		21
#Define MIDI_EVENT_MODE				22
#Define MIDI_EVENT_REVERB			23
#Define MIDI_EVENT_CHORUS			24
#Define MIDI_EVENT_CUTOFF			25
#Define MIDI_EVENT_RESONANCE		26
#Define MIDI_EVENT_RELEASE			27
#Define MIDI_EVENT_ATTACK			28
#Define MIDI_EVENT_REVERB_MACRO		30
#Define MIDI_EVENT_CHORUS_MACRO		31
#Define MIDI_EVENT_REVERB_TIME		32
#Define MIDI_EVENT_REVERB_DELAY		33
#Define MIDI_EVENT_REVERB_LOCUTOFF	34
#Define MIDI_EVENT_REVERB_HICUTOFF	35
#Define MIDI_EVENT_REVERB_LEVEL		36
#Define MIDI_EVENT_CHORUS_DELAY		37
#Define MIDI_EVENT_CHORUS_DEPTH		38
#Define MIDI_EVENT_CHORUS_RATE		39
#Define MIDI_EVENT_CHORUS_FEEDBACK	40
#Define MIDI_EVENT_CHORUS_LEVEL		41
#Define MIDI_EVENT_CHORUS_REVERB	42
#Define MIDI_EVENT_DRUM_FINETUNE	50
#Define MIDI_EVENT_DRUM_COARSETUNE	51
#Define MIDI_EVENT_DRUM_PAN			52
#Define MIDI_EVENT_DRUM_REVERB		53
#Define MIDI_EVENT_DRUM_CHORUS		54
#Define MIDI_EVENT_DRUM_CUTOFF		55
#Define MIDI_EVENT_DRUM_RESONANCE	56
#Define MIDI_EVENT_DRUM_LEVEL		57
#Define MIDI_EVENT_TEMPO			62
#Define MIDI_EVENT_MIXLEVEL			&H10000
#Define MIDI_EVENT_TRANSPOSE		&H10001

Type BASS_MIDI_EVENT
	event As Long          ' MIDI_EVENT_xxx
	param As Long
	chan As Long
	tick As Long            ' event position (ticks)
	position As Long		' event position (bytes)
End Type

' BASS_CHANNELINFO type
#Define BASS_CTYPE_STREAM_MIDI	&H10d00

' Additional attributes
#Define BASS_ATTRIB_MIDI_PPQN		&H12000
#Define BASS_ATTRIB_MIDI_TRACK_VOL	&H12100 ' + track #

' Additional tag type
#Define BASS_TAG_MIDI_TRACK	&H11000	' + track #, track text : array of null-terminated ANSI strings

' BASS_ChannelGetLength/GetPosition/SetPosition mode
#Define BASS_POS_MIDI_TICK		2		' tick position

Declare Function BASS_MIDI_StreamCreate Alias "BASS_MIDI_StreamCreate" (ByVal channels As Long, ByVal flags As Long, ByVal freq As Long) As Long
Declare Function BASS_MIDI_StreamCreateFile Alias "BASS_MIDI_StreamCreateFile" (ByVal mem As Long, ByVal file As Any Ptr, ByVal offset As ULongInt, ByVal length As ULongInt, ByVal flags As Long, ByVal freq As Long) As Long
Declare Function BASS_MIDI_StreamCreateURL Alias "BASS_MIDI_StreamCreateURL" (ByVal url As ZString Ptr, ByVal offset As Long, ByVal flags As Long, ByVal proc As Long, ByVal user As Long, ByVal freq As Long) As Long
Declare Function BASS_MIDI_StreamCreateFileUser Alias "BASS_MIDI_StreamCreateFileUser" (ByVal system_ As Long, ByVal flags As Long, ByVal procs As Any Ptr, ByVal user As Any Ptr, ByVal freq As Long) As Long
Declare Function BASS_MIDI_StreamGetMark Alias "BASS_MIDI_StreamGetMark" (ByVal handle As Long, ByVal type_ As Long, ByVal index As Long, ByVal marks As Any Ptr) As Long
Declare Function BASS_MIDI_StreamSetFonts Alias "BASS_MIDI_StreamSetFonts" (ByVal handle As Long, ByVal fonts As BASS_MIDI_FONT Ptr, ByVal count As Long) As Long
Declare Function BASS_MIDI_StreamGetFonts Alias "BASS_MIDI_StreamGetFonts" (ByVal handle As Long, ByVal fonts As Any Ptr, ByVal count As Long) As Long
Declare Function BASS_MIDI_StreamLoadSamples Alias "BASS_MIDI_StreamLoadSamples" (ByVal handle As Long) As Long
Declare Function BASS_MIDI_StreamEvent Alias "BASS_MIDI_StreamEvent" (ByVal handle As Long, ByVal chan As Long, ByVal event_ As Long, ByVal param As Long) As Long
Declare Function BASS_MIDI_StreamGetEvent Alias "BASS_MIDI_StreamGetEvent" (ByVal handle As Long, ByVal chan As Long, ByVal event_ As Long) As Long
Declare Function BASS_MIDI_StreamGetEvents Alias "BASS_MIDI_StreamGetEvents" (ByVal handle As Long, ByVal chan As Long, ByVal filter As Long, ByVal events As BASS_MIDI_EVENT Ptr) As Long
Declare Function BASS_MIDI_StreamGetChannel Alias "BASS_MIDI_StreamGetChannel" (ByVal handle As Long, ByVal chan As Long) As Long

Declare Function BASS_MIDI_FontInit Alias "BASS_MIDI_FontInit" (ByVal file As ZString Ptr, ByVal flags As Long) As Long
Declare Function BASS_MIDI_FontFree Alias "BASS_MIDI_FontFree" (ByVal handle As Long) As Long
Declare Function BASS_MIDI_FontGetInfo Alias "BASS_MIDI_FontGetInfo" (ByVal handle As Long, ByVal info As BASS_MIDI_FONTINFO Ptr) As Long
Declare Function BASS_MIDI_FontGetPreset Alias "BASS_MIDI_FontGetPreset" (ByVal handle As Long, ByVal preset_ As Long, ByVal bank As Long) As Long
Declare Function BASS_MIDI_FontLoad Alias "BASS_MIDI_FontLoad" (ByVal handle As Long, ByVal preset_ As Long, ByVal bank As Long) As Long
Declare Function BASS_MIDI_FontCompact Alias "BASS_MIDI_FontCompact" (ByVal handle As Long) As Long
Declare Function BASS_MIDI_FontPack Alias "BASS_MIDI_FontPack" (ByVal handle As Long, ByVal outfile As ZString Ptr, ByVal encoder As ZString Ptr, ByVal flags As Long) As Long
Declare Function BASS_MIDI_FontUnpack Alias "BASS_MIDI_FontUnpack" (ByVal handle As Long, ByVal outfile As ZString Ptr, ByVal flags As Long) As Long
Declare Function BASS_MIDI_FontSetVolume Alias "BASS_MIDI_FontSetVolume" (ByVal handle As Long, ByVal volume As Single) As Long
Declare Function BASS_MIDI_FontGetVolume Alias "BASS_MIDI_FontGetVolume" (ByVal handle As Long) As Single

#endif
