#Include "GL/gl.bi"

Const ToolName = "Black_Hole"

#Include "Tool.bi"

Type TOOL
	PosiX As Integer
	PosiY As Integer
	Radius As Integer
	Grad As Integer
	Dreh As Single
	ID As Integer
	TOID As Integer
	LT As Double
End Type

Dim Shared NT As Integer
Dim Shared T As TOOL Ptr
Dim Shared Winn As Integer
Dim Shared Transp As Single

Sub DrawFin ( ByVal tool As TOOL Ptr, ByVal Tex As UInteger )
	glEnable(GL_BLEND)
	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	glEnable(GL_TEXTURE_2D)
	glBindTexture(GL_TEXTURE_2D,Tex)
	glBegin(GL_QUADS)
	glColor4f(1,1,1,transp)
	Dim As Integer X,Y,R
	Dim As Single P,X1,Y1,X2,Y2
	X = tool->PosiX
	Y = tool->PosiY
	R = tool->Radius
	P = 360/R*2
	For i As Integer = 0 To R/2-1
		X1 = Sin((i*P+tool->Dreh)*3.141/180)
		Y1 = cos((i*P+tool->Dreh)*3.141/180)
		X2 = Sin(((i+1)*P+tool->Dreh)*3.141/180)
		Y2 = cos(((i+1)*P+tool->Dreh)*3.141/180)
		glTexCoord2f(1,0.5):glvertex2f(X1*(R-4)+X,Y1*(R-4)+Y)
		glTexCoord2f(1,1):glvertex2f(X1*(R+4)+X,Y1*(R+4)+Y)
		glTexCoord2f(0,1):glvertex2f(X2*(R+4)+X,Y2*(R+4)+Y)
		glTexCoord2f(0,0.5):glvertex2f(X2*(R-4)+X,Y2*(R-4)+Y)
	Next
	glEnd()
	glDisable(GL_TEXTURE_2D)
	glDisable(GL_BLEND)
End Sub

Function Main ( ByVal P1 As Integer, ByVal P2 As Integer, ByVal P3 As Integer, ByVal P4 As Integer ) As Integer Export
	Select Case P1
		Case TOOL_DESTROY
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
		Case TOOL_INIT
			Nt = 0
			T = 0
		Case TOOL_UPDATE
			Dim P As PARTICLE Ptr
			Dim L As PARTICLE Ptr
			Dim D As PARTICLE Ptr
			Dim Ent As Integer
			Dim Entalt As Integer
			Dim RQ As Integer
			Dim win As Integer = -1
			Dim totool As TOOL Ptr
			Dim Gra As Double
			Dim Ge As Double
			Dim FT As Double = Timer
			If winn Then
				transp -= 0.02
				If transp < 0 Then transp = 0
			Else
				transp = 1
			EndIf
			For i As Integer = 0 To NT-1
				If T[i].LT = 0 Then T[i].LT = FT
				T[i].Dreh += (FT-T[i].LT)
				If T[i].Dreh > 360 Then T[i].Dreh -= 360
				L = 0
				P = *Cast(PARTICLE Ptr Ptr,P3)
				RQ = T[i].Radius^2
				toTOOL = 0
				If T[i].TOID <> 0 Then
					For j As Integer = 0 To NT-1
						If T[j].ID = T[i].TOID Then
							toTool = @T[j]
							Exit For
						EndIf
					Next
				EndIf
				Do Until P = 0
					Ent = (T[i].PosiX-P->PosiX)^2+(T[i].PosiY-P->PosiY)^2
					Entalt = (T[i].PosiX-P->PosiXA)^2+(T[i].PosiY-P->PosiYA)^2
					If Ent = 0 Then
						If totool = 0 Then
							D = P
							If L = 0 Then 
								*Cast(PARTICLE Ptr Ptr,P3) = P->Next
							Else
								L->Next = P->Next
							EndIf
							P = P->Next
							DeAllocate(D)
							Continue Do
						Else
							Gra = ATan2(P->PosiYA-P->PosiY,P->PosiXA-P->PosiX)+3.141+(totool->Grad-T[i].Grad)*3.141/180
							P->PosiXA = toTool->PosiX
							P->PosiYA = toTool->PosiY
							P->PosiX = Cos(Gra)*toTool->Radius+toTool->PosiX
							P->PosiY = Sin(Gra)*toTool->Radius+toTool->PosiY
							P->NoVerschub = -1
							Ge = Sqr(P->VectorX^2+P->VectorY^2)
							Gra = ATan2(P->VectorY,P->VectorX)+(totool->Grad-T[i].Grad)*3.141/180
							P->VectorX = Cos(Gra)*Ge
							P->VectorY = Sin(Gra)*Ge
						EndIf
					ElseIf (Ent < RQ  And Entalt > RQ) Then
						P->PosiX = T[i].PosiX
						P->PosiY = T[i].PosiY
						P->NoVerschub = -1
					EndIf
					L = P
					P = P->Next
				Loop
				T[i].LT = FT
			Next
		Case TOOL_RESET
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
			winn = 0
		Case TOOL_ADD
			T = ReAllocate(T,SizeOf(TOOL)*(NT+1))
			T[NT].PosiX = 0
			T[NT].PosiY = 0
			T[NT].Radius = 40
			T[NT].Grad = 0
			T[NT].Dreh = 0
			T[NT].ID = 0
			T[NT].TOID = 0
			T[NT].LT = 0
			NT += 1
			Return NT
		Case TOOL_SET
			If P2 = 0 Then
				Select Case LCase(*Cast(ZString Ptr,P3))
					Case "win"
						winn = P4
				End Select	
			EndIf
			If P2 < 1 Or P2 > NT Then Return FALSE
			Dim R As Integer = P2-1
			Select Case LCase(*Cast(ZString Ptr,P3))
				Case "posix"
					T[r].PosiX = P4
				Case "posiy"
					T[r].PosiY = P4
				Case "radius"
					T[r].Radius = P4
				Case "grad"
					T[r].Grad = P4
				Case "id"
					T[r].ID = P4
				Case "toid"
					T[r].TOID = P4
			End Select
		Case TOOL_GET
			Select Case LCase(*Cast(ZString Ptr,P2))
				Case "name"
					Return Cast(Integer,StrPtr(ToolName))
				Case "texture"
					Return Cast(Integer,StrPtr("Black_Hole.bmp"))
				Case "numparam"
					Return 6
				Case "param1"
					Return Cast(Integer,StrPtr("PosiX"))
				Case "param2"
					Return Cast(Integer,StrPtr("PosiY"))
				Case "param3"
					Return Cast(Integer,StrPtr("Radius"))
				Case "param4"
					Return Cast(Integer,StrPtr("Grad"))
				Case "param5"
					Return Cast(Integer,StrPtr("ID"))
				Case "param6"
					Return Cast(Integer,StrPtr("ToID"))
				Case Else
					If P3 < 1 Or P3 > NT Then Return NULL
					Dim R As Integer = P3-1
					Select Case LCase(*Cast(ZString Ptr,P2))
						Case "posix"
							Return T[r].PosiX
						Case "posiy"
							Return T[r].PosiY
						Case "radius"
							Return T[r].Radius
						Case "grad"
							Return T[r].Grad
						Case "id"
							Return T[r].ID
						Case "toid"
							Return T[r].TOID
						Case Else
							Return NULL
					End Select
			End Select
		Case TOOL_PAINT_STATICS
			For i As Integer = 0 To NT-1
				DrawFin(@T[i],P4)
			Next
		Case Else
			Return FALSE
	End Select
	Return TRUE
End Function
