#Include "GL/gl.bi"

Const ToolName = "Color"

#Include "Tool.bi"

Type TOOL
	PosiX As Integer
	PosiY As Integer
	Radius As Integer
	ColorR As Single
	ColorG As Single
	ColorB As Single
End Type

Dim Shared NT As Integer
Dim Shared T As TOOL Ptr
Dim Shared winn As Integer
Dim Shared Transp As Single

Sub DrawCircle ( ByVal tool As TOOL Ptr, ByVal Tex As UInteger )
	glEnable(GL_BLEND)
	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	glEnable(GL_TEXTURE_2D)
	glBindTexture(GL_TEXTURE_2D,Tex)
	glBegin(GL_QUADS)
	glColor4f(tool->ColorR,tool->ColorG,tool->ColorB,transp)
	Dim As Integer X,Y,R
	Dim As Single P,X1,Y1,X2,Y2
	X = tool->PosiX
	Y = tool->PosiY
	R = tool->Radius
	P = 360/R
	For i As Integer = 0 To R-1
		X1 = Sin(i*P*3.141/180)
		Y1 = cos(i*P*3.141/180)
		X2 = Sin((i+1)*P*3.141/180)
		Y2 = cos((i+1)*P*3.141/180)
		glTexCoord2f(0,((i Mod 10))/10):glvertex2f(X1*(R-5)+X,Y1*(R-5)+Y)
		glTexCoord2f(1,((i Mod 10))/10):glvertex2f(X1*(R+5)+X,Y1*(R+5)+Y)
		glTexCoord2f(1,(i Mod 10+1)/10):glvertex2f(X2*(R+5)+X,Y2*(R+5)+Y)
		glTexCoord2f(0,(i Mod 10+1)/10):glvertex2f(X2*(R-5)+X,Y2*(R-5)+Y)
	Next
	glEnd()
	glDisable(GL_TEXTURE_2D)
	glDisable(GL_BLEND)
End Sub

Function Main ( ByVal P1 As Integer, ByVal P2 As Integer, ByVal P3 As Integer, ByVal P4 As Integer ) As Integer Export
	Select Case P1
		Case TOOL_DESTROY
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
		Case TOOL_INIT
			Nt = 0
			T = 0
		Case TOOL_UPDATE
			Dim P As PARTICLE Ptr
			Dim Ent As Integer
			Dim Entalt As Integer
			Dim RQ As Integer
			If Winn Then
				transp -= 0.02
				If Transp < 0 Then transp = 0
			Else
				transp = 1
			EndIf
			For i As Integer = 0 To NT-1
				P = *Cast(PARTICLE Ptr Ptr,P3)
				RQ = T[i].Radius^2
				Do Until P = 0
					Ent = (T[i].PosiX-P->PosiX)^2+(T[i].PosiY-P->PosiY)^2
					Entalt = (T[i].PosiX-P->PosiXA)^2+(T[i].PosiY-P->PosiYA)^2
					If (Ent <= RQ  And Entalt > RQ) Or (Ent > RQ  And Entalt <= RQ) Then
						P->ColorR = T[i].ColorR
						P->ColorG = T[i].ColorG
						P->ColorB = T[i].ColorB
					EndIf
					P = P->Next
				Loop
			Next
		Case TOOL_RESET
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
			winn = 0
		Case TOOL_ADD
			T = ReAllocate(T,SizeOf(TOOL)*(NT+1))
			T[NT].PosiX = 0
			T[NT].PosiY = 0
			T[NT].Radius = 60
			T[NT].ColorR = 1
			T[NT].ColorG = 1
			T[NT].ColorB = 1
			NT += 1
			Return NT
		Case TOOL_SET
			If P2 = 0 Then
				Select Case LCase(*Cast(ZString Ptr,P3))
					Case "win"
						winn = P4
				End Select
			EndIf
			If P2 < 1 Or P2 > NT Then Return FALSE
			Dim R As Integer = P2-1
			Select Case LCase(*Cast(ZString Ptr,P3))
				Case "posix"
					T[r].PosiX = P4
				Case "posiy"
					T[r].PosiY = P4
				Case "radius"
					T[r].Radius = P4
				Case "colorr"
					T[r].ColorR = P4/255
				Case "colorg"
					T[r].ColorG = P4/255
				Case "colorb"
					T[r].ColorB = P4/255
			End Select
		Case TOOL_GET
			Select Case LCase(*Cast(ZString Ptr,P2))
				Case "name"
					Return Cast(Integer,StrPtr(ToolName))
				Case "texture"
					Return Cast(Integer,StrPtr("Color.tga"))
				Case "numparam"
					Return 6
				Case "param1"
					Return Cast(Integer,StrPtr("PosiX"))
				Case "param2"
					Return Cast(Integer,StrPtr("PosiY"))
				Case "param3"
					Return Cast(Integer,StrPtr("Radius"))
				Case "param4"
					Return Cast(Integer,StrPtr("ColorR"))
				Case "param5"
					Return Cast(Integer,StrPtr("ColorG"))
				Case "param6"
					Return Cast(Integer,StrPtr("ColorB"))
				Case Else
					If P3 < 1 Or P3 > NT Then Return NULL
					Dim R As Integer = P3-1
					Select Case LCase(*Cast(ZString Ptr,P2))
						Case "posix"
							Return T[r].PosiX
						Case "posiy"
							Return T[r].PosiY
						Case "radius"
							Return T[r].Radius
						Case "colorr"
							Return T[r].ColorR*255
						Case "colorg"
							Return T[r].ColorG*255
						Case "colorb"
							Return T[r].ColorB*255
						Case Else
							Return NULL
					End Select
			End Select
		Case TOOL_PAINT_STATICS
			For i As Integer = 0 To NT-1
				DrawCircle(@T[i],P4)
			Next
		Case Else
			Return FALSE
	End Select
	Return TRUE
End Function
