#Include "GL/gl.bi"

Const ToolName = "Color_Mirrow"

Type float As Single

Function vecdot ( ByVal Zeiger1 As float Ptr , ByVal Leng1 As Integer , ByVal Zeiger2 As float Ptr , ByVal Leng2 As Integer ) As float
	Dim er As Double
	If Leng1 <> Leng2 Then Return 0
	For i As Integer = 0 To Leng1-1
		er += Zeiger1[i]*Zeiger2[i]
	Next
	Return er
End Function

Sub vecreflect ( ByVal Zeiger1 As float Ptr , ByVal Leng1 As Integer , byVal Zeiger2 As float Ptr , ByVal Leng2 As Integer , ByVal Zeiger3 As float Ptr , ByVal Leng3 As Integer )
	If Leng1 = Leng2 And Leng1 = Leng3 Then
		Dim er As float
		er = vecdot ( Zeiger3 , Leng3 , Zeiger2 , Leng2 )
		For i As Integer = 0 To Leng1-1
			Zeiger1[i] = Zeiger2[i] - 2 * er * Zeiger3[i]
		Next
	EndIf
End Sub

#Include "Tool.bi"

Type TOOL
	PosiX As Integer
	PosiY As Integer
	Radius As Integer
	ColorR As Single
	ColorG As Single
	ColorB As Single
	Grad As Integer
	Posi1X As Integer
	Posi1Y As Integer
	Posi2X As Integer
	Posi2Y As Integer
	over As Integer
	count As Single
End Type

Dim Shared NT As Integer
Dim Shared T As TOOL Ptr
Dim Shared Winn As Integer
Dim Shared Transp As Single

Function OverLine ( ByVal p1x As Single, ByVal p1y As Single, ByVal p2x As Single, ByVal p2y As Single, ByVal p3x As Single, ByVal p3y As Single ) As Integer
	Return Sgn((p3x-p2x)*(p2y-p1y)+(p3y-p2y)*(p1x-p2x))
End Function

Sub DrawObj ( ByVal tool As TOOL Ptr )
	Dim As Single Normal(0 To 1),N,N1
	Normal(0) = tool->Posi2Y-tool->Posi1Y
	Normal(1) = tool->Posi1X-tool->Posi2X
	N = Sqr(Normal(0)*Normal(0)+Normal(1)*Normal(1))
	Normal(0)/=N
	Normal(1)/=N
	Normal(0)*=5
	Normal(1)*=5
	glEnable(GL_BLEND)
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	glColor4f(tool->ColorR,tool->ColorG,tool->ColorB,0)
	glBegin(GL_QUADS)
	glVertex2f(tool->Posi1X+Normal(0),tool->Posi1Y+Normal(1))
	glColor4f(tool->ColorR,tool->ColorG,tool->ColorB,Transp)
	glVertex2f(tool->Posi1X,tool->Posi1Y)
	glVertex2f(tool->Posi2X,tool->Posi2Y)
	glColor4f(tool->ColorR,tool->ColorG,tool->ColorB,0)
	glVertex2f(tool->Posi2X+Normal(0),tool->Posi2Y+Normal(1))
	
	glVertex2f(tool->Posi1X-Normal(0),tool->Posi1Y-Normal(1))
	glColor4f(tool->ColorR,tool->ColorG,tool->ColorB,Transp)
	glVertex2f(tool->Posi1X,tool->Posi1Y)
	glVertex2f(tool->Posi2X,tool->Posi2Y)
	glColor4f(tool->ColorR,tool->ColorG,tool->ColorB,0)
	glVertex2f(tool->Posi2X-Normal(0),tool->Posi2Y-Normal(1))
	glEnd()
	glDisable(GL_BLEND)
End Sub

Sub CalcPosis ( ByVal tool As TOOL Ptr )
	tool->Posi1X = Cos(tool->Grad*3.141/180)*tool->Radius+tool->PosiX
	tool->Posi1Y = Sin(tool->Grad*3.141/180)*tool->Radius+tool->PosiY
	tool->Posi2X = Cos(tool->Grad*3.141/180)*-tool->Radius+tool->PosiX
	tool->Posi2Y = Sin(tool->Grad*3.141/180)*-tool->Radius+tool->PosiY
End Sub

Function Main ( ByVal P1 As Integer, ByVal P2 As Integer, ByVal P3 As Integer, ByVal P4 As Integer ) As Integer Export
	Select Case P1
		Case TOOL_DESTROY
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
		Case TOOL_INIT
			Nt = 0
			T = 0
		Case TOOL_UPDATE
			Dim NP As Integer
			Dim P As PARTICLE Ptr
			Dim G As Integer
			Dim Ent As Integer
			Dim Entalt As Integer
			Dim RQ As Integer
			Dim As Single XV,YV,N
			Dim As Single Normal(0 To 1),Neu(0 To 1)
			If winn Then 
				Transp -= 0.02
				If Transp < 0 Then Transp = 0
			Else
				Transp = 1
			EndIf
			For i As Integer = 0 To NT-1
				P = *Cast(PARTICLE Ptr Ptr,P3)
				RQ = T[i].Radius^2
				Do Until P = 0
					Ent = (T[i].PosiX-P->PosiX)^2+(T[i].PosiY-P->PosiY)^2
					If Ent <= RQ Then
						If ( OverLine ( T[i].Posi1X, T[i].Posi1Y, T[i].Posi2X, T[i].Posi2Y, P->PosiX, P->PosiY ) <> OverLine ( T[i].Posi1X, T[i].Posi1Y, T[i].Posi2X, T[i].Posi2Y, P->PosiXA, P->PosiYA ) ) Then
							If ( OverLine ( P->PosiX, P->PosiY, P->PosiXA, P->PosiYA, T[i].Posi1X, T[i].Posi1Y ) <> OverLine ( P->PosiX, P->PosiY, P->PosiXA, P->PosiYA, T[i].Posi2X, T[i].Posi2Y ) ) Then
								Normal(0) = T[i].Posi2Y-T[i].Posi1Y
								Normal(1) = T[i].Posi1X-T[i].Posi2X
								N = Sqr(Normal(0)*Normal(0)+Normal(1)*Normal(1))
								Normal(0)/=N
								Normal(1)/=N
								vecreflect ( @Neu(0),2,@P->VectorX,2,@Normal(0),2 )
								P->VectorX = Neu(0)
								P->VectorY = Neu(1)
								P->PosiX = P->PosiXA
								P->PosiY = P->PosiYA
								P->ColorR = T[i].ColorR
								P->ColorG = T[i].ColorG
								P->ColorB = T[i].ColorB
							EndIf
						EndIf
					EndIf
					P = P->Next
				Loop
			Next
		Case TOOL_RESET
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
			Winn = 0
		Case TOOL_ADD
			T = ReAllocate(T,SizeOf(TOOL)*(NT+1))
			T[NT].PosiX = 0
			T[NT].PosiY = 0
			T[NT].Radius = 60
			T[NT].ColorR = 1
			T[NT].ColorG = 1
			T[NT].ColorB = 1
			T[NT].Grad = 0
			T[NT].over = 0
			T[NT].count = 1
			CalcPosis(@T[NT])
			NT += 1
			Return NT
		Case TOOL_SET
			If P2 = 0 Then
				Select Case LCase(*Cast(ZString Ptr,P3))
					Case "win"
						winn = P4
				End Select
			EndIf
			If P2 < 1 Or P2 > NT Then Return FALSE
			Dim R As Integer = P2-1
			Select Case LCase(*Cast(ZString Ptr,P3))
				Case "posix"
					T[r].PosiX = P4
					CalcPosis(@T[r])
				Case "posiy"
					T[r].PosiY = P4
					CalcPosis(@T[r])
				Case "radius"
					T[r].Radius = P4
					CalcPosis(@T[r])
				Case "grad"
					T[r].Grad = P4
					CalcPosis(@T[r])
				Case "colorr"
					T[r].ColorR = P4/255
				Case "colorg"
					T[r].ColorG = P4/255
				Case "colorb"
					T[r].ColorB = P4/255
			End Select
		Case TOOL_GET
			Select Case LCase(*Cast(ZString Ptr,P2))
				Case "name"
					Return Cast(Integer,StrPtr(ToolName))
				Case "numparam"
					Return 7
				Case "param1"
					Return Cast(Integer,StrPtr("PosiX"))
				Case "param2"
					Return Cast(Integer,StrPtr("PosiY"))
				Case "param3"
					Return Cast(Integer,StrPtr("Radius"))
				Case "param4"
					Return Cast(Integer,StrPtr("Grad"))
				Case "param5"
					Return Cast(Integer,StrPtr("ColorR"))
				Case "param6"
					Return Cast(Integer,StrPtr("ColorG"))
				Case "param7"
					Return Cast(Integer,StrPtr("ColorB"))
				Case Else
					If P3 < 1 Or P3 > NT Then Return NULL
					Dim R As Integer = P3-1
					Select Case LCase(*Cast(ZString Ptr,P2))
						Case "posix"
							Return T[r].PosiX
						Case "posiy"
							Return T[r].PosiY
						Case "radius"
							Return T[r].Radius
						Case "grad"
							Return T[r].Grad
						Case "colorr"
							Return T[r].ColorR*255
						Case "colorg"
							Return T[r].ColorG*255
						Case "colorb"
							Return T[r].ColorB*255
						Case Else
							Return NULL
					End Select
			End Select
		Case TOOL_PAINT_STATICS
			For i As Integer = 0 To NT-1
				DrawObj(@T[i])
			Next
		Case Else
			Return FALSE
	End Select
	Return TRUE
End Function