#Include "GL/gl.bi"

Const ToolName = "Magnet_Richtung"

#Include "Tool.bi"

Type TOOL
	PosiX As Integer
	PosiY As Integer
	Radius As Integer
	Grad As Integer
	Power As Integer
	LTime As Double
	over As Integer
	count As Single
End Type

Dim Shared NT As Integer
Dim Shared T As TOOL Ptr
Dim Shared Winn As Integer
Dim Shared Transp As Single
Dim Shared ToolPaint As ToolPaintSub

Sub DrawObj ( ByVal tool As TOOL Ptr, ByVal m As FRAMEMOUSE Ptr, ByVal Tex As UInteger )
	Dim As MAIN_TOOL mTool
	mTool.posiX = tool->PosiX
	mTool.posiY = tool->PosiY
	mTool.radius = tool->Radius
	mTool.grad = tool->Grad
	mTool.light = 0
	mTool.r = 0
	mTool.g = 0
	mTool.b = 0
	mTool.transp = Transp
	mTool.count = @tool->count
	mTool.whatOver = tool->over
	mTool.image = Tex
	ToolPaint(@mTool,m)
End Sub

Function Main ( ByVal P1 As Integer, ByVal P2 As Integer, ByVal P3 As Integer, ByVal P4 As Integer ) As Integer Export
	Select Case P1
		Case TOOL_DESTROY
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
		Case TOOL_INIT
			Nt = 0
			T = 0
		Case TOOL_UPDATE
			Dim NP As Integer
			Dim P As PARTICLE Ptr
			Dim G As Integer
			Dim Ent As Integer
			Dim Entalt As Integer
			Dim RQ As Integer
			Dim As Single XV,YV
			Dim As Double TT
			Dim As FRAMEMOUSE Ptr M
			M = Cast(FRAMEMOUSE Ptr,P2)
			If winn Then 
				Transp -= 0.02
				If Transp < 0 Then Transp = 0
			Else
				Transp = 1
			EndIf
			For i As Integer = 0 To NT-1
				If T[i].LTime = 0 Then T[i].LTime = Timer
				TT = Timer-T[i].LTime
				P = *Cast(PARTICLE Ptr Ptr,P3)
				RQ = T[i].Radius^2
				XV = Sin(T[i].Grad*3.141/180)*T[i].Power*10
				YV = Cos(T[i].Grad*3.141/180)*T[i].Power*10
				If M->Dis = @T[i] Then
					If T[i].over = 1 Then
						T[i].PosiX += M->X-M->XA
						T[i].PosiY += M->Y-M->YA
					ElseIf T[i].over = 2 Then
						T[i].Radius = ((M->X-T[i].PosiX)^2+(M->Y-T[i].PosiY)^2)^0.5
						If T[i].Radius < 30 Then T[i].Radius = 30
						If T[i].Radius > 200 Then T[i].Radius = 200
					EndIf
				Else
					MouseOverPosi(M,T[i].PosiX,T[i].PosiY,T[i].Radius,@T[i].over,@T[i])
				EndIf
				Do Until P = 0
					Ent = (T[i].PosiX-P->PosiX)^2+(T[i].PosiY-P->PosiY)^2
					If Ent <= RQ Then
						P->VectorX += XV*TT
						P->VectorY += YV*TT
					EndIf
					P = P->Next
				Loop
				T[i].LTime = Timer
			Next
		Case TOOL_RESET
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
			Winn = 0
		Case TOOL_ADD
			T = ReAllocate(T,SizeOf(TOOL)*(NT+1))
			T[NT].PosiX = 0
			T[NT].PosiY = 0
			T[NT].Radius = 60
			T[NT].Grad = 0
			T[NT].Power = 100
			T[NT].LTime = 0
			T[NT].over = 0
			T[NT].count = 2
			NT += 1
			Return NT
		Case TOOL_SET
			If P2 = 0 Then
				Select Case LCase(*Cast(ZString Ptr,P3))
					Case "win"
						winn = P4
					Case "toolpaint"
						ToolPaint = Cast(ToolPaintSub,P4)
				End Select
			EndIf
			If P2 < 1 Or P2 > NT Then Return FALSE
			Dim R As Integer = P2-1
			Select Case LCase(*Cast(ZString Ptr,P3))
				Case "posix"
					T[r].PosiX = P4
				Case "posiy"
					T[r].PosiY = P4
				Case "radius"
					T[r].Radius = P4
				Case "grad"
					T[r].Grad = P4
				Case "power"
					T[r].Power = P4
			End Select
		Case TOOL_GET
			Select Case LCase(*Cast(ZString Ptr,P2))
				Case "name"
					Return Cast(Integer,StrPtr(ToolName))
				Case "texture"
					Return Cast(Integer,StrPtr("Magnet_Richtung.bmp"))
				Case "numparam"
					Return 5
				Case "param1"
					Return Cast(Integer,StrPtr("PosiX"))
				Case "param2"
					Return Cast(Integer,StrPtr("PosiY"))
				Case "param3"
					Return Cast(Integer,StrPtr("Radius"))
				Case "param4"
					Return Cast(Integer,StrPtr("Grad"))
				Case "param5"
					Return Cast(Integer,StrPtr("Power"))
				Case Else
					If P3 < 1 Or P3 > NT Then Return NULL
					Dim R As Integer = P3-1
					Select Case LCase(*Cast(ZString Ptr,P2))
						Case "posix"
							Return T[r].PosiX
						Case "posiy"
							Return T[r].PosiY
						Case "radius"
							Return T[r].Radius
						Case "grad"
							Return T[r].Grad
						Case "power"
							Return T[r].Power
						Case Else
							Return NULL
					End Select
			End Select
		Case TOOL_PAINT_ENABLED
			Dim As FRAMEMOUSE Ptr M
			M = Cast(FRAMEMOUSE Ptr,P2)
			For i As Integer = 0 To NT-1
				If M->Over <> @T[i] Then DrawObj(@T[i],M,P4)
			Next
		Case TOOL_PAINT_SELECTS
			Dim As FRAMEMOUSE Ptr M
			M = Cast(FRAMEMOUSE Ptr,P2)
			For i As Integer = 0 To NT-1
				If M->Over = @T[i] Then DrawObj(@T[i],M,P4)
			Next
		Case Else
			Return FALSE
	End Select
	Return TRUE
End Function
