Const ToolName = "Maker"

#Include "Tool.bi"

Type TOOL
	PosiX As Integer
	PosiY As Integer
	Radius As Integer
	Grad As Integer
	Power As Integer
	LTime As Double
End Type

Dim Shared NT As Integer
Dim Shared T As TOOL Ptr

Function Main ( ByVal P1 As Integer, ByVal P2 As Integer, ByVal P3 As Integer, ByVal P4 As Integer ) As Integer Export
	Select Case P1
		Case TOOL_DESTROY
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
		Case TOOL_INIT
			Nt = 0
			T = 0
		Case TOOL_UPDATE
			Dim NP As Integer
			Dim NewP As PARTICLE Ptr
			Dim G As Integer
			Dim R As Integer
			For i As Integer = 0 To NT-1
				If T[i].LTime = 0 Then 
					T[i].LTime = Timer
				EndIf
				NP = (Timer - T[i].LTime)*10 
				If NP > 0 Then
					For j As Integer = 1 To NP
						G = Rnd*360
						R = T[i].Radius*Rnd
						NewP = Allocate(SizeOf(PARTICLE))
						NewP->PosiX = Sin(G*3.141/180)*R+T[i].PosiX
						NewP->PosiY = Cos(G*3.141/180)*R+T[i].PosiY
						NewP->PosiXA = NewP->PosiX
						NewP->PosiYA = NewP->PosiY
						NewP->VectorX = Sin(T[i].Grad*3.141/180)*T[i].Power
						NewP->VectorY = Cos(T[i].Grad*3.141/180)*T[i].Power
						NewP->Alter = 20
						NewP->ColorR = 1
						NewP->ColorG = 1
						NewP->ColorB = 1
						NewP->TimeUderSpeedLimit = 0
						NewP->NoVerschub = 0
						NewP->Next = *Cast(PARTICLE Ptr Ptr, P3)
						*Cast(PARTICLE Ptr Ptr, P3) = NewP
					Next
					T[i].LTime = Timer
				EndIf
				
			Next
		Case TOOL_RESET
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
		Case TOOL_ADD
			T = ReAllocate(T,SizeOf(TOOL)*(NT+1))
			T[NT].PosiX = 0
			T[NT].PosiY = 0
			T[NT].Radius = 20
			T[NT].Grad = 0
			T[NT].Power = 400
			T[NT].LTime = 0
			NT += 1
			Return NT
		Case TOOL_SET
			If P2 < 1 Or P2 > NT Then Return FALSE
			Dim R As Integer = P2-1
			Select Case LCase(*Cast(ZString Ptr,P3))
				Case "posix"
					T[r].PosiX = P4
				Case "posiy"
					T[r].PosiY = P4
				Case "radius"
					T[r].Radius = P4
				Case "grad"
					T[r].Grad = P4
				Case "power"
					T[r].Power = P4
			End Select
		Case TOOL_GET
			Select Case LCase(*Cast(ZString Ptr,P2))
				Case "name"
					Return Cast(Integer,StrPtr(ToolName))
				Case "numparam"
					Return 5
				Case "param1"
					Return Cast(Integer,StrPtr("PosiX"))
				Case "param2"
					Return Cast(Integer,StrPtr("PosiY"))
				Case "param3"
					Return Cast(Integer,StrPtr("Radius"))
				Case "param4"
					Return Cast(Integer,StrPtr("Grad"))
				Case "param5"
					Return Cast(Integer,StrPtr("Power"))
				Case Else
					If P3 < 1 Or P3 > NT Then Return NULL
					Dim R As Integer = P3-1
					Select Case LCase(*Cast(ZString Ptr,P2))
						Case "posix"
							Return T[r].PosiX
						Case "posiy"
							Return T[r].PosiY
						Case "radius"
							Return T[r].Radius
						Case "grad"
							Return T[r].Grad
						Case "power"
							Return T[r].Power
						Case Else
							Return NULL
					End Select
			End Select
		Case Else
			Return FALSE
	End Select
	Return TRUE
End Function
