#Include "gl/gl.bi"

Const ToolName = "Ziel"

#Include "Tool.bi"

Type TOOL
	PosiX As Integer
	PosiY As Integer
	Radius As Integer
	ColorR As Single
	ColorG As Single
	ColorB As Single
	Power As Single
	LTime As Double
	LP As Double
	Channals As UInteger
End Type

Dim Shared NT As Integer
Dim Shared T As TOOL Ptr
Dim Shared Winn As Integer
Dim Shared Transp As Single

Dim Shared MusicVol As Single Ptr

Sub DrawFin ( ByVal TT As TOOL Ptr )
	glEnable(GL_BLEND)
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	glColor4f(0,0,0,0.4*Transp)
	glBegin(GL_QUADS)
	glVertex2f(TT->PosiX-32,TT->PosiY-32)
	glVertex2f(TT->PosiX-32,TT->PosiY+32)
	glVertex2f(TT->PosiX+32,TT->PosiY+32)
	glVertex2f(TT->PosiX+32,TT->PosiY-32)
	glEnd()
	
	For i As Integer = 0 To 8
		
		glColor4f(TT->ColorR,TT->ColorG,TT->ColorB,0.8*Transp)
		If TT->Power < (i+1)/9 Then glColor4f(TT->ColorR,TT->ColorG,TT->ColorB,0.2*Transp)
		
		glBegin(GL_QUADS)
		glVertex2f(TT->PosiX-30,TT->PosiY-31+i*7)
		glVertex2f(TT->PosiX-30,TT->PosiY-26+i*7)
		glVertex2f(TT->PosiX+30,TT->PosiY-26+i*7)
		glVertex2f(TT->PosiX+30,TT->PosiY-31+i*7)
		glEnd()
	Next
	glDisable(GL_BLEND)
End Sub

Sub DrawLight ( ByVal TT As TOOL Ptr )
	If TT->Power=1 Then
		glEnable(GL_BLEND)
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
		glColor4f(TT->ColorR,TT->ColorG,TT->ColorB,0.5*Transp)
		glBegin(GL_QUADS)
		glVertex2f(TT->PosiX-30,TT->PosiY-30)
		glVertex2f(TT->PosiX-30,TT->PosiY+30)
		glVertex2f(TT->PosiX+30,TT->PosiY+30)
		glVertex2f(TT->PosiX+30,TT->PosiY-30)
		glEnd()
		glDisable(GL_BLEND)
	EndIf
End Sub

Function Main ( ByVal P1 As Integer, ByVal P2 As Integer, ByVal P3 As Integer, ByVal P4 As Integer ) As Integer Export
	Select Case P1
		Case TOOL_DESTROY
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
		Case TOOL_INIT
			Nt = 0
			T = 0
		Case TOOL_UPDATE
			Dim P As PARTICLE Ptr
			Dim NP As PARTICLE Ptr
			Dim Ent As Integer
			Dim Entalt As Integer
			Dim RQ As Integer
			Dim NTime As Double = Timer
			Dim win As Integer = -1
			If winn Then
				transp -= 0.02
				If transp < 0 Then transp = 0
			Else
				transp = 1
			EndIf
			For i As Integer = 0 To NT-1
				If T[i].LTime = 0 Then T[i].LTime = NTime
				P = *Cast(PARTICLE Ptr Ptr,P3)
				RQ = T[i].Radius^2
				Do Until P = 0
					Ent = (T[i].PosiX-P->PosiX)^2+(T[i].PosiY-P->PosiY)^2
					Entalt = (T[i].PosiX-P->PosiXA)^2+(T[i].PosiY-P->PosiYA)^2
					If (Ent <= RQ  And Entalt > RQ) Then
						If T[i].ColorR = P->ColorR And T[i].ColorG = P->ColorG And T[i].ColorB = P->ColorB Then
							T[i].Power += 0.02
							T[i].LP = NTime
						EndIf
					EndIf
					P = P->Next
				Loop
				If T[i].LP+2 < NTime Then
					T[i].Power -= (NTime-T[i].LTime)*2
				EndIf
				If T[i].Power > 1 Then T[i].Power = 1
				If T[i].Power < 0 Then T[i].Power = 0
				If T[i].Power <> 1 Then 
					win = 0
				EndIf
				For j As Integer = 0 To 15
					If (T[i].Channals And (1 Shl j)) Then
						MusicVol[j]=T[i].Power
					EndIf
				Next
				T[i].LTime = NTime
			Next
			Return win
		Case TOOL_RESET
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
			winn = 0
		Case TOOL_ADD
			T = ReAllocate(T,SizeOf(TOOL)*(NT+1))
			T[NT].PosiX = 0
			T[NT].PosiY = 0
			T[NT].Radius = 40
			T[NT].ColorR = 1
			T[NT].ColorG = 1
			T[NT].ColorB = 1
			T[NT].Power = 0
			T[NT].LTime = 0
			T[NT].Channals = 0
			NT += 1
			Return NT
		Case TOOL_SET
			If P2 = 0 Then
				Select Case LCase(*Cast(ZString Ptr,P3))
					Case "win"
						winn = P4
					Case "music"
						MusicVol = Cast(Single Ptr,P4)
				End Select	
			EndIf
			If P2 < 1 Or P2 > NT Then Return FALSE
			Dim R As Integer = P2-1
			Select Case LCase(*Cast(ZString Ptr,P3))
				Case "posix"
					T[r].PosiX = P4
				Case "posiy"
					T[r].PosiY = P4
				Case "radius"
					T[r].Radius = P4
				Case "colorr"
					T[r].ColorR = P4/255
				Case "colorg"
					T[r].ColorG = P4/255
				Case "colorb"
					T[r].ColorB = P4/255
				Case "channel"
					T[r].Channals = P4
			End Select
		Case TOOL_GET
			Select Case LCase(*Cast(ZString Ptr,P2))
				Case "name"
					Return Cast(Integer,StrPtr(ToolName))
				Case "numparam"
					Return 7
				Case "param1"
					Return Cast(Integer,StrPtr("PosiX"))
				Case "param2"
					Return Cast(Integer,StrPtr("PosiY"))
				Case "param3"
					Return Cast(Integer,StrPtr("Radius"))
				Case "param4"
					Return Cast(Integer,StrPtr("ColorR"))
				Case "param5"
					Return Cast(Integer,StrPtr("ColorG"))
				Case "param6"
					Return Cast(Integer,StrPtr("ColorB"))
				Case "param7"
					Return Cast(Integer,StrPtr("Channel"))
				Case Else
					If P3 < 1 Or P3 > NT Then Return NULL
					Dim R As Integer = P3-1
					Select Case LCase(*Cast(ZString Ptr,P2))
						Case "posix"
							Return T[r].PosiX
						Case "posiy"
							Return T[r].PosiY
						Case "radius"
							Return T[r].Radius
						Case "colorr"
							Return T[r].ColorR*255
						Case "colorg"
							Return T[r].ColorG*255
						Case "colorb"
							Return T[r].ColorB*255
						Case "channel"
							Return T[r].Channals
						Case Else
							Return NULL
					End Select
			End Select
		Case TOOL_PAINT_STATICS
			For i As Integer = 0 To NT-1
				DrawFin(@T[i])
			Next
		Case TOOL_PAINT_LIGHT
			For i As Integer = 0 To NT-1
				DrawLight(@T[i])
			Next
		Case Else
			Return FALSE
	End Select
	Return TRUE
End Function
