#Include "GL/gl.bi"

Const ToolName = "divide"

#Include "Tool.bi"

Type TOOL
	PosiX As Integer
	PosiY As Integer
	Radius As Integer
	over As Integer
	count As Single
End Type

Dim Shared NT As Integer
Dim Shared T As TOOL Ptr
Dim Shared Winn As Integer
Dim Shared Transp As Single

Function OverLine ( ByVal p1x As Single, ByVal p1y As Single, ByVal p2x As Single, ByVal p2y As Single, ByVal p3x As Single, ByVal p3y As Single ) As Integer
	Return Sgn((p3x-p2x)*(p2y-p1y)+(p3y-p2y)*(p1x-p2x))
End Function

Sub DrawCircle ( ByVal x As Integer, ByVal y As Integer, ByVal radius As Integer )
	glBegin(GL_TRIANGLES)
	Dim As Single P,X1,Y1,X2,Y2
	P = 360/radius
	For i As Integer = 0 To radius-1
		X1 = Sin(i*P*3.141/180)
		Y1 = cos(i*P*3.141/180)
		X2 = Sin((i+1)*P*3.141/180)
		Y2 = cos((i+1)*P*3.141/180)
		glColor4f(1,1,1,Transp)
		glvertex2f(X1*radius+x,Y1*radius+y)
		glvertex2f(X2*radius+x,Y2*radius+y)
		glColor4f(0,0,0,Transp)
		glvertex2f(x,y)
	Next
	glEnd()
End Sub

Sub DrawObj ( ByVal tool As TOOL Ptr )
	glEnable(GL_BLEND)
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	DrawCircle(tool->PosiX, tool->PosiY, 10)
	glDisable(GL_BLEND)
End Sub

Function Main ( ByVal P1 As Integer, ByVal P2 As Integer, ByVal P3 As Integer, ByVal P4 As Integer ) As Integer Export
	Select Case P1
		Case TOOL_DESTROY
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
		Case TOOL_INIT
			Nt = 0
			T = 0
		Case TOOL_UPDATE
			Dim NP As Integer
			Dim P As PARTICLE Ptr
			Dim G As Integer
			Dim Ent As Integer
			Dim Entalt As Integer
			Dim RQ As Integer
			Dim As Single XV,YV,N
			Dim As Single grad
			If winn Then 
				Transp -= 0.02
				If Transp < 0 Then Transp = 0
			Else
				Transp = 1
			EndIf
			For i As Integer = 0 To NT-1
				P = *Cast(PARTICLE Ptr Ptr,P3)
				RQ = T[i].Radius^2
				Do Until P = 0
					Ent = (T[i].PosiX-P->PosiX)^2+(T[i].PosiY-P->PosiY)^2
					Entalt = (T[i].PosiX-P->PosiXA)^2+(T[i].PosiY-P->PosiYA)^2
					If Ent <= RQ And Entalt > RQ Then
						grad = ATan2(P->PosiYA-P->PosiY, P->PosiXA-P->PosiX)*180/3.141
						N = Sqr(P->VectorX*P->VectorX+P->VectorY*P->VectorY)
						If ( OverLine ( P->PosiX, P->PosiY, P->PosiXA, P->PosiYA, T[i].PosiX, T[i].PosiY )>0 ) Then
							grad += 120
						Else
							grad -= 120
						EndIf
						P->VectorX = Cos(grad*3.141/180)*N
						P->VectorY = Sin(grad*3.141/180)*N
					EndIf
					P = P->Next
				Loop
			Next
		Case TOOL_RESET
			If T Then DeAllocate(T)
			T = 0 
			Nt = 0
			Winn = 0
		Case TOOL_ADD
			T = ReAllocate(T,SizeOf(TOOL)*(NT+1))
			T[NT].PosiX = 0
			T[NT].PosiY = 0
			T[NT].Radius = 20
			T[NT].over = 0
			T[NT].count = 1
			NT += 1
			Return NT
		Case TOOL_SET
			If P2 = 0 Then
				Select Case LCase(*Cast(ZString Ptr,P3))
					Case "win"
						winn = P4
				End Select
			EndIf
			If P2 < 1 Or P2 > NT Then Return FALSE
			Dim R As Integer = P2-1
			Select Case LCase(*Cast(ZString Ptr,P3))
				Case "posix"
					T[r].PosiX = P4
				Case "posiy"
					T[r].PosiY = P4
				Case "radius"
					T[r].Radius = P4
			End Select
		Case TOOL_GET
			Select Case LCase(*Cast(ZString Ptr,P2))
				Case "name"
					Return Cast(Integer,StrPtr(ToolName))
				Case "numparam"
					Return 3
				Case "param1"
					Return Cast(Integer,StrPtr("PosiX"))
				Case "param2"
					Return Cast(Integer,StrPtr("PosiY"))
				Case "param3"
					Return Cast(Integer,StrPtr("Radius"))
				Case Else
					If P3 < 1 Or P3 > NT Then Return NULL
					Dim R As Integer = P3-1
					Select Case LCase(*Cast(ZString Ptr,P2))
						Case "posix"
							Return T[r].PosiX
						Case "posiy"
							Return T[r].PosiY
						Case "radius"
							Return T[r].Radius
						Case Else
							Return NULL
					End Select
			End Select
		Case TOOL_PAINT_STATICS
			For i As Integer = 0 To NT-1
				DrawObj(@T[i])
			Next
		Case Else
			Return FALSE
	End Select
	Return TRUE
End Function