

'###################################
' Regatta Mod for TileCity  
' Version 1.00 by Aleatorylamp, with 
' support by oog / proog.de May/2012  
'###################################

'message max 16 characters
Const modcopyright="Aleatorylamp mod"


' Sailboat and 3-wheeled Landyacht.
' Controls:
'  left/right cursor keys or right/left on left joystick: Steering. 
'    up/down  cursor keys or fore/back on right joystick: Let out / Pull in Sail.
'  Catch the wind to start moving by turning the rudder, or pull in or let out
'  the sail. Follow a zig-zag path to travel a course directly against the wind.
'  Wind instrument needles show direction of relative and apparent winds,
'  as well as sailboom position - colour indicates sail efficiency:
'    Light blue: optimal laminar flow, most efficient (10-15 wind incidence on sail)
'    Yellow    : laminar flow, quite efficient (16-25 wind incidence on sail)
'    Red       : Wind only pushes sail
'    Grey      : Sail loose in the wind (no push)
'  At angles very close to the wind, despite optimal laminar flow, push vector is too
'  small to move the vehicle, so turn away from the wind a little.
'
' Aerostatic balloon.
' Controls: 
'     up/down  cursor arrows or joystick firing buttons    : Rise/descend. 
'   left/right cursor arrows or right/left on left joystick: Turn to look around.
'  The balloon travels with the wind. At different altitudes, wind changes direction, 
'  and slowly the balloon will follow. This makes navigation possible to a certain degree.
'  Wind instrument shows relative wind.
'
' y yacht
' l landyacht
' a aerostatic balloon (hot air balloon)
'
' Variables for Sailing Yacht and Landyacht
Dim Shared As Single Heading
Dim Shared As Double Pi
pi=3.14159265
Dim Shared As Integer relwind
Dim Shared As Double aapwind
Dim Shared As Single vapwind
Dim Shared As Integer tk
Dim Shared As Integer boomangle
Boomangle=15
Dim Shared As Integer boomang
Dim Shared As Integer boomcolr
Dim Shared As Integer boomcolg
Dim Shared As Integer boomcolb
Dim Shared As Single sil
Dim Shared As Single difang
Dim Shared As Single ve
Dim Shared As Double sefi
Dim Shared As Double fsail
Dim Shared As Double res
Dim Shared As Double prop
Dim shared As Single ins
Dim Shared As Double vay
Dim Shared As Double vax
Dim Shared As Single heel
Dim Shared As Single pitch
Dim Shared As Single shk
Dim Shared As Single WSpeed
Dim Shared As Single WAngle
Dim Shared As Single WAng 

'SAIL EFFICIENCY depending on angle of incidence 
'of wind on sail for sailing yacht and landyacht
Dim Shared As integer se(180)
Dim As Integer Ang
Dim As Integer in
Restore incidence
FOR in = 1 TO 180
READ Ang
se(in) = Ang
Next in
incidence:
DATA 0,0,0,0,0,0,0,0,0,0
DATA 80,81,83,85,87,89,91,93,95,97
DATA 98,99,100,99,98,97,70,70,70,70
DATA 70,70,70,70,70,70,70,70,70,70
DATA 70,70,70,70,70,70,71,71,72,72
DATA 73,73,74,74,75,75,75,75,75,75
DATA 75,75,75,75,75,75,75,75,75,75
DATA 75,75,75,75,75,75,75,75,75,75
DATA 75,76,77,78,79,80,80,80,80,80
DATA 79,78,77,76,75,74,73,72,71,70
DATA 69,68,67,66,65,64,63,62,61,60
DATA 59,58,57,56,55,54,53,52,51,50
DATA 49,48,47,46,45,44,43,42,41,40
DATA 39,38,37,36,35,34,33,32,31,30
DATA 29,28,27,26,25,24,23,22,21,20
DATA 19,18,17,16,15,14,13,12,11,10
DATA 9,8,7,6,5,4,3,2,1,0
DATA 0,0,0,0,0,0,0,0,0,0,0

'SHIP RESISTANCE - Heeling and pitching 
'factor for sailing yacht only.
Dim Shared As integer rsf(180)
Restore Resistance
FOR in = 1 TO 180
READ ang
rsf(in) = ang
Next in
Resistance:
DATA 100,100,100,100,100,100,100,100,100,100
DATA 100,100,100,100,100,100,100,100,100,100
DATA 100,100,100,100,100,100,100,100,100,98
DATA 98,99,99,100,100,101,102,103,103,104
DATA 104,104,104,104,104,105,105,105,105,105
DATA 106,106,107,107,108,108,109,109,110,110
DATA 109,109,108,108,107,107,106,106,105,105
DATA 104,103,102,101,100,98,96,94,92,90
DATA 88,86,84,84,84,84,83,81,79,77
DATA 78,80,83,86,89,92,95,98,101,104
DATA 106,108,110,112,114,116,118,120,122,124
DATA 126,129,132,135,138,140,142,144,146,148
DATA 150,152,154,156,158,160,162,164,166,168
DATA 167,167,166,166,165,165,164,164,163,162
DATA 159,156,152,148,143,138,133,128,124,120
DATA 117,114,111,108,105,102,100,98,96,94
DATA 92,90,88,86,84,82,80,78,77,76
DATA 75,71,68,65,64,63,62,61,61,60

For in = 1 TO 180
rsf(in) = rsf(in) / 4000 * in
NEXT in

'new parts for Sailing yacht, Landyacht and Aerostatic balloon
Dim Shared As Any Ptr playerMast
Dim Shared As Any Ptr playerRudder
Dim Shared As Any Ptr playerSail
Dim Shared As Any Ptr playerSail2
Dim Shared As Any Ptr playerSailMast
Dim Shared As Any Ptr playerSailMast2
Dim Shared As Any Ptr playerBalloon
Dim Shared As Any Ptr playerBasket


#macro TCMod_Texture()
  Dim Shared As TileImage Sail2Tex
  Dim Shared As TileImage BalloonTex
  Dim Shared As Any Ptr OhdWind, OhdWindTex
  Dim Shared As Any Ptr OhdRWind, OhdRWindTex
  Dim Shared As Any Ptr OhdBoom, OhdBoomTex
#endmacro


#macro TCMod_LoadTexture()
  LoadTileTex("sail2.bmp",Sail2Tex)
  LoadTileTex("Balloon.bmp",BalloonTex)
#endmacro


#macro TCMod_CreatePlayer()
  playerSailMast=CreatePivot(playerModel)
  PositionEntity playerSailMast, 0, 0, 1.4
  playerSail=CreateSail(playerSailMast)
  EntityTexture playerSail,SailTex.tex
  EntityAlpha playerSail,0.8
  ScaleEntity playerSail,1.4,3.2,1
  PositionEntity playerSail, 0, 2.2, -1.4
  RotateEntity playerSail, 0, 270, 0
  
  playerSailMast2=CreatePivot(playerModel)
  PositionEntity playerSailMast2, 0, 0, 1.4
  playerSail2=CreateSail(playerSailMast2)
  EntityTexture playerSail2,Sail2Tex.tex
  EntityAlpha playerSail2,0.8
  ScaleEntity playerSail2,1.4,3.2,1
  PositionEntity playerSail2, 0, 2.2, -1.4
  RotateEntity playerSail2, 0, 270, 0
     
  playerBalloon=CreateSphere(,playerModel)
  EntityTexture playerBalloon,BalloonTex.tex
  EntityAlpha playerBalloon,0.8
  ScaleEntity playerBalloon,3,2.5,3
  MoveEntity playerBalloon,0,4,0

  playerBasket=CreateCylinder(,,playerModel)
  EntityColor playerBasket,10,10,100
  ScaleEntity playerBasket,0.8,0.8,0.8
  MoveEntity playerBasket,0,-1.2,0
  
  playerRudder=CreateCube(playerModel)
  EntityColor playerRudder,100,100,100
  ScaleEntity playerRudder,0.1,0.1,0.4
  MoveEntity playerRudder,0,-0.9,-2.5
#endmacro


'######################################
'## Wind Instrument - over head display
'######################################

#macro TCMod_OHD()

Sub OhdWindInit
  OhdWind=CreateSprite(cam)
  MoveEntity OhdWind,0.82,.08,1.1
  ScaleSprite OhdWind,0.23,0.23
  OhdWindTex=CreateTexture(128,128,4,1)
  EntityTexture OhdWind,OhdWindTex
  EntityAlpha OhdWind, 0.5  
End Sub


Sub OhdWindShow    
  'Blue Wind marker shows Apparent Wind for Yacht and Landyacht. 
  Line Img128,(0,0)-(127,127),0,BF               'fill img black (invisible)
 
  If InStr("lya",pm) Then   
    Circle Img128,(63,63),46,RGB(200,100,100),,,,F 'round instrument background
    If "a"<> pm Then Line Img128,(62,19)-(65,33),RGB(200,1,1),BF 'Apparent Wind marker      
  End If
  BufferToTex OhdWindTex,Img128+32,1
 
  If InStr("ly",pm) Then
    RotateSprite OhdWind,-Aapwind         'rotate sprite as per Apparent Wind
  End If
End Sub


Sub OhdRWindInit
  OhdRWind=CreateSprite(cam)
  MoveEntity OhdRWind,0.82,.08,1.1
  ScaleSprite OhdRWind,0.23,0.23
  OhdRWindTex=CreateTexture(128,128,4,1)
  EntityTexture OhdRWind,OhdRWindTex
  EntityAlpha OhdRWind, 0.5  
End Sub


Sub OhdRWindShow    
  'White Wind marker shows Relative for Yacht, Landyacht and Balloon. 
  Line Img128,(0,0)-(127,127),0,BF               'fill img black (invisible)
 
  If InStr("lya",pm) Then 
    Circle Img128,(63,63),32,RGB(100,50,50),,,,F 'inner round instrument background
    Line Img128,(62,19)-(65,33),RGB(220,220,220),BF 'Relative Wind marker   
  End If
  BufferToTex OhdRWindTex,Img128+32,1
 
  If InStr("lya",pm) Then
    RotateSprite OhdRWind,-Relwind        'rotate sprite as per Relative Wind 
  End If
End Sub


Sub OhdBoomInit
  OhdBoom=CreateSprite(cam)
  MoveEntity OhdBoom,0.82,.08,1.1
  ScaleSprite OhdBoom,0.23,0.23
  OhdBoomTex=CreateTexture(128,128,4,1)
  EntityTexture OhdBoom,OhdBoomTex
  EntityAlpha OhdBoom, 0.5  
End Sub


Sub OhdBoomShow    
  'Boom marker Sail Boom position Yacht and Landyacht.
  'Colours: Light blue: Sail is in laminar flow.
  '                Red: Wind is only pushing sail.
  '               Grey: Sail is loose in the wind. 
  Line Img128,(0,0)-(127,127),0,BF               'fill img black (invisible)
 
  If InStr("ly",pm) Then   
   Line Img128,(62,33)-(65,63),RGB(boomcolr,boomcolg,boomcolb),BF 'Boom Angle marker 
   Circle Img128,(63,63),5,RGB(boomcolr,boomcolg,boomcolb),,,,F   
  End If
  BufferToTex OhdBoomTex,Img128+32,1
 
  If InStr("ly",pm) Then
   RotateSprite OhdBoom,Boomang-180       'rotate sprite as per Boom Angle 
  End If
End Sub
#endmacro


#macro TCMod_SwitchVehicleInit()
  ' y yacht
  ' l landyacht
  ' a aerostat (hot air balloon)
  PositionEntity playerhead,0,0.4,0
  PositionEntity playerWheelFL,-1.5,-1.5,1.8
#endmacro


#macro TCMod_SwitchVehicleHide()
  HideEntity playerBalloon
  HideEntity playerBasket
  HideEntity playerSailMast 
  HideEntity playerSailMast2      
  HideEntity playerRudder
#endmacro


#macro TCMod_SwitchVehicleNew()
  Case "y":
    pm=v: MaxSpeedF=40.0: MaxSpeedR=10.0: AccF=0.3: AccR=0.2
    PositionEntity playerModel,0,0,0
    PositionEntity playerbody,0,-0.5,-2
    PositionEntity playerhead,0,0.35,-2
    RotateEntity playerbody,0,0,0
    ShowEntity playerShip
    HideEntity playerBalloon
    HideEntity playerBasket
    ShowEntity playerSailMast
    HideEntity playerSailMast2
    ShowEntity playerRudder
    HideEntity playerMotor
    HideEntity playerRotor
    HideEntity playerJetPack
    HideEntity playerWingL
    HideEntity playerWingR
    HideEntity playerWheelFL
    HideEntity playerWheelFR
    HideEntity playerWheelRL
    HideEntity playerWheelRR
    playerCamY0=1
    playerCamZ0=2
    playerCamY=1
    playerCamZ=2
    Gravity=-1
    If talk Then eSpeak.Speak("sailing yacht")
  
  Case "l":
    pm=v: MaxSpeedF=150.0: MaxSpeedR=70.0: AccF=0.5: AccR=0.4
    PositionEntity playerModel,0,0,0
    PositionEntity playerbody,0,-0.5,-1.5
    PositionEntity playerWheelFL,0,-1.5,2.8
    PositionEntity playerhead,0,0.4,-1.5
    RotateEntity playerbody,0,0,0
    ShowEntity playerShip
    HideEntity playerBalloon
    HideEntity playerBasket
    ShowEntity playerSailMast2
    HideEntity playerSailMast
    HideEntity playerRudder
    HideEntity playerMotor
    HideEntity playerRotor
    HideEntity playerJetPack
    HideEntity playerWingL
    HideEntity playerWingR
    ShowEntity playerWheelFL
    HideEntity playerWheelFR
    ShowEntity playerWheelRL
    ShowEntity playerWheelRR
    playerCamY0=1.5
    playerCamZ0=2
    playerCamY=1
    playerCamZ=3
    Gravity=-1
    If talk Then eSpeak.Speak("landyacht")
  
 Case "a":
    pm=v: MaxSpeedF=70.0: MaxSpeedR=20.0: AccF=1: AccR=0.5
    PositionEntity playerModel,0,0,0
    PositionEntity playerbody,0,-0.5,0
    RotateEntity playerbody,0,0,0
    hideEntity playerShip
    ShowEntity playerBalloon
    ShowEntity playerBasket
    HideEntity playerSailMast
    HideEntity playerSailMast2
    HideEntity playerRudder
    HideEntity playerMotor
    HideEntity playerRotor
    HideEntity playerJetPack
    HideEntity playerWingL
    HideEntity playerWingR
    HideEntity playerWheelFL
    HideEntity playerWheelFR
    HideEntity playerWheelRL
    HideEntity playerWheelRR
    playerCamY0=0.5
    playerCamZ0=4.5
    playerCamY=0.5
    playerCamZ=5
    Gravity=-0.01
    If talk Then eSpeak.Speak("hot air balloon") 
#EndMacro


#macro TCMod_VehicleList()
  cOhdText(0)=" Switch Vehicle "
  cOhdText(1)=" Car    Boat    "
  cOhdText(2)=" Helicopter     "
  cOhdText(3)=" Plane  Jetpack "
  cOhdText(4)=" Walk   Dive    "
  cOhdText(5)=" Swim   Yacht   "
  cOhdText(6)=" Landyacht      "
  cOhdText(7)=" Aerostat       " 
#endmacro


#macro TCMod_MoveVehicles()
  Sub MoveYacht
    '------- Relative Wind angle
    WAngle=(GetWeather(Player).Windangle)
    Relwind=WAngle-Heading
    If relwind < -180 THEN relwind = relwind + 360
    IF relwind > 180 THEN relwind = relwind - 360
    
    '------Windward side  is left (-) or right(+).
    tk=Sgn(relwind)
       
    '------- Velocity of Apparent Wind
    WSpeed=(GetWeather(Player).WindSpeed)
    vay=WSpeed* Sin(Relwind*pi/180)
    vax=WSpeed* Cos(Relwind*pi/180)+ve
    vapwind=Sqr(vax*vax+vay*vay)
    
    '------- Prevent division by zero
    If Vax<>0 Then aapwind= Atn(Vay/Vax)*180/pi
    If Abs(relwind-aapwind)>179 Then aapwind=aapwind+180*Sgn(relwind)
    
    'get boomangle from plfw (Joystick)
    If (plfw<-0.1) AndAlso (boomangle>1) Then boomangle=boomangle-1
    If (plfw>0.1) AndAlso (boomangle<90) Then boomangle=boomangle+1
    
    'get boomangle from cursor arrows
    If (plup>0.01) AndAlso (boomangle<90) Then boomangle=boomangle+1
    If (plup<-0.01) AndAlso (boomangle>1) Then boomangle=boomangle-1
    
    ' ---- Boomangle and Wind angle of incidence on sail
    boomang=boomangle*-tk
    sil=boomangle*-tk
    difang=Abs(aapwind)-Abs(sil)
    
    ' ---- If sail is in optimal laminar flow (light blue boom in wind instrument)
    If difang>9 And difang<16 Then
      boomcolr=255
      boomcolg=255
      boomcolb=1 
    ' ---- If sail is in laminar flow (yellow boom in wind instrument)  
    ElseIf difang>15 And difang<26 Then
      boomcolr=1
      boomcolg=255
      boomcolb=255 
    Else
    ' ---- If wind is only pushing sail (red boom in instrument)  
      boomcolr=1
      boomcolg=1
      boomcolb=150
    EndIf
    
    ' ---- If sail is loose in the wind (grey boom in wind instrument)
    If Abs(sil)>=Abs(aapwind) Then 
      boomang=-aapwind
      difang=0
      boomcolr=40
      boomcolg=40
      boomcolb=40    
    EndIf
    
    ins=(difang)
    
    ' ---- read sail efficiency from angle of incidence matrix
    sefi=se(ins)
    fsail=abs(sil*pi/180)
    
    ' ---- Read resistance factor from resistance table as per
    ' ---- relative wind angle and multiply by square of windspeed
    res = ve * ve * rsf(ABS(relwind))
    
    ' ---- Calculate propulsion vector as per apparent wind speed and resistance factor
    prop=sefi*Sin(fsail)*vapwind - res
    
    ' ---- Transfer propulsion vector to speed with progressive accelleration or decelleration
    ve=(ve-Sgn(ve-prop)*.05)
    
    If ve<0 Then ve=0 'prevent going backwards because it interferes with calculation
    PLSpeed=ve        'keep normal variable for steering speed and instrument read-out
    
    'Heeling angle as per Windspeed, Windangle and Boomangle
    heel= (Vay*pi/180)*15+10*Cos(boomangle*pi/180)*tk 
    
    'Forward pitch as per Windspeed, Windangle and Boomangle
    pitch=4*Sin(boomang*pi/180)*-tk+(Vax*pi/180)*4
       
    'turn left / right
    If Plfw>=0 Then
      turnentity player,0,-((PLSpeed*2)*tsa)*plrt*frametime,0
      ' ---- If stopped against wind get the oar!
      If PLSpeed=0 then turnentity player,0,-(10*tsa)*plrt*frametime,0
    Else
      turnentity player,0,((PLSpeed*2)*tsa)*plrt*frametime,0
      ' ---- If stopped against wind get the oar!
      If PLSpeed=0 then turnentity player,0,(10*tsa)*plrt*frametime,0
    EndIf
    
    'bend sail
    ScaleEntity playerSail, 1.5,2.5,-heel/24
    
    'move forward / back
    MoveEntity player,0,0,ve*frametime*speedscale
    
    'turn sail
    RotateEntity playerSailMast,0,(EntityYAW(playerSailMast)*4+boomang)/5,0
   
    'animate steering
    RotateEntity playerMotor,0,plrt*45*((MaxSpeedF*2-Abs(ve))/MaxSpeedF),0
    RotateEntity playerRudder,0,plrt*45*((MaxSpeedF*2-Abs(ve))/MaxSpeedF),0
    RotateEntity PlayerHead,0,180-plrt*45*((MaxSpeedF*2-Abs(ve))/MaxSpeedF),heel
     
    'animation - simulate waves (slightly waving boat), pitching + heeling.
    RotateEntity player,0,EntityYAW(player),0  
    RotateEntity playerModel,(3*ve/MaxSpeedF)*Sin(Timer*5)+Sin(Timer*2)+pitch,0,Sin(Timer*3)+heel
  End Sub
  
  
  Sub MoveLandyacht
    ' ---- shaking factor for rough ground, grass or sand
    shk=0.1+(2.4*ve/MaxSpeedF)
    
    ' ---- Relative Wind angle
    WAngle=(GetWeather(Player).Windangle)
    Relwind=WAngle-Heading
    If relwind < -180 THEN relwind += 360
    IF relwind > 180 THEN relwind -= 360
    
    ' ---- Windward side  is left (-) or right(+).
    tk=Sgn(relwind)
    
    ' ---- Velocity of Apparent Wind
    WSpeed=(GetWeather(Player).WindSpeed)
    If GetMap(tcx,tcz)<>" " Then WSpeed*=2   
    vay=WSpeed* Sin(Relwind*pi/180)
    vax=WSpeed* Cos(Relwind*pi/180)+ve
    vapwind=Sqr(vax*vax+vay*vay)
    
    ' ---- Prevent division by zero
    If Vax<>0 Then aapwind= Atn(Vay/Vax)*180/pi
    If Abs(relwind-aapwind)>179 Then aapwind=aapwind+180*Sgn(relwind)
    
    'move boomangle with joystick
    If (plfw<-0.1) AndAlso (boomangle>1) Then boomangle=boomangle-1
    If (plfw>0.1) AndAlso (boomangle<90) Then boomangle=boomangle+1
    
    'move boomangle with cursor arrows
    If (plup>0.01) AndAlso (boomangle<90) Then boomangle=boomangle+1
    If (plup<-0.01) AndAlso (boomangle>1) Then boomangle=boomangle-1
    
    ' ---- Boomangle and Wind angle of incidence on sail
    boomang=boomangle*-tk
    sil=boomangle*-tk
    difang=Abs(aapwind)-Abs(sil)
    
    ' ---- If sail is in optimal laminar flow (light blue boom in wind instrument)
    If difang>9 And difang<16 Then
      boomcolr=255
      boomcolg=255
      boomcolb=1 
    ' ---- If sail is in laminar flow (yellow boom in wind instrument)  
    ElseIf difang>15 And difang<26 Then
      boomcolr=1
      boomcolg=255
      boomcolb=255 
    Else
    ' ---- If wind is only pushing sail (red boom in instrument)  
      boomcolr=1
      boomcolg=1
      boomcolb=150
    EndIf
    
    ' ---- If sail is loose in the wind (grey boom in wind instrument)
    If Abs(sil)>=Abs(aapwind) Then 
      boomang=-aapwind
      difang=0
      boomcolr=40
      boomcolg=40
      boomcolb=40    
    EndIf
       
    ' ---- read sail efficiency from angle of incidence matrix
    ins=(difang)
    sefi=se(ins)
    fsail=abs(sil*pi/180)
    
    ' ---- Low, uniform resistance factor. Landyacht speeds can reach 3 x windspeed.
    res = ve * ve *0.060
    
    ' ---- Calculate propulsion vector as per apparent wind speed and resistance factor
    prop=sefi*Sin(fsail)*vapwind - res
    
    ' ---- Transfer propulsion vector to speed with 
    ' ---- equal accelleration and decelleration
    ve=(ve-Sgn(ve-prop)*.2)
    
    If ve<0 Then ve=0 ':prevent going backweards because it interferes with calculation
    PLSpeed=ve        'preserve normal variable for turning speed and speedometer
     
    ' ---- Heeling angle as per Windspeed, Windangle and Boomangle (slight effect)
    heel=((Vay*pi/180)+Cos(boomangle*pi/180)*tk)*1.5
      
    ' ---- Forward pitch as per Windspeed, Windangle and Boomangle
    pitch=((Vax*pi/180)+Sin(boomang*pi/180)*-tk)*1.5
             
    'turn left / right
    turnentity player,0,-3*(PlSpeed*tsa*tsa)*plrt*frametime,0
    ' ---- If stopped against wind get out and push nose around!
    If PLSpeed=0 then turnentity player,0,-(10*tsa)*plrt*frametime,0
    
    'bend sail
    ScaleEntity playerSail2, 1.5,2.5,-heel/4
    
    'move forward / back
    MoveEntity player,0,0,ve*frametime*SpeedScale
       
    'turn sail
    RotateEntity playerSailMast2,0,(EntityYAW(playerSailMast2)*2+boomang)/3,0
    
    'animate steering and head
    RotateEntity playerWheelFL,0,-plrt*20*((MaxSpeedF*2-Abs(ve))/MaxSpeedF),0
    RotateEntity PlayerHead,0,180-plrt*45*((MaxSpeedF*2-Abs(ve))/MaxSpeedF),0
      
    'animation - turn, with heel and pitch
    RotateEntity playerModel,(3*ve/MaxSpeedF)+pitch,EntityYAW(playerModel),heel
       
    ' ---- animate shaking when running over rough ground
    If GetMap(tcx,tcz)=":" Then
    ' ---- grey stony terrain
    If ve>0 Then RotateEntity playerModel,shk*Sin(Timer*110)+pitch,0,shk*Sin(Timer*90)+heel  
      ' ---- dirt road
    ElseIf GetMap(tcx,tcz)="+" Then
      If ve>0 Then RotateEntity playerModel,shk*Sin(Timer*85)+pitch,0,shk*Sin(Timer*65)+heel 
      ' ---- grass
    ElseIf GetMap(tcx,tcz)="," Then
      If ve>0 Then RotateEntity playerModel,shk*Sin(Timer*50)+pitch,0,shk*sin(Timer*35)+heel
      ' ---  sand
      ElseIf GetMap(tcx,tcz)="." Then
        If ve>0 Then RotateEntity playerModel,shk*Sin(Timer*30)+pitch,0,shk*sin(Timer*15)+heel
     End If
  End Sub
  
  
  Sub MoveBalloon
    '------- Relative Wind angle (for wind instrument and heading correction)
    WAngle=(GetWeather(Player).Windangle)
    Relwind=WAngle-Heading
    If relwind < -180 THEN relwind = relwind + 360
    If relwind > 180 THEN relwind = relwind - 360
    
    ' ---- Windward side  is left (-) or right(+).
    tk=Sgn(relwind)
    
    'progressive one fifth-degree adjustment to new wind direction 
    If Abs(relwind)<>180 Then If WAng<>WAngle Then WAng+=.2*tk
    
    'If high enough over water balloon travels with the wind. 
    WSpeed=(GetWeather(Player).WindSpeed)	
    If GetMap(tcx,tcz)=" " Then  
      If EntityY(player)>WaterHeight+2.8 Then  
        PLSpeed=WSpeed  
      End If  
    
    'If high enough over land it travels with the wind,      
    'and stops when landing on the ground.  
    Else
      If EntityY(player)>TileHeight(tcx,tcz)+Streetheight+4 Then  
        PLSpeed=WSpeed
      ElseIf EntityY(player)<TileHeight(tcx,tcz)+Streetheight+4 Then      
        PLSpeed*=0.8
        ve*=0.8
      End If   
    End If 
   
    'acquire Wind speed
    If plup<>0 Then PlSpeed=0
    ve+=Sgn(PLSpeed-ve)*.2  
    
    If ve<0 Then ve=0 ':prevent going backweards because it interferes with calculation
    PLSpeed=ve        'preserve normal variable for turning speed and speedometer  
    
    RotateEntity PlayerBody,0,180-plrt*40*((MaxSpeedF*2-Abs(PlSpeed))/MaxSpeedF),0
    RotateEntity PlayerHead,0,180-plrt*40*((MaxSpeedF*2-Abs(PlSpeed))/MaxSpeedF),0
    
    'Aerostatic balloon  travels with the wind
    WAng-=plrt      'turn ballon left/right
    RotateEntity Player,0,WAng,0
    
    Dim as Single psp
    psp=ve*frametime*SpeedScale
    'move Balloon with wind and up/down
    PositionEntity player,EntityX(player)-(sin(WAngle/180*pi)*psp), _
                   EntityY(player)+plup*frametime*100, _
                   EntityZ(player)-(cos(WAngle/180*pi)*psp)  
  
  End Sub
#endmacro



#macro TCMod_DoMove()
  Case "y": MoveYacht
  Case "l": MoveLandyacht
  Case "a": MoveBalloon
#endmacro


#macro TCMod_DiveLimit()
  'dive limit (boat, sailing yacht) 
  ElseIf "y"=pm Then 
    'set boat, sailing yacht to water height
    If EntityY(player)<WaterHeight+2.8 Then
      PositionEntity player,EntityX(player), WaterHeight+2.8, EntityZ(player)    
    ElseIf EntityY(player)>WaterHeight+2.8 Then
      PlSpeed*=0.8
      ve*=0.8
    EndIf
 
  'dive limit (aerostat floats in water but stops)  
  ElseIf "a"=pm Then
    If EntityY(player)<WaterHeight+1 Then
      PositionEntity player,EntityX(player), WaterHeight+1, EntityZ(player) 
      PlSpeed*=0.8
      ve*=.08
    EndIf 
   
  'dive limit (car, landyacht)  
  ElseIf "l"=pm Then
    If EntityY(player)<WaterHeight+0.5 Then
      PositionEntity playerModel,0, 0.1*Sin(Timer), 0    
      PlSpeed*=0.8
      ve*=0.8
    Else
      PositionEntity playerModel,0, 0, 0    
    EndIf
#endmacro


#macro TCMod_DoInit()
  OhdWindInit
  OhdRWindInit
  OhdBoomInit
#endmacro


#macro TCMod_ShowOhd()
 '------- Landyacht and Sailing Yacht Heading (also for other vehicles)
  Heading=-EntityYAW(Player)
  If heading<0 Then heading=heading+360   
 
  OhdWindShow   'Show Apparent Wind in instrument  
  OhdRWindShow  'Show Relative Wind in instrument
  OhdBoomShow   'Show Sailboom position and colour in Wind instrument

  'Check Tile type (for Landyacht rattle)
  'Ohdtext( 4)="Gr:"+GetMap(tcx,tcz)  
  
  'Check Balloon landing on water
  'Ohdtext( 4)="H"+Str(EntityY(Player))+" W:"+Str(Waterheight)
  'Ohdtext( 5)="T:"+Str(TileHeight(tcx,tcz)+Streetheight)

  If InStr("phja",pm) Then     
  Ohdtext( 5)="Height:"+Str(Int(EntityY(Player)))
  Else Ohdtext( 5)=""
  End If 
   
  Ohdtext( 4)="Heading "+(Str(Int(Heading)))+chr(&hF8)+"N"    
  OhdText( 7)="Km/h:"+str(Int(PlSpeed)) +" B:"+str(abuttons) 
 
  'Wind is different for these vehicles  
  If InStr("lya",pm) Then
  Ohdtext( 6)="Wind:"+Str(Int(WSpeed))+", "+Str(int(WAngle))+chr(&hF8) 
  Else Ohdtext( 6)=""
  End If
#endmacro
  

#macro TCMod_()
#endmacro


#ifdef TCMod
  TCMod_()
#endif
