'BrushWave.bas - Game_207 Texture brushing routines
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

#Include  once "BrushWave.bi"
#Include  once "Pixel.bi"

#IfDef  DEBUG_BRUSHWAVE
    #Define  DEBUG
#EndIf
#Include  once "Debug.bi"

'==========================================================================|

public _
Sub  BrushWaveLeftRight(byval image  as Image_Buffer,_
                        array wave() as Double      ,_
                        byval rScale as Double = 1  ,_
                        byval gScale as Double = 1  ,_
                        byval bScale as Double = 1   )


    DASSERT( image <> NULL, "Invalid Parameter: image = " & image )

    Dim  as Integer imageWidth, imageHeight
    ImageInfo  image, imageWidth, imageHeight

    Dim  as Integer waveIndex = LBound(wave ),_
                    yIndex    = 0

    Do   while   ( waveIndex <= UBound(wave ) )_
         AndAlso ( yIndex < imageHeight )

        For  xIndex as Integer = 0 to imageWidth - 1

            Dim as unsigned Integer _
            colourValue = Point(xIndex, yIndex, image)

            Pset  image                          , _
                  (xIndex,yIndex)                , _
                  PixelFromDelta(colourValue      ,_
                                 wave( waveIndex ),_
                                 rScale           ,_
                                 gScale           ,_
                                 bScale            ) 

        Next  xIndex

        waveIndex += 1
        yIndex +=1

    Loop  

End sub
