'CarveWave.bas - Game_207 texture shaping tools
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

#Include  once "CarveWave.bi"

#IfDef  DEBUG_CARVEWAVE
    #Define DEBUG
#EndIf
#Include  once "Debug.bi"

'==========================================================================|

public _
Sub  CarveWaveLeftRight(byval image     as          Image_Buffer,_
                        array wave()    as const    Double      ,_ 
                        byval yBase     as          Integer     ,_
                        byval direction as          Integer     ,_
                        byval colourVal as unsigned Integer      _
                                         = COLOUR_TRANSPARENT    )

    DASSERT(image <> NULL, "Null pointer!" )
    DASSERT(Abs(direction) = 1                           ,_
            "Invalid parameter: direction = " & direction )

    Dim  as Integer imageWidth, imageHeight
    ImageInfo  image, imageWidth, imageHeight
    DASSERT(yBase < imageHeight,"Invalid parameter! yBase = " & yBase )

    Dim  as Integer _
    waveIndex = LBound(wave ),_
    xPos      = 0

    Do  while   waveIndex <= UBound(wave ) _
        AndAlso xPos < imageWidth 

        Dim  as Integer yStop = yBase _
                              + direction*wave( waveIndex )

        CLAMP_TO(yStop, 0, imageHeight - 1 )

        Line image, (xPos,yBase)-(xPos,yStop), colourVal

        waveIndex += 1
        xPos      += 1

    Loop

End sub

public _
Sub  CarveWaveUpDown(byval image     as          Image_Buffer,_
                     array wave()    as const    Double      ,_ 
                     byval xBase     as          Integer     ,_
                     byval direction as          Integer     ,_
                     byval colourVal as unsigned Integer      _
                                      = COLOUR_TRANSPARENT    )

    DASSERT(image <> NULL, "Null pointer!" )
    DASSERT(Abs(direction) = 1                           ,_
            "Invalid parameter: direction = " & direction )

    Dim  as Integer imageWidth, imageHeight  
    ImageInfo  image, imageWidth, imageHeight
    DASSERT(xBase < imageWidth,"Invalid parameter! xBase = " & xBase )

    Dim  as Integer _
    waveIndex = LBound(wave ),_
    yPos      = 0

    Do  while   waveIndex <= UBound(wave ) _
        AndAlso yPos < imageHeight 

        Dim  as Integer xStop = xBase _
                              + direction * wave( waveIndex )

        CLAMP_TO(xStop, 0, imageWidth - 1 )
        
        Line image, (xBase,yPos)-(xStop,yPos), colourVal
   
        waveIndex += 1
        yPos      += 1

    Loop   

End sub
