'GFXBackPanel.bas - Game207 back panel graphic creation
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

#Include  once "Common.bi"

#IfDef  DEBUG_GFXBACKPANEL
    #Define  DEBUG
#Endif
#Include  once "Debug.bi"

#Include  once "Pixel.bi"
#Include  once "GenGrain.bi"
#Include  once "SineWave.bi"
#Include  once "BrushWave.bi"
#Include  once "CarveWave.bi"
#Include  once "TraceWave.bi"
#Include  once "Layout.bi"

'==========================================================================|

public _
Sub  CraftBackPanel(byval layer as Image_Buffer )

    '---Create-Gnarled-Wood Grain-Texture---------------------------------|
    Scope

      '---Generate-grain-pattern-------------------------------------------|

        Dim  as Double grain(0 to BACK_LAYER_WIDTH - 1)
        GenGrain  grain(), BACK_LAYER_GRAIN_DEPTH

      '---Apply-grain-pattern-across-top-row-of-pixels---------------------|

        For  x as Integer = 0 to BACK_LAYER_WIDTH - 1

            Dim  as unsigned Integer _
            pixelColour = PixelFromDelta(BACK_LAYER_COLOUR       ,_
                                         grain( x )              ,_
                                         BACK_LAYER_COLOUR_SCALES )

            Pset layer, (x,0), pixelColour

        Next  x

      '---Propigate-pattern-with-random-exchanges--------------------------|

        For  y as Integer = 1 to BACK_LAYER_HEIGHT - 1

            Dim  as Integer xSource = Int(Rnd() * 2)
            Pset layer, (0,y), Point(xSource, y - 1 , layer )

            For  x as Integer = 1 to BACK_LAYER_WIDTH - 2

                xSource = x + Int(Rnd() * 3 - 1)
                Pset layer, (x,y), Point(xSource, y - 1, layer )
                
            Next  x

            xSource = BACK_LAYER_WIDTH - 1 - Int(Rnd() * 2)
            Pset layer, ((BACK_LAYER_WIDTH - 1),y),_
                 Point(xSource, y - 1, layer )                  

        Next  y  

    End Scope

    '---Carve-Top-Curve---------------------------------------------------|
    Scope

        Dim  as Double curve(0 to BACK_LAYER_WIDTH - 1 )

        SineWave  curve(), MARGIN_HORIZONTAL     ,_
                           2 * ( GRID_WIDTH - 1 )               
     
        SineWave  curve(), 1                                      ,_
                           2 * ( GRID_WIDTH - 1 )                 ,_
                           (-PI/2)                                ,_
                           PHI                                    ,_
                           0                                      ,_
                           BACK_LAYER_WIDTH - 1                   ,_
                           OP_MUL                                 ,_
                           TRUE

        CarveWaveLeftRight  layer, curve(), 0, CARVE_DOWN

        TraceWaveLeftRight  layer, curve(), 2, TRACE_BELOW,_
                            BACK_LAYER_HIGHLIGHT_DELTA    ,_
                            BACK_LAYER_COLOUR_SCALES       

    End Scope

End  Sub

