'GFXToken.bas - Game_207 game piece graphic creation
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

#Include  once "Common.bi"

#IfDef  DEBUG_GFXTOKEN
    #Define  DEBUG
#EndIf
#Include  once "Debug.bi"

#Include  once "Pixel.bi"
#Include  once "Layout.bi"

'==========================================================================|

public _
Sub  CraftToken(byval layer  as Image_Buffer )

    DASSERT(layer <> NULL, "Null pointer!" )

    '---Carve-Circular-Token-----------------------------------------------|

    Dim  as  Double _
    yCenter = PLAYER_TOKEN_HEIGHT/2,_
    xCenter = PLAYER_TOKEN_WIDTH/2              

    

    For  yPos as Integer = 0 to PLAYER_TOKEN_HEIGHT - 1

        For  xPos as Integer = 0 to PLAYER_TOKEN_WIDTH - 1

            Dim  as Double _
            distance = SQR( (yPos - yCenter)^2 + (xPos - xCenter)^2 )

                        
            If  (distance - PLAYER_TOKEN_RADIUS ) < 0.25 Then

                Dim  as unsigned Integer _
                colourValue = Point(xPos, yPos, layer ) 


              '---Sculpt-curve---------------------------------------------|

                distance += Rnd() * 2 - 2
            
                Dim as Double colourDelta = 0                

                #Define SCALE (PLAYER_TOKEN_RADIUS/(2*PHI))
                              
                If      (distance > SCALE) _
                AndAlso (distance < PLAYER_TOKEN_RADIUS- 2 ) Then
                    
                    #Define CURVE _
                    (Sin((distance-SCALE) * (PI/4) / SCALE))

                    colourDelta = PLAYER_TOKEN_CURVE_MAGNITUDE * CURVE
                    
                    #UnDef CURVE
                 End if
                 
                 Pset layer, (xPos, yPos), PixelFromDelta(colourValue,_
                                                         colourDelta )

             Else

              '---Carve-away-excess----------------------------------------|    

                Pset layer, (xPos, Ypos), COLOUR_TRANSPARENT

            End  if

        Next xPos
    Next  yPos

End  sub