'Pixel.bas - Game_207 Pixel Manipulation Routines
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

#Include once  "Common.bi"

'==========================================================================|

#Define  TEST_COLOUR (&hFFcFcFcF)
#Define  BIAS_COLOUR (&hFF808080)

#Define  COLOUR_DELTA_BIAS (128 )

#Define  COMPONENT_RED(_colour_)   ( ( (_colour_) and &h00FF0000 ) shr 16 )
#Define  COMPONENT_GREEN(_colour_) ( ( (_colour_) and &h0000FF00 ) shr  8 )
#Define  COMPONENT_BLUE(_colour_)  ( ( (_colour_) and &h000000FF )        )

'==========================================================================|

public _
Function PixelFromDelta(byval pixelColour as unsigned Integer   , _
                        byval delta       as          Double    , _
                        byval rScale      as          Double = 1, _
                        byval gScale      as          Double = 1, _
                        byval bScale      as          Double = 1 )_
                        as unsigned Integer

    #Define NOISE (Int(Rnd() * 4 - Rnd() * 4 ))
    
    Dim  as Integer _
    newRed   = COMPONENT_RED(pixelColour)   + delta * rScale + NOISE,_
    newGreen = COMPONENT_GREEN(pixelColour) + delta * gScale + NOISE,_ 
    newBlue  = COMPONENT_BLUE(pixelColour)  + delta * bScale + NOISE

    CLAMP_TO(newRed  , &h00, &hFF )
    CLAMP_TO(newGreen, &h00, &hFF )
    CLAMP_TO(newBlue , &h00, &HFF )

    function = RGBA(newRed, newGreen, newBlue, &hFF )

End  function