'SineWave.bas - Game_207 wave generator
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

#Include  once "SineWave.bi"

#IfDef DEBUG_SINEWAVE
    #Define DEBUG
#EndIf
#Include  once "Debug.bi"

'==========================================================================|

public _
Sub  SineWave(array wave()      as Double           ,_
              byval amplitude   as Integer          ,_
              byval scale       as Integer          ,_
              byval phase       as Double  =  0     ,_
              byval exponent    as Double  =  1     ,_
              byval initIndex   as Integer = -1     ,_
              byval stopIndex   as Integer = -1     ,_
              byval opMode      as Integer =  OP_ADD,_
              byval applyAbsVal as Boolean =  FALSE  )
              


    

    Dim as Integer _
    xVar     = 0                                            ,_
    index    = Iif(initIndex = -1, LBound(wave), initIndex ),_
    endIndex = Iif(stopIndex = -1, UBound(wave), stopIndex )

    index    = MAX_OF(index, LBound(wave) )
    endIndex = MIN_OF(endIndex, UBound(wave) )
    
    Do  while index <= endIndex

        Dim  as Double _
        yVar = amplitude*Sin(xVar * 2*PI/scale + phase)

        If  applyAbsVal  Then
             yVar *= Sgn(yVar)
             yVar = yVar^exponent
        End if

        Select  case opMode
        Case  OP_ADD
            wave( index ) += yVar
        Case  OP_MUL
            wave( index ) *= yVar
        Case  OP_SET
            wave( index )  = yVar
        End  select

        index += 1
        xVar  += 1

    Loop 

End sub

