'TraceWave.bas - Game_207 Texture drawing tool
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

#Include  once "TraceWave.bi"

#IfDef  DEBUG_TRACEWAVE
    #Define  DEBUG
#EndIf
#Include  once "Debug.bi"

#Include  once "Pixel.bi"

'==========================================================================|

public _
Sub  TraceWaveLeftRight(byval image     as Image_Buffer ,_
                        array wave()    as Double       ,_
                        byval yBase     as Integer      ,_
                        byval direction as Integer      ,_
                        byval delta     as Double       ,_
                        byval rScale    as Double = 1   ,_
                        byval gScale    as Double = 1   ,_
                        byval bScale    as Double = 1    )

    DASSERT(image <> NULL, "Null pointer!")
    DASSERT(Abs(direction) = 1                               ,_
                "Invalid parameter: direction = " & direction )

    Dim  as Integer imageWidth, imageHeight
    ImageInfo  image, imageWidth, imageHeight
    DASSERT(yBase < imageHeight, "Invalid parameter: yBase = " & yBase  )

    Dim  as Integer       _
    xPos  = 0            ,_
    index = LBound(wave )

    Do  while   index <= UBound(wave )_
        AndAlso xPos < imageWidth - 1

        Dim as Integer _
        yPos = yBase + direction*wave( index )
        CLAMP_TO(yPos, 0, imageHeight - 1 )
    
        Dim   as unsigned Integer _
        pixelColour = Point(xPos, yPos, image )
    
        Pset  image, (xPos, yPos), PixelFromDelta(pixelColour,_
                                                  delta      ,_
                                                  rScale     ,_
                                                  gScale     ,_
                                                  bScale      )

        xPos  += 1
        index += 1

    Loop

End  sub

public _
Sub  TraceWaveUpDown(byval image     as Image_Buffer ,_
                     array wave()    as Double       ,_
                     byval xBase     as Integer      ,_
                     byval direction as Integer      ,_
                     byval delta     as Double       ,_
                     byval rScale    as Double = 1   ,_
                     byval gScale    as Double = 1   ,_
                     byval bScale    as Double = 1    )

    DASSERT(image <> NULL, "Null pointer!")
    DASSERT(Abs(direction) = 1                               ,_
                "Invalid parameter: direction = " & direction )

    Dim  as Integer imageWidth, imageHeight
    ImageInfo  image, imageWidth, imageHeight
    DASSERT(xBase < imageWidth, "Invalid parameter: xBase = " & xBase  )

    Dim  as Integer       _
    yPos  = 1            ,_
    index = LBound(wave ) + 1

    Do  while   index <= UBound(wave )_
        AndAlso yPos < imageHeight - 1

        Dim as Integer _
        xPos = xBase + direction*wave( index ) 
        CLAMP_TO(xPos, 0, imageWidth - 1 )
    
        Dim   as unsigned Integer _
        pixelColour = Point(xPos, yPos, image )
    
        Pset  image, (xPos, yPos), PixelFromDelta(pixelColour,_
                                                  delta      ,_
                                                  rScale     ,_
                                                  gScale     ,_
                                                  bScale      )

        yPos  += 1
        index += 1

    Loop

End  sub


