'Tree.bas - Game207 AI Tree data structure
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

#Include  once "Tree.bi"

#IfDef  DEBUG_TREE
#Define  DEBUG
#EndIf
#Include once "Debug.bi"

'==========================================================================|

public _
Constructor  Tree_Node()

    parent      = NULL
    firstChild  = NULL
    lastChild   = NULL
    nextSibling = NULL
    prevSibling = NULL


    slotTested   = -1
    score        = 0
    openFlag     = TRUE

End  constructor


public _
Destructor  Tree_Node()

    Dim  as pTree_Node workNode = firstChild

    Do   until workNode = NULL 
        Dim  as pTree_Node  nextNode = workNode->nextSibling
        Delete  workNode
        workNode = nextNode
    Loop

End  destructor

'==========================================================================|

public _
Sub  Tree_Node.AddChild(byval newChild as pTree_Node)

    If  firstChild = NULL Then
        firstChild = newChild
    Else 
        newChild->prevSibling = lastChild
        lastChild->nextSibling = newChild
    End  if
    lastChild = newChild
    newChild->parent = @This

End  sub


'==========================================================================|

public _
Function  Tree_Node.Find(byval slot as Integer ) as pTree_Node

    Dim  as pTree_Node returnNode = NULL,_
                       searchNode = firstChild
    
    Do  until Not (returnNode = NULL ) OrElse searchNode = NULL
        If  searchNode->slotTested = slot Then  returnNode = searchNode
        searchNode = searchNode->nextSibling

    Loop

    function = returnNode
    
End  function

'==========================================================================|

public _
Sub  Tree_Node.Remove()

    If  prevSibling <> NULL Then  prevSibling->nextSibling = nextSibling
    If  nextSibling <> NULL Then  nextSibling->prevSibling = prevSibling

    If parent <> NULL  Then

        If parent->firstChild = @This  Then
            parent->firstChild = nextSibling
        End if
        If parent->lastChild = @This  Then
            parent->lastChild = prevSibling
        End if
        
    End  if

    nextSibling = NULL
    prevSibling = NULL
    parent = NULL

End  sub