'Board_Display - Game207 board state visual
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

#Ifdef DEBUG_BOARD_DISPLAY
#Define DEBUG
#Endif
#Include  once "Debug.bi"

#Include  once "GUI\Board_Display.bi"

'==========================================================================|

public _
Sub  Board_Display.SetImages(byval imA as Image_Buffer,_
                             byval imB as Image_Buffer ) 

    DASSERT(imA <> NULL AndAlso imB <> NULL,_
    "Null pointer!"                         )

    imageA = imA
    imageB = imB

End  sub


public _
Sub  Board_Display.ConnectState(byval newState as Board_State ptr )

    DASSERT(newState <> NULL, "Null pointer!" )

    boardState = newState

End  sub

public _
Sub  Board_Display.Draw(byval dest as Image_Buffer )

    DASSERT(dest <> NULL, "Null pointer!" )
    DASSERT(imageA <> NULL AndAlso imageB <> NULL AndAlso boardState<>NULL,_
    "Object not properly initialized!"                                     )

    Dim as Image_Buffer spaceImage( PLAYER_B to PLAYER_A )   _
                                => { imageB   ,NULL , imageA }

    For  slot as Integer = 0 to BOARD_WIDTH - 1

        Dim  as Integer slotX = SLOT_X(slot )
        
        Dim  as Integer row = 0

        Dim  as Boolean emptyFound = FALSE
        Do  until row = BOARD_HEIGHT OrElse emptyFound

            Dim  as Integer rowY= ROW_Y(row)

            Dim  as Integer spaceState = boardState->Token(slot, row )

            If  spaceState <> EMPTY_SPACE Then
                Put  dest, (slotX, rowY), spaceImage(spaceState), TRANS
            Else
                emptyFound = TRUE
            End  if
                        
            row +=1
      
        Loop   

    Next  slot

End  sub