'Slot_Selector.bi - Game207 game space selection control
'Ryan Kelly (codeFoil) 2012

'=========================================================================|

#Ifdef  DEBUG_SLOT_SELECTOR
#Define  DEBUG
#EndIf
#Include  once "Debug.bi"

#Include  once "GUI.bi"

'=========================================================================|

public _
Constructor  Slot_Selector()

    errorFlag = FALSE

    box.Set(GRID_X, GRID_Y, GRID_WIDTH, GRID_HEIGHT )

    slotHighlight =  ImageCreate(SLOT_WIDTH, GRID_HEIGHT )
    If  slotHighlight = NULL Then
        errorFlag = TRUE
    End  if

End  constructor


public _
Destructor  Slot_Selector()

    If slotHighlight <> NULL Then

        ImageDestroy  slotHighlight
    
    End  if


End  destructor

'--------------------------------------------------------------------------|

#Macro  EXPOSE_BOOLEAN(_type_,_member_,_Set_,_Clear_,_access_)

public _
Function  _type_._Set_() as Boolean

    function    = _member_
    _member_ = TRUE

End  function

public _
Function  _type_._Clear_() as Boolean

    function    = _member_
    _member_ = FALSE

End  function

public _
Property  _type_._access_() as Boolean

    property = _member_

End  property

#EndMacro

EXPOSE_BOOLEAN(Slot_Selector, enabledFlag, ShimmedEnable, Disable, isEnabled)
public _ 
Function  Slot_Selector.Enable() as Boolean
    Hide
    mouseIsMine = FALSE
    function = ShimmedEnable

End  function


EXPOSE_BOOLEAN(Slot_Selector, visibleFlag, Show  , Hide   , isVisible)



public _
Property  Slot_Selector.selectedSlot() as Integer

    property = currentSlot

End  property


public _
Property Slot_Selector.selectedSlot(byval newSlot as Integer )

    DASSERT(newSlot>=0  AndAlso newSlot < BOARD_WIDTH,_
    "Invalid parameter newSlot : " & newSlot          )

    DASSERT(boardState->IsSlotOpen(newSlot)    ,_
    "Invalid paramter newSlot. Slot is full."   )

    currentSlot = newSlot

End  property 

'--------------------------------------------------------------------------|


public _
Sub  Slot_Selector.ConnectState(byval newState as Board_State ptr )

    boardState = newState    

End  sub

public _
Sub  Slot_Selector.SetColor(byval newC as Colour_Value )

    Paint slotHighlight, (0,0), newC

End  sub

public _
Sub  Slot_Selector.Draw(byval dest as Image_Buffer)

    If       visibleFlag                        _
    AndAlso  boardState->IsSlotOpen(currentSlot)_
    AndAlso  mouseIsMine                        _
    Then

        Dim  as Integer x = SLOT_X(currentSlot)

        Put  dest, (x, GRID_Y ), slotHighlight, ALPHA, SLOT_SELECTOR_ALPHA       

    End  if

End  sub

'--------------------------------------------------------------------------|

public   _
static   _
Function _
Slot_Selector.HandleEvent(byval this as Slot_Selector  ptr,_
                          byref event as Screen_Event      ) as Boolean

    function = FALSE
    
    If this->enabledFlag  Then
        Select  case event.code
        Case  MOUSE_BUTTON_PRESS
            If       event.mouseButton = MOUSE_BUTTON_LEFT           _
            AndAlso  this->mouseIsMine                               _
            Then
                function = TRUE    
                If  this->boardState->IsSlotOpen(this->currentSlot) Then 
                    this->actionClick.Fire()
                End  if
            End  if
        Case MOUSE_MOVE

            function = this->MouseMove(event.mouseX, event.MouseY )

        End Select        

    End  if

End  function


private _  
Function  Slot_Selector.MouseMove(byval mouseX as Integer,_
                                  byval mouseY as Integer ) as Boolean

    If  box.doesEnclose(mouseX, mouseY ) Then

        mouseIsMine = TRUE
        currentSlot = SLOT_FROM(mouseX)
        Show

    Else

        mouseIsMine = FALSE
        Hide
        
    End  if

    function = mouseIsMine

End  function