'Text_Message.bas - Game207 text message panel
'Ryan Kelly (codeFoil) 2012

'=========================================================================|

#IfDef  DEBUG_TEXT_MESSAGE
#Define  DEBUG
#EndIF
#Include  once "Debug.bi"

#Include  once "GUI\Text_Message.bi"

'=========================================================================|

Declare sub DrawTextBox(byval dest as Image_Buffer,_
                        byval x    as Integer     ,_
                        byval y    as Integer     ,_
                        byval w    as Integer     ,_
                        byval h    as Integer     ,_
                        byval fc   as Colour_Value,_
                        byval bc   as Colour_Value,_
                        byval tc   as Colour_Value,_
                        byval text as string       )

'=========================================================================|

public _
Constructor  Text_Message(byval initMessage as String      ,_
                          byval initFc      as Colour_Value,_
                          byval initBc      as Colour_Value,_
                          byval initTc      as Colour_Value )

    message  = initMessage
    fillC    = initFc
    boarderC = initBc
    textC    = initTc

    AdjustSize

End  constructor

'--------------------------------------------------------------------------|

#Macro  EXPOSE_BOOLEAN(_type_,_member_,_Set_,_Clear_,_access_)

public _
Function  _type_._Set_() as Boolean

    function    = _member_
    _member_ = TRUE

End  function

public _
Function  _type_._Clear_() as Boolean

    function    = _member_
    _member_ = FALSE

End  function

public _
Property  _type_._access_() as Boolean

    property = _member_

End  property

#EndMacro

EXPOSE_BOOLEAN(Text_Message,visibleFlag, Show, Hide, isVisible)

'--------------------------------------------------------------------------|


private _
Sub  Text_Message.AdjustSize()


    Dim  as Integer newW = Len(message) * CHARACTER_SPACING
    newW += 2 * TEXT_MESSAGE_MARGIN

    CLAMP_TO(newW, 0, WINDOW_WIDTH )

    Dim  as Integer newX = (WINDOW_WIDTH - newW ) / 2

    box.Set(newX, TEXT_MESSAGE_Y, newW, TEXT_MESSAGE_HEIGHT ) 


End  sub

public _
Sub  Text_Message.Draw(byval dest as Image_Buffer )

    If  visibleFlag Then

        Dim as Integer x, y, w ,h
        box.GetAll(x,y,w, h )
    
        DrawTextBox dest, x, y, w, h, fillC, boarderC, textC, message

    End  if

End  sub


private _ 
Sub  DrawTextBox(byval dest as Image_Buffer,_
                 byval x    as Integer     ,_
                 byval y    as Integer     ,_
                 byval w    as Integer     ,_
                 byval h    as Integer     ,_
                 byval fc   as Colour_Value,_
                 byval bc   as Colour_Value,_
                 byval tc   as Colour_Value,_
                 byval text as string       )


    Dim as Integer shX = x - (TEXT_MESSAGE_MARGIN / 2 ),_
                   shY = y - (TEXT_MESSAGE_MARGIN / 2 ),_
                   shW = w + (TEXT_MESSAGE_MARGIN     ),_
                   shH = h + (TEXT_MESSAGE_MARGIN     )

    Line dest, (shX,shY)-(shX+shW-1,shY+shH-1), bc, BF
    Line dest, (x,y)-(x+w-1,y+h-1), fc, BF

    Draw string  dest, (x + (TEXT_MESSAGE_MARGIN)+ 1 ,_
                        y + (TEXT_MESSAGE_MARGIN) ),_
                        text, tc

End  sub

'-------------------------------------------------------------------------|

public _
Sub  Text_Message.SetText(byref newMessage as String )

    message = newMessage
    AdjustSize

        

End  sub