'Board_State.bi - Game 207 game board logic
'Ryan R. Kelly (codeFoil) 2012

'==========================================================================|

#Include once "Common.bi"

'===DATA=TYPES=and=CONSTANTS===============================================|

#Ifndef BOARD_WIDTH
#Define BOARD_WIDTH (7)
#EndIf
#Ifndef BOARD_HEIGHT 
#Define BOARD_HEIGHT (6)
#EndIf

#Define EMPTY_SPACE (0)
#Define PLAYER_A (1)
#Define PLAYER_B (-1)

Type Board_State

  Public:
    Declare  constructor()
    Declare  sub Clear()

    Declare  function PlaceToken(byval where  as Integer ) as Boolean

    Declare  function Token(byval querySlot as Integer,_
                            byval queryRow  as Integer ) as Integer

    Declare  function IsSlotOpen(byval querySlot as Integer) as Boolean

    Declare  function NextRowInSloT(byval querySlot as Integer) as Boolean

    Declare  sub Undo()

    Declare  property lastSlotPlayed() as Integer
    Declare  property lastTurn()       as Integer
    Declare  property winner()         as Integer
                                 
  Private:

    Declare  function CheckForWin() as Boolean
    Declare  function CountConnected(byval player    as Integer,_
                                     byval initSlot  as Integer,_
                                     byval initRow   as Integer,_
                                     byval deltaSlot as Integer,_
                                     byval deltaRow  as Integer )_
                                     as Integer
    
    as  Integer location( 0 to BOARD_WIDTH  - 1 , _
                          0 to BOARD_HEIGHT - 1   )
    as  Integer nextRow( 0 to BOARD_WIDTH - 1 )

    as  Integer moveHistory(0 to BOARD_WIDTH * BOARD_HEIGHT -1)
    as  Integer turnNumber
    as  Integer currentPlayer 
    
    as  Integer movesRemaining
    as  Integer gameWinner
End type
