'Bounding_Box.bi - Game207 GUI region object
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

'Included by GUI.bi

'Include order must be preserved.

#IfnDef  GAME207_GUI
#Include  once "Common.bi"
#EndIf

'===BOUNDING=BOX===========================================================|

Enum Box_Mode
    BOX_OUTLINE = FALSE
    BOX_FILLED  = TRUE
End enum

Enum Ellipse_Mode
    ELLIPSE_OUTLINE = FALSE
    ELLIPSE_FILLED  = TRUE
End enum

Enum Box_Etch_Mode
    BOX_ETCH_NODE              = &h00
    BOX_ETCH_LEFT              = &h01
    BOX_ETCH_TOP               = &h02
    BOX_ETCH_TOP_LEFT          = &h03
    BOX_ETCH_BOTTOM            = &h04
    BOX_ETCH_BOTTOM_LEFT       = &h05
    BOX_ETCH_BOTTOM_TOP        = &h06
    BOX_ETCH_BOTTOM_TOP_LEFT   = &h07
    BOX_ETCH_RIGHT             = &h08
    BOX_ETCH_RIGHT_LEFT        = &h09
    BOX_ETCH_RIGHT_TOP         = &h0A
    BOX_ETCH_RIGHT_TOP_LEFT    = &h0B
    BOX_ETCH_RIGHT_BOTTOM      = &h0C
    BOX_ETCH_RIGHT_BOTTOM_LEFT = &h0D
    BOX_ETCH_RIGHT_BOTTOM_TOP  = &h0E
    BOX_ETCH_BOX               = &h0F
End  Enum

Type  Bounding_Box

  Public:
    Declare  constructor()

    Declare  function  Set(byval newX  as Integer,_
                           byval newY  as Integer,_                    
                           byval newW  as Integer,_
                           byval newH  as Integer ) as Boolean

    Declare  function  MoveTo(byval newX as Integer,_
                              byval newY as Integer ) as Boolean

    Declare  function  Resize(byval newW as Integer,_
                              byval newH as Integer ) as Boolean

    Declare  function  GetAll(byref outX as Integer,_
                              byref outY as Integer,_
                              byref outW as Integer,_
                              byref outH as Integer ) as Boolean

    Declare  function  GetFirst(byref outX as Integer,_
                                byref outY as Integer ) as Boolean

    Declare  function  GetSize(byref outW as Integer,_
                               byref outH as Integer ) as Boolean

    Declare  function  GetLast(byref outX as Integer,_
                               byref outY as Integer ) as Boolean
    


    Declare  function DoesEnclose(byval testX as Integer,_
                                  byval testY as Integer ) as Boolean

    Declare  function Draw(byval dest   as Image_Buffer,_
                           byval colour as Colour_Value,_        
                           byval mode   as Box_Mode     _
                                         = BOX_FILLED   ) as Boolean

    Declare  function DrawEllipse(byval dest   as Image_Buffer ,_
                                  byval colour as Colour_Value ,_        
                                  byval mode   as Ellipse_Mode  _
                                                = ELLIPSE_FILLED) as Boolean

    Declare  function Etch(byval dest      as Image_Buffer ,_
                           byval colour    as Colour_Value ,_ 
                           byval mode      as Box_Etch_Mode,_
                           byval thickness as Integer = 1   ) as Boolean

    Declare  property isEmpty()  as Boolean

    Declare  property x1() as Integer
    Declare  property x1(byval newX as Integer)

    Declare  property y1() as Integer
    Declare  property y1(byval newY as Integer)

    Declare  property x2() as Integer
    Declare  property x2(byval newX as Integer)

    Declare  property y2() as Integer 
    Declare  property y2(byval newY as Integer)

    Declare  property w() as Integer
    Declare  property w(byval newW as Integer)

    Declare  property h() as Integer
    Declare  property h(byval newH as Integer)

     

  Private:

    as  Boolean  emptyFlag
    as  Integer  x     ,_
                 y     ,_
                 width ,_
                 height,_
                 maxX  ,_
                 maxY        

 

End  type
