'Button_Control.bi - Game207 Button Control
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

'Included by GUI.bi
'Include order must be preserved
#IfnDef  GAME207_GUI
#Include  once "Common.bi"
#Include  once "Bounding_Box.bi"
#Include  once "Action.bi"
#Include  once "Screen_Event.bi"
#EndIf

'===BUTTON=================================================================|

#Define DEF_BFC   (&hFF888888) 'Default button face color
#Define DEF_BHC   (&hFFFFFFFF) 'Default button highlight color
#Define DEF_BSC   (&hFF404040) 'Default button shadow color
#Define DEF_BBVL  (1)          'Default button bevel width

'--------------------------------------------------------------------------|

Type  Button_Style as unsigned Integer

#Define  BUTTON_RECTANGLE    (&h00)
#Define  BUTTON_RAISED       (&h01)
#Define  BUTTON_CIRCLE       (&h02)
#Define  BUTTON_IMAGE        (&h04)
#Define  BUTTON_IMAGE_INVERT (&h08)   
#Define  BUTTON_EXIT         (&h10)
#Define  BUTTON_RESET        (&h20)

'==========================================================================|

Type  Button_Control

  Public:
    Declare  constructor (byval initStyle as BUTTON_STYLE          ,_
                          byval initX     as Integer               ,_
                          byval initY     as Integer               ,_
                          byval initW     as Integer               ,_
                          byval InitH     as Integer               ,_
                          byval fColour   as Colour_Value = DEF_BFC,_
                          byval hColour   as Colour_Value = DEF_BHC,_
                          byval sColour   as Colour_Value = DEF_BSC,_
                          byval image     as Image_Buffer = NULL   ,_
                          byval imageInv  as Image_Buffer = NULL    )
    Declare  destructor()


  Public:  
    Declare  function    Enable() as Boolean 
    Declare  function   Disable() as Boolean 
    Declare  property isEnabled() as Boolean 
  Private:
    as  Boolean enabledFlag 


  Public:
    Declare  function      Show() as Boolean
    Declare  function      Hide() as Boolean
    Declare  property isVisible() as Boolean
  Private:
    as  Boolean visibleFlag 


  Public:
    Declare  function      Toggle() as Boolean
    Declare  function    PushDown() as Boolean
    Declare  function      PullUp() as Boolean 
    Declare  property isDepressed() as Boolean
  Private:
    as  Boolean depressedFlag

  Public:
    Declare  sub Fill(byval fillRountine as Image_Crafter ) 
    Declare  sub FillInverted(byval fillRountine as Image_Crafter )

    Declare  function Draw(byval dest as Image_Buffer) as Boolean
  Private:
    Declare  function _
             DrawRectangularButton(byval dest as Image_Buffer) as Boolean

    Declare  function _
             DrawCircleButton(byval dest as Image_Buffer ) as Boolean

  Public:
    as  Bounding_Box  box
    as  Boolean errorFlag
    as  Action actionClick
    as  String  toolTipText

  Private:
    as  Button_Style  style
    as  Colour_Value  faceColour     ,_
                      highlightColour,_
                      shadowColour   ,_
                      workingHighlight,_
                      workingShadow        
    as  Image_Buffer  faceImage,_
                      faceInverted
    as  Boolean ownFaceImage,_
                ownFaceInverted,_
                mouseIsMine 

    
    as  Boolean showToolTip

  Public:
    Declare static function HandleEvent(byval this as Button_Control ptr,_
                                        byref event as Screen_Event      )_
                                        as Boolean

End  Type
