'Game_AI.bi - Game207 pseudo-intelligent opponent
'Ryan Kelly (codeFoil) 2012

'=========================================================================|

#IfnDef Game207_GUI
#Include  once "Common.bi"
#Include  once "Board_State.bi"
#Include  once "GUI\Slot_Selector.bi"
#EndIf

#Include  once "AI\Tree.bi"

'=========================================================================|

#Define THREAD_SLEEP_DURATION (500)

'=========================================================================|

Type  Thread_Handle as any ptr
Type  Mutex as any ptr
Type  Condition as any ptr

'-------------------------------------------------------------------------|

Type  pGame_AI as Game_AI ptr
Type  Game_AI

  Public:
    Declare  constructor()
    Declare  destructor()
     
    Declare  sub      ConnectToGame(byval bState as Board_State ptr  ,_
                                    byval side  as Integer            )

    Declare  sub      ReleaseGame()
                                    
    Declare  property hasDecided() as Boolean
    Declare  property move()       as Integer

    as  Boolean errorFlag

  Private:
    as  Board_State ptr trueState

    as  Integer mySide,_
                myMove
                      
    as  Boolean playSignal
    

  '------------------------------------------------------------------------|

    Declare  static sub AIThreadEntry(byval this as pGame_AI )

    Declare  sub AIThread()

    Declare  sub BeginGame()

    Declare  sub      ChooseMyMove()         
    Declare  function RandomMove() as Integer

    Declare  sub      Ponder()

    as  Mutex          aiThreadLock

    as  Thread_Handle  aiThreadHandle

    as  Condition      condConnected  ,_
                       condAcknowledge

    as  Boolean exitSignal,_
                gameSignal,_
                moveSignal

    as  Double timeOut

    as  pTree_Node  rootNode, curNode

    as  Integer lookAhead, lookAheadThreshold, depthSearched

    as  Board_State ponderState
     
End  type