'Layout.bi - Game_207 Interface layout
'Ryan Kelly (codeFoil) 2012


#Define  BOARD_WIDTH  (7)
#Define  BOARD_HEIGHT (6)

'=========================================================================|

#Define  MARGIN_HORIZONTAL (32)
#Define  MARGIN_VERTICAL   (49)

#Define  SLOT_WIDTH   (32)
#Define  ROW_HEIGHT   (32)
#Define  SLOT_SPACING (15)
#Define  HOLE_RADIUS  (14)

'--------------------------------------------------------------------------|

#Define GRID_X      (MARGIN_VERTICAL        )
#Define GRID_Y      (MARGIN_HORIZONTAL + 32 )
#Define GRID_WIDTH  (314                    )
#Define GRID_HEIGHT (192                    )

#Define GRID_BOUNDS _
GRID_X             , GRID_Y              ,_
GRID_X + GRID_WIDTH, GRID_Y + GRID_HEIGHT

'--------------------------------------------------------------------------|

#Define PLAYER_TOKEN_WIDTH       (SLOT_WIDTH)
#Define PLAYER_TOKEN_HEIGHT      (ROW_HEIGHT)

#Define PLAYER_TOKEN_COLOUR_A    (&hFFB09080)
#Define PLAYER_TOKEN_HIGHLIGHT_A (&hFF9090FF)
#Define PLAYEr_TOKEN_SHADOW_A    (&hFF808000)

#Define PLAYER_TOKEN_COLOUR_B    (&hFF444444)
#Define PLAYER_TOKEN_HIGHLIGHT_B (&hFF4040FF)
#Define PLAYER_TOKEN_SHADOW_B    (&hFF808000)

#Define PLAYER_TOKEN_RADIUS   ((PLAYER_TOKEN_WIDTH - 1 )/2)

#Define PLAYER_TOKEN_CURVE_MAGNITUDE (-16)

#Define PLAYER_TOKEN_A_X _
        (GRID_X + GRID_WIDTH + ( MARGIN_VERTICAL - PLAYER_TOKEN_WIDTH)/2)

#Define PLAYER_TOKEN_B_X _
        ((MARGIN_VERTICAL - PLAYER_TOKEN_WIDTH)/2)

#Define PLAYER_TOKEN_Y (GRID_Y + GRID_HEIGHT )

'--------------------------------------------------------------------------|

#Define BACK_LAYER_X      (MARGIN_VERTICAL                  )
#Define BACK_LAYER_Y      (32                               )
#Define BACK_LAYER_HEIGHT (MARGIN_HORIZONTAL + GRID_HEIGHT  )
#Define BACK_LAYER_WIDTH  (GRID_WIDTH                       )

#Define  BACK_LAYER_COLOUR (&HFFB0B0A0)
#Define  BACK_LAYER_HIGHLIGHT_DELTA (32)
#Define  BACK_LAYER_RSCALE ( .50  )
#Define  BACK_LAYER_GSCALE ( .50  )
#Define  BACK_LAYER_BSCALE ( 1.25 )

#Define  BACK_LAYER_COLOUR_SCALES _
         BACK_LAYER_RSCALE, BACK_LAYER_GSCALE, BACK_LAYER_BSCALE

#Define  BACK_LAYER_GRAIN_DEPTH (12)


'--------------------------------------------------------------------------|

#Define  FRONT_LAYER_X      (0  )
#Define  FRONT_LAYER_Y      (32 )
#Define  FRONT_LAYER_HEIGHT (256)
#Define  FRONT_LAYER_WIDTH  (412)

#Define  FRONT_LAYER_COLOUR (&HFF8080A0)
#Define  FRONT_LAYER_HIGHLIGHT_DELTA (64)
#Define  FRONT_LAYER_RSCALE ( 0.25 )
#Define  FRONT_LAYER_GSCALE ( 0.25 )
#Define  FRONT_LAYER_BSCALE ( 1.125)

#Define  FRONT_LAYER_COLOUR_SCALES _
         FRONT_LAYER_RSCALE, FRONT_LAYER_GSCALE, FRONT_LAYER_BSCALE

#Define  FRONT_LAYER_GRAIN_DEPTH  (16)

#Define  FRONT_LAYER_FACE_CURVE_HEIGHT (12)
#Define  FRONT_LAYER_FACE_CURVE_SCALE  (FRONT_LAYER_HEIGHT * 1.5)
#Define  FRONT_LAYER_FACE_CURVE_PHASE  (-PI)

'--------------------------------------------------------------------------|

#Define RESET_BUTTON_STYLE  (BUTTON_RAISED Or BUTTON_CIRCLE )
#Define RESET_BUTTON_WIDTH  (16)
#Define RESET_BUTTON_HEIGHT (16)
#Define RESET_BUTTON_X _
(FRONT_LAYER_X + (MARGIN_VERTICAL-RESET_BUTTON_WIDTH)/2)
#Define RESET_BUTTON_Y _
(FRONT_LAYER_Y + (MARGIN_HORIZONTAL-RESET_BUTTON_HEIGHT)/2)
#Define RESET_BUTTON_COLOUR    (FRONT_LAYER_COLOUR)
#Define RESET_BUTTON_HIGHLIGHT (&hFFA0A000)
#Define RESET_BUTTON_SHADOW    (&hFF606080)
#Define RESET_BUTTON_BOUNDS _
RESET_BUTTON_X                     , RESET_BUTTON_Y                     ,_
RESET_BUTTON_X + RESET_BUTTON_WIDTH, RESET_BUTTON_Y + EXIT_BUTTON_HEIGHT

'--------------------------------------------------------------------------|

#Define EXIT_BUTTON_WIDTH  (16)
#Define EXIT_BUTTON_HEIGHT (16)

#Define EXIT_BUTTON_X _
(GRID_X+GRID_WIDTH+(MARGIN_VERTICAL-EXIT_BUTTON_WIDTH )/2)

#Define EXIT_BUTTON_Y _
(FRONT_LAYER_Y+(MARGIN_HORIZONTAL-EXIT_BUTTON_HEIGHT)/2)

#Define EXIT_BUTTON_COLOUR    (FRONT_LAYER_COLOUR)
#Define EXIT_BUTTON_HIGHLIGHT (&hFFC0C000)
#Define EXIT_BUTTON_SHADOW    (&hFF606080)

#Define EXIT_BUTTON_BOUNDS _
EXIT_BUTTON_X                     , EXIT_BUTTON_Y                     ,_
EXIT_BUTTON_X + EXIT_BUTTON_WIDTH , EXIT_BUTTON_Y + EXIT_BUTTON_HEIGHT

'--------------------------------------------------------------------------|

#Define ROW_Y(_r_)_
(GRID_Y + GRID_HEIGHT - ROW_HEIGHT*((_r_)+1))

#Define SLOT_X(_s_) _
(GRID_X - FRONT_LAYER_X + ( SLOT_WIDTH + SLOT_SPACING )*(_s_))

#Define SLOT_FROM(_x_) (((_x_) - GRID_X ) \ ( SLOT_WIDTH + SLOT_SPACING ))


'--------------------------------------------------------------------------|

#Define WINDOW_WIDTH  (FRONT_LAYER_WIDTH + FRONT_LAYER_X )
#Define WINDOW_HEIGHT (FRONT_LAYER_HEIGHT + FRONT_LAYER_Y )

'--------------------------------------------------------------------------|

#Define TEXT_MESSAGE_MARGIN (4)
#Define TEXT_MESSAGE_HEIGHT (8 + 2 * TEXT_MESSAGE_MARGIN )
#Define TEXT_MESSAGE_Y      (FRONT_LAYER_Y + FRONT_LAYER_HEIGHT / PHI)
#Define CHARACTER_SPACING   (8)

#Define TEXT_MESSAGE_FILL_COLOUR   (&hFF303040  )
#Define TEXT_MESSAGE_BORDER_COLOUR (&hFFD8D8E8  )
#Define TEXT_MESSAGE_TEXT_COLOUR   (&hFFBCBCB0  )

'--------------------------------------------------------------------------|

#Define SLOT_SELECTOR_ALPHA (&h60)