'Main.bas -  Game207 main module
'Ryan Kelly (codeFoil) 2012

'==========================================================================|


#Ifdef  DEBUG_MAIN
#Define  DEBUG
#Endif
#Include  once "Debug.bi"

#Include  once "GUI.bi"

'==========================================================================|

Declare  sub DisplayExitMessage(byref message as String )
Declare  sub PlaceString(byref outText as String, byval yPos as Integer )

'==========================================================================|

Randomize &hcF
ScreenRes WINDOW_WIDTH, WINDOW_HEIGHT, 32, , &h1C
Color , COLOUR_TRANSPARENT
Cls
Dim  as String exitMessage = "Thank You For Playing"

Scope

Dim  as Game_Window  gameWindow

If  gameWindow.errorFlag  Then
    DPRINT("Main window failed to initialize")
    exitMessage = "Sorry, an error occurred during initilization."
Else

    gameWindow.Center
    gameWindow.SetMode(MODE_PLAYER_SELECTION)
    gameWindow.FadeIn

    Do  while gameWindow.HandleInput

        gameWindow.Draw
        Sleep 50, 1   

    Loop 

    gameWindow.FadeOut
    
End  if

End  scope

DisplayExitMessage exitMessage
Sleep 5000, 1

End  0

'==========================================================================|


private _
Sub  DisplayExitMessage(byref message as String )
    Dim  as Integer boxWidth  = Len(message) * 8 + 32          ,_
                    boxHeight = 84                             ,_
                    boxLeft   = (WINDOW_WIDTH  - boxWidth)  / 2,_
                    boxTop    = (WINDOW_HEIGHT - boxHeight) / 2 

    ScreenLock
    Line (boxLeft, boxTop) - (boxLeft + boxWidth, boxTop + boxHeight),_
         RGBA(&hE8, &hE8, &hD8, &hFF ), BF
    Line (boxLeft, boxTop) - (boxLeft + boxWidth, boxTop + boxHeight),_
         RGBA(&h38, &h38, &h48, &hFF ), B

    PlaceString "Game207"                 , boxTop + 12
    PlaceString "version 1.01b"           , boxTop + 24
    PlaceString "Ryan R. Kelly"           , boxTop + 36
    PlaceString "(codeFoil) 2012"         , boxTop + 48
    PlaceString  message                  , boxTop + 72
    ScreenUnlock

End  sub

private _
Sub  PlaceString(byref outText as String, byval yPos as Integer )

    Draw String ( (WINDOW_WIDTH - 8 * Len(outText))/2, yPos ), outText,_
                RGBA(&h38, &h38, &h48, &hFF )

End  sub